require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_BIGSUR_H_)) {
    eval 'sub _ASM_BIGSUR_H_ () {1;}' unless defined(&_ASM_BIGSUR_H_);
    require 'asm/irq.ph';
    require 'asm/hd64465.ph';
    eval 'sub BIGSUR_IRQ_LOW () {0;}' unless defined(&BIGSUR_IRQ_LOW);
    eval 'sub BIGSUR_IRQ_NUM () {14;}' unless defined(&BIGSUR_IRQ_NUM);
    eval 'sub BIGSUR_IRQ_HIGH () {( &BIGSUR_IRQ_LOW +  &BIGSUR_IRQ_NUM);}' unless defined(&BIGSUR_IRQ_HIGH);
    eval 'sub BIGSUR_2NDLVL_IRQ_LOW () {( &HD64465_IRQ_BASE+ &HD64465_IRQ_NUM);}' unless defined(&BIGSUR_2NDLVL_IRQ_LOW);
    eval 'sub BIGSUR_2NDLVL_IRQ_NUM () {32;}' unless defined(&BIGSUR_2NDLVL_IRQ_NUM);
    eval 'sub BIGSUR_2NDLVL_IRQ_HIGH () {( &BIGSUR_2NDLVL_IRQ_LOW +  &BIGSUR_2NDLVL_IRQ_NUM);}' unless defined(&BIGSUR_2NDLVL_IRQ_HIGH);
    eval 'sub BIGSUR_SH7751_PCI_IRQ_BASE () {( &BIGSUR_2NDLVL_IRQ_LOW+10);}' unless defined(&BIGSUR_SH7751_PCI_IRQ_BASE);
    eval 'sub BIGSUR_HD64464_ADDR () {0xb2000000;}' unless defined(&BIGSUR_HD64464_ADDR);
    eval 'sub BIGSUR_DGDR () {0xb1fffe00;}' unless defined(&BIGSUR_DGDR);
    eval 'sub BIGSUR_BIDR () {0xb1fffd00;}' unless defined(&BIGSUR_BIDR);
    eval 'sub BIGSUR_CSLR () {0xb1fffc00;}' unless defined(&BIGSUR_CSLR);
    eval 'sub BIGSUR_SW1R () {0xb1fffb00;}' unless defined(&BIGSUR_SW1R);
    eval 'sub BIGSUR_DBGR () {0xb1fffa00;}' unless defined(&BIGSUR_DBGR);
    eval 'sub BIGSUR_BDTR () {0xb1fff900;}' unless defined(&BIGSUR_BDTR);
    eval 'sub BIGSUR_BDRR () {0xb1fff800;}' unless defined(&BIGSUR_BDRR);
    eval 'sub BIGSUR_PPR1 () {0xb1fff700;}' unless defined(&BIGSUR_PPR1);
    eval 'sub BIGSUR_PPR2 () {0xb1fff600;}' unless defined(&BIGSUR_PPR2);
    eval 'sub BIGSUR_IDE2 () {0xb1fff500;}' unless defined(&BIGSUR_IDE2);
    eval 'sub BIGSUR_IDE3 () {0xb1fff400;}' unless defined(&BIGSUR_IDE3);
    eval 'sub BIGSUR_SPCR () {0xb1fff300;}' unless defined(&BIGSUR_SPCR);
    eval 'sub BIGSUR_ETHR () {0xb1fe0000;}' unless defined(&BIGSUR_ETHR);
    eval 'sub BIGSUR_PPDR () {0xb1fdff00;}' unless defined(&BIGSUR_PPDR);
    eval 'sub BIGSUR_ICTL () {0xb1fdfe00;}' unless defined(&BIGSUR_ICTL);
    eval 'sub BIGSUR_ICMD () {0xb1fdfd00;}' unless defined(&BIGSUR_ICMD);
    eval 'sub BIGSUR_DMA0 () {0xb1fdfc00;}' unless defined(&BIGSUR_DMA0);
    eval 'sub BIGSUR_DMA1 () {0xb1fdfb00;}' unless defined(&BIGSUR_DMA1);
    eval 'sub BIGSUR_IRQ0 () {0xb1fdfa00;}' unless defined(&BIGSUR_IRQ0);
    eval 'sub BIGSUR_IRQ1 () {0xb1fdf900;}' unless defined(&BIGSUR_IRQ1);
    eval 'sub BIGSUR_IRQ2 () {0xb1fdf800;}' unless defined(&BIGSUR_IRQ2);
    eval 'sub BIGSUR_IRQ3 () {0xb1fdf700;}' unless defined(&BIGSUR_IRQ3);
    eval 'sub BIGSUR_IMR0 () {0xb1fdf600;}' unless defined(&BIGSUR_IMR0);
    eval 'sub BIGSUR_IMR1 () {0xb1fdf500;}' unless defined(&BIGSUR_IMR1);
    eval 'sub BIGSUR_IMR2 () {0xb1fdf400;}' unless defined(&BIGSUR_IMR2);
    eval 'sub BIGSUR_IMR3 () {0xb1fdf300;}' unless defined(&BIGSUR_IMR3);
    eval 'sub BIGSUR_IRLMR0 () {0xb1fdf200;}' unless defined(&BIGSUR_IRLMR0);
    eval 'sub BIGSUR_IRLMR1 () {0xb1fdf100;}' unless defined(&BIGSUR_IRLMR1);
    eval 'sub BIGSUR_V320USC_ADDR () {0xb1000000;}' unless defined(&BIGSUR_V320USC_ADDR);
    eval 'sub BIGSUR_HD64465_ADDR () {0xb0000000;}' unless defined(&BIGSUR_HD64465_ADDR);
    eval 'sub BIGSUR_INTERNAL_BASE () {0xb0000000;}' unless defined(&BIGSUR_INTERNAL_BASE);
    eval 'sub BIGSUR_ETHER_IOPORT () {0x220;}' unless defined(&BIGSUR_ETHER_IOPORT);
    eval 'sub BIGSUR_IDECMD_IOPORT () {0x1f0;}' unless defined(&BIGSUR_IDECMD_IOPORT);
    eval 'sub BIGSUR_IDECTL_IOPORT () {0x1f8;}' unless defined(&BIGSUR_IDECTL_IOPORT);
    eval 'sub BIGSUR_LED () {(1<<4);}' unless defined(&BIGSUR_LED);
    eval 'sub BIGSUR_LSR0_SIZE () {(64*(1<<20));}' unless defined(&BIGSUR_LSR0_SIZE);
    eval 'sub BIGSUR_LSR1_SIZE () {(64*(1<<20));}' unless defined(&BIGSUR_LSR1_SIZE);
}
1;
