require '_h2ph_pre.ph';

no warnings 'redefine';

require 'asm/irq.ph';
unless(defined(&HW_EVENT_IRQ_BASE)) {
    sub HW_EVENT_IRQ_BASE () {	 &OFFCHIP_IRQ_BASE;}
}
unless(defined(&HW_EVENT_VSYNC)) {
    sub HW_EVENT_VSYNC () {	( &HW_EVENT_IRQ_BASE + 5);}
}
unless(defined(&HW_EVENT_MAPLE_DMA)) {
    sub HW_EVENT_MAPLE_DMA () {	( &HW_EVENT_IRQ_BASE + 12);}
}
unless(defined(&HW_EVENT_GDROM_DMA)) {
    sub HW_EVENT_GDROM_DMA () {	( &HW_EVENT_IRQ_BASE + 14);}
}
unless(defined(&HW_EVENT_GDROM_CMD)) {
    sub HW_EVENT_GDROM_CMD () {	( &HW_EVENT_IRQ_BASE + 32);}
}
unless(defined(&HW_EVENT_AICA_SYS)) {
    sub HW_EVENT_AICA_SYS () {	( &HW_EVENT_IRQ_BASE + 33);}
}
unless(defined(&HW_EVENT_EXTERNAL)) {
    sub HW_EVENT_EXTERNAL () {	( &HW_EVENT_IRQ_BASE + 35);}
}
unless(defined(&HW_EVENT_IRQ_MAX)) {
    sub HW_EVENT_IRQ_MAX () {	( &HW_EVENT_IRQ_BASE + 95);}
}
1;
