require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_DMA_H)) {
    eval 'sub __ASM_SH_DMA_H () {1;}' unless defined(&__ASM_SH_DMA_H);
    require 'linux/config.ph';
    require 'asm/io.ph';
    eval 'sub MAX_DMA_CHANNELS () {8;}' unless defined(&MAX_DMA_CHANNELS);
    eval 'sub SH_MAX_DMA_CHANNELS () {4;}' unless defined(&SH_MAX_DMA_CHANNELS);
    eval 'sub MAX_DMA_ADDRESS () {( &PAGE_OFFSET+0x10000000);}' unless defined(&MAX_DMA_ADDRESS);
    if(defined( &__sh3__)) {
	eval 'sub SAR () {((\'unsigned long\'[]){0xa4000020,0xa4000030,0xa4000040,0xa4000050});}' unless defined(&SAR);
	eval 'sub DAR () {((\'unsigned long\'[]){0xa4000024,0xa4000034,0xa4000044,0xa4000054});}' unless defined(&DAR);
	eval 'sub DMATCR () {((\'unsigned long\'[]){0xa4000028,0xa4000038,0xa4000048,0xa4000058});}' unless defined(&DMATCR);
	eval 'sub CHCR () {((\'unsigned long\'[]){0xa400002c,0xa400003c,0xa400004c,0xa400005c});}' unless defined(&CHCR);
	eval 'sub DMAOR () {0xa4000060;}' unless defined(&DMAOR);
    }
 elsif(defined( &__SH4__)) {
	eval 'sub SAR () {((\'unsigned long\'[]){0xbfa00000,0xbfa00010,0xbfa00020,0xbfa00030});}' unless defined(&SAR);
	eval 'sub DAR () {((\'unsigned long\'[]){0xbfa00004,0xbfa00014,0xbfa00024,0xbfa00034});}' unless defined(&DAR);
	eval 'sub DMATCR () {((\'unsigned long\'[]){0xbfa00008,0xbfa00018,0xbfa00028,0xbfa00038});}' unless defined(&DMATCR);
	eval 'sub CHCR () {((\'unsigned long\'[]){0xbfa0000c,0xbfa0001c,0xbfa0002c,0xbfa0003c});}' unless defined(&CHCR);
	eval 'sub DMAOR () {0xbfa00040;}' unless defined(&DMAOR);
    }
    eval 'sub DMTE_IRQ () {((\'int\'[]){ &DMTE0_IRQ, &DMTE1_IRQ, &DMTE2_IRQ, &DMTE3_IRQ});}' unless defined(&DMTE_IRQ);
    eval 'sub DMA_MODE_READ () {0x;}' unless defined(&DMA_MODE_READ);
    eval 'sub DMA_MODE_WRITE () {0x1;}' unless defined(&DMA_MODE_WRITE);
    eval 'sub DMA_AUTOINIT () {0x10;}' unless defined(&DMA_AUTOINIT);
    eval 'sub REQ_L () {0x;}' unless defined(&REQ_L);
    eval 'sub REQ_E () {0x80000;}' unless defined(&REQ_E);
    eval 'sub RACK_H () {0x;}' unless defined(&RACK_H);
    eval 'sub RACK_L () {0x40000;}' unless defined(&RACK_L);
    eval 'sub ACK_R () {0x;}' unless defined(&ACK_R);
    eval 'sub ACK_W () {0x20000;}' unless defined(&ACK_W);
    eval 'sub ACK_H () {0x;}' unless defined(&ACK_H);
    eval 'sub ACK_L () {0x10000;}' unless defined(&ACK_L);
    eval 'sub DM_INC () {0x4000;}' unless defined(&DM_INC);
    eval 'sub DM_DEC () {0x8000;}' unless defined(&DM_DEC);
    eval 'sub SM_INC () {0x1000;}' unless defined(&SM_INC);
    eval 'sub SM_DEC () {0x2000;}' unless defined(&SM_DEC);
    eval 'sub RS_DUAL () {0x;}' unless defined(&RS_DUAL);
    eval 'sub RS_IN () {0x200;}' unless defined(&RS_IN);
    eval 'sub RS_OUT () {0x300;}' unless defined(&RS_OUT);
    eval 'sub TM_BURST () {0x80;}' unless defined(&TM_BURST);
    eval 'sub TS_8 () {0x10;}' unless defined(&TS_8);
    eval 'sub TS_16 () {0x20;}' unless defined(&TS_16);
    eval 'sub TS_32 () {0x30;}' unless defined(&TS_32);
    eval 'sub TS_64 () {0x;}' unless defined(&TS_64);
    eval 'sub TS_BLK () {0x40;}' unless defined(&TS_BLK);
    eval 'sub CHCR_DE () {0x1;}' unless defined(&CHCR_DE);
    eval 'sub CHCR_TE () {0x2;}' unless defined(&CHCR_TE);
    eval 'sub CHCR_IE () {0x4;}' unless defined(&CHCR_IE);
    eval 'sub DMAOR_COD () {0x8;}' unless defined(&DMAOR_COD);
    eval 'sub DMAOR_AE () {0x4;}' unless defined(&DMAOR_AE);
    eval 'sub DMAOR_NMIF () {0x2;}' unless defined(&DMAOR_NMIF);
    eval 'sub DMAOR_DME () {0x1;}' unless defined(&DMAOR_DME);
    if(defined(&CONFIG_PCI)) {
    } else {
	eval 'sub isa_dma_bridge_buggy () {(0);}' unless defined(&isa_dma_bridge_buggy);
    }
}
1;
