require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_HARDIRQ_H)) {
    eval 'sub __ASM_SH_HARDIRQ_H () {1;}' unless defined(&__ASM_SH_HARDIRQ_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'linux/irq_cpustat.ph';
    eval 'sub in_interrupt () {
        eval q(({ \'int\'  &__cpu =  &smp_processor_id(); ( &local_irq_count( &__cpu) +  &local_bh_count( &__cpu) != 0); }));
    }' unless defined(&in_interrupt);
    eval 'sub in_irq () {
        eval q(( &local_irq_count( &smp_processor_id()) != 0));
    }' unless defined(&in_irq);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub hardirq_trylock {
	    my($cpu) = @_;
    	    eval q(( &local_irq_count($cpu) == 0));
	}' unless defined(&hardirq_trylock);
	eval 'sub hardirq_endlock {
	    my($cpu) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&hardirq_endlock);
	eval 'sub irq_enter {
	    my($cpu, $irq) = @_;
    	    eval q(( &local_irq_count($cpu)++));
	}' unless defined(&irq_enter);
	eval 'sub irq_exit {
	    my($cpu, $irq) = @_;
    	    eval q(( &local_irq_count($cpu)--));
	}' unless defined(&irq_exit);
	eval 'sub synchronize_irq () {
	    eval q( &barrier());
	}' unless defined(&synchronize_irq);
    } else {
	die("Super\-H\ SMP\ is\ not\ available");
    }
}
1;
