require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SH_HD64465_)) {
    eval 'sub _ASM_SH_HD64465_ () {1;}' unless defined(&_ASM_SH_HD64465_);
    require 'linux/config.ph';
    require 'asm/io.ph';
    require 'asm/irq.ph';
    eval 'sub HD64465_REG_SRR () {0x1000c;}' unless defined(&HD64465_REG_SRR);
    eval 'sub HD64465_REG_SDID () {0x10010;}' unless defined(&HD64465_REG_SDID);
    eval 'sub HD64465_SDID () {0x8122;}' unless defined(&HD64465_SDID);
    eval 'sub HD64465_REG_SMSCR () {0x10000;}' unless defined(&HD64465_REG_SMSCR);
    eval 'sub HD64465_SMSCR_PS2ST () {0x4000;}' unless defined(&HD64465_SMSCR_PS2ST);
    eval 'sub HD64465_SMSCR_ADCST () {0x1000;}' unless defined(&HD64465_SMSCR_ADCST);
    eval 'sub HD64465_SMSCR_UARTST () {0x800;}' unless defined(&HD64465_SMSCR_UARTST);
    eval 'sub HD64465_SMSCR_SCDIST () {0x200;}' unless defined(&HD64465_SMSCR_SCDIST);
    eval 'sub HD64465_SMSCR_PPST () {0x100;}' unless defined(&HD64465_SMSCR_PPST);
    eval 'sub HD64465_SMSCR_PC0ST () {0x40;}' unless defined(&HD64465_SMSCR_PC0ST);
    eval 'sub HD64465_SMSCR_PC1ST () {0x20;}' unless defined(&HD64465_SMSCR_PC1ST);
    eval 'sub HD64465_SMSCR_AFEST () {0x10;}' unless defined(&HD64465_SMSCR_AFEST);
    eval 'sub HD64465_SMSCR_TM0ST () {0x8;}' unless defined(&HD64465_SMSCR_TM0ST);
    eval 'sub HD64465_SMSCR_TM1ST () {0x4;}' unless defined(&HD64465_SMSCR_TM1ST);
    eval 'sub HD64465_SMSCR_IRDAST () {0x2;}' unless defined(&HD64465_SMSCR_IRDAST);
    eval 'sub HD64465_SMSCR_KBCST () {0x1;}' unless defined(&HD64465_SMSCR_KBCST);
    eval 'sub HD64465_REG_NIRR () {0x15000;}' unless defined(&HD64465_REG_NIRR);
    eval 'sub HD64465_REG_NIMR () {0x15002;}' unless defined(&HD64465_REG_NIMR);
    eval 'sub HD64465_REG_NITR () {0x15004;}' unless defined(&HD64465_REG_NITR);
    eval 'sub HD64465_REG_TCVR1 () {0x16000;}' unless defined(&HD64465_REG_TCVR1);
    eval 'sub HD64465_REG_TCVR0 () {0x16002;}' unless defined(&HD64465_REG_TCVR0);
    eval 'sub HD64465_REG_TRVR1 () {0x16004;}' unless defined(&HD64465_REG_TRVR1);
    eval 'sub HD64465_REG_TRVR0 () {0x16006;}' unless defined(&HD64465_REG_TRVR0);
    eval 'sub HD64465_REG_TCR1 () {0x16008;}' unless defined(&HD64465_REG_TCR1);
    eval 'sub HD64465_REG_TCR0 () {0x1600a;}' unless defined(&HD64465_REG_TCR0);
    eval 'sub HD64465_TCR_EADT () {0x10;}' unless defined(&HD64465_TCR_EADT);
    eval 'sub HD64465_TCR_ETMO () {0x8;}' unless defined(&HD64465_TCR_ETMO);
    eval 'sub HD64465_TCR_PST_MASK () {0x6;}' unless defined(&HD64465_TCR_PST_MASK);
    eval 'sub HD64465_TCR_PST_1 () {0x6;}' unless defined(&HD64465_TCR_PST_1);
    eval 'sub HD64465_TCR_PST_4 () {0x4;}' unless defined(&HD64465_TCR_PST_4);
    eval 'sub HD64465_TCR_PST_8 () {0x2;}' unless defined(&HD64465_TCR_PST_8);
    eval 'sub HD64465_TCR_PST_16 () {0x;}' unless defined(&HD64465_TCR_PST_16);
    eval 'sub HD64465_TCR_TSTP () {0x1;}' unless defined(&HD64465_TCR_TSTP);
    eval 'sub HD64465_REG_TIRR () {0x1600c;}' unless defined(&HD64465_REG_TIRR);
    eval 'sub HD64465_REG_TIDR () {0x1600e;}' unless defined(&HD64465_REG_TIDR);
    eval 'sub HD64465_REG_PWM1CS () {0x16010;}' unless defined(&HD64465_REG_PWM1CS);
    eval 'sub HD64465_REG_PWM1LPC () {0x16012;}' unless defined(&HD64465_REG_PWM1LPC);
    eval 'sub HD64465_REG_PWM1HPC () {0x16014;}' unless defined(&HD64465_REG_PWM1HPC);
    eval 'sub HD64465_REG_PWM0CS () {0x16018;}' unless defined(&HD64465_REG_PWM0CS);
    eval 'sub HD64465_REG_PWM0LPC () {0x1601a;}' unless defined(&HD64465_REG_PWM0LPC);
    eval 'sub HD64465_REG_PWM0HPC () {0x1601c;}' unless defined(&HD64465_REG_PWM0HPC);
    eval 'sub HD64465_REG_ADDRA () {0x1e000;}' unless defined(&HD64465_REG_ADDRA);
    eval 'sub HD64465_REG_ADDRB () {0x1e002;}' unless defined(&HD64465_REG_ADDRB);
    eval 'sub HD64465_REG_ADDRC () {0x1e004;}' unless defined(&HD64465_REG_ADDRC);
    eval 'sub HD64465_REG_ADDRD () {0x1e006;}' unless defined(&HD64465_REG_ADDRD);
    eval 'sub HD64465_REG_ADCSR () {0x1e008;}' unless defined(&HD64465_REG_ADCSR);
    eval 'sub HD64465_ADCSR_ADF () {0x80;}' unless defined(&HD64465_ADCSR_ADF);
    eval 'sub HD64465_ADCSR_ADST () {0x40;}' unless defined(&HD64465_ADCSR_ADST);
    eval 'sub HD64465_ADCSR_ADIS () {0x20;}' unless defined(&HD64465_ADCSR_ADIS);
    eval 'sub HD64465_ADCSR_TRGE () {0x10;}' unless defined(&HD64465_ADCSR_TRGE);
    eval 'sub HD64465_ADCSR_ADIE () {0x8;}' unless defined(&HD64465_ADCSR_ADIE);
    eval 'sub HD64465_ADCSR_SCAN () {0x4;}' unless defined(&HD64465_ADCSR_SCAN);
    eval 'sub HD64465_ADCSR_CH_MASK () {0x3;}' unless defined(&HD64465_ADCSR_CH_MASK);
    eval 'sub HD64465_REG_ADCALCR () {0x1e00a;}' unless defined(&HD64465_REG_ADCALCR);
    eval 'sub HD64465_REG_ADCAL () {0x1e00c;}' unless defined(&HD64465_REG_ADCAL);
    eval 'sub HD64465_REG_GPACR () {0x14000;}' unless defined(&HD64465_REG_GPACR);
    eval 'sub HD64465_REG_GPBCR () {0x14002;}' unless defined(&HD64465_REG_GPBCR);
    eval 'sub HD64465_REG_GPCCR () {0x14004;}' unless defined(&HD64465_REG_GPCCR);
    eval 'sub HD64465_REG_GPDCR () {0x14006;}' unless defined(&HD64465_REG_GPDCR);
    eval 'sub HD64465_REG_GPECR () {0x14008;}' unless defined(&HD64465_REG_GPECR);
    eval 'sub HD64465_REG_GPADR () {0x14010;}' unless defined(&HD64465_REG_GPADR);
    eval 'sub HD64465_REG_GPBDR () {0x14012;}' unless defined(&HD64465_REG_GPBDR);
    eval 'sub HD64465_REG_GPCDR () {0x14014;}' unless defined(&HD64465_REG_GPCDR);
    eval 'sub HD64465_REG_GPDDR () {0x14016;}' unless defined(&HD64465_REG_GPDDR);
    eval 'sub HD64465_REG_GPEDR () {0x14018;}' unless defined(&HD64465_REG_GPEDR);
    eval 'sub HD64465_REG_GPAICR () {0x14020;}' unless defined(&HD64465_REG_GPAICR);
    eval 'sub HD64465_REG_GPBICR () {0x14022;}' unless defined(&HD64465_REG_GPBICR);
    eval 'sub HD64465_REG_GPCICR () {0x14024;}' unless defined(&HD64465_REG_GPCICR);
    eval 'sub HD64465_REG_GPDICR () {0x14026;}' unless defined(&HD64465_REG_GPDICR);
    eval 'sub HD64465_REG_GPEICR () {0x14028;}' unless defined(&HD64465_REG_GPEICR);
    eval 'sub HD64465_REG_GPAISR () {0x14040;}' unless defined(&HD64465_REG_GPAISR);
    eval 'sub HD64465_REG_GPBISR () {0x14042;}' unless defined(&HD64465_REG_GPBISR);
    eval 'sub HD64465_REG_GPCISR () {0x14044;}' unless defined(&HD64465_REG_GPCISR);
    eval 'sub HD64465_REG_GPDISR () {0x14046;}' unless defined(&HD64465_REG_GPDISR);
    eval 'sub HD64465_REG_GPEISR () {0x14048;}' unless defined(&HD64465_REG_GPEISR);
    eval 'sub HD64465_REG_PCC0ISR () {0x12000;}' unless defined(&HD64465_REG_PCC0ISR);
    eval 'sub HD64465_PCCISR_PREADY () {0x80;}' unless defined(&HD64465_PCCISR_PREADY);
    eval 'sub HD64465_PCCISR_PIREQ () {0x80;}' unless defined(&HD64465_PCCISR_PIREQ);
    eval 'sub HD64465_PCCISR_PMWP () {0x40;}' unless defined(&HD64465_PCCISR_PMWP);
    eval 'sub HD64465_PCCISR_PVS2 () {0x20;}' unless defined(&HD64465_PCCISR_PVS2);
    eval 'sub HD64465_PCCISR_PVS1 () {0x10;}' unless defined(&HD64465_PCCISR_PVS1);
    eval 'sub HD64465_PCCISR_PCD_MASK () {0xc;}' unless defined(&HD64465_PCCISR_PCD_MASK);
    eval 'sub HD64465_PCCISR_PBVD_MASK () {0x3;}' unless defined(&HD64465_PCCISR_PBVD_MASK);
    eval 'sub HD64465_PCCISR_PBVD_BATGOOD () {0x3;}' unless defined(&HD64465_PCCISR_PBVD_BATGOOD);
    eval 'sub HD64465_PCCISR_PBVD_BATWARN () {0x1;}' unless defined(&HD64465_PCCISR_PBVD_BATWARN);
    eval 'sub HD64465_PCCISR_PBVD_BATDEAD1 () {0x2;}' unless defined(&HD64465_PCCISR_PBVD_BATDEAD1);
    eval 'sub HD64465_PCCISR_PBVD_BATDEAD2 () {0x;}' unless defined(&HD64465_PCCISR_PBVD_BATDEAD2);
    eval 'sub HD64465_REG_PCC0GCR () {0x12002;}' unless defined(&HD64465_REG_PCC0GCR);
    eval 'sub HD64465_PCCGCR_PDRV () {0x80;}' unless defined(&HD64465_PCCGCR_PDRV);
    eval 'sub HD64465_PCCGCR_PCCR () {0x40;}' unless defined(&HD64465_PCCGCR_PCCR);
    eval 'sub HD64465_PCCGCR_PCCT () {0x20;}' unless defined(&HD64465_PCCGCR_PCCT);
    eval 'sub HD64465_PCCGCR_PVCC0 () {0x10;}' unless defined(&HD64465_PCCGCR_PVCC0);
    eval 'sub HD64465_PCCGCR_PMMOD () {0x8;}' unless defined(&HD64465_PCCGCR_PMMOD);
    eval 'sub HD64465_PCCGCR_PPA25 () {0x4;}' unless defined(&HD64465_PCCGCR_PPA25);
    eval 'sub HD64465_PCCGCR_PPA24 () {0x2;}' unless defined(&HD64465_PCCGCR_PPA24);
    eval 'sub HD64465_PCCGCR_PREG () {0x1;}' unless defined(&HD64465_PCCGCR_PREG);
    eval 'sub HD64465_REG_PCC0CSCR () {0x12004;}' unless defined(&HD64465_REG_PCC0CSCR);
    eval 'sub HD64465_PCCCSCR_PSCDI () {0x80;}' unless defined(&HD64465_PCCCSCR_PSCDI);
    eval 'sub HD64465_PCCCSCR_PSWSEL () {0x40;}' unless defined(&HD64465_PCCCSCR_PSWSEL);
    eval 'sub HD64465_PCCCSCR_PIREQ () {0x20;}' unless defined(&HD64465_PCCCSCR_PIREQ);
    eval 'sub HD64465_PCCCSCR_PSC () {0x10;}' unless defined(&HD64465_PCCCSCR_PSC);
    eval 'sub HD64465_PCCCSCR_PCDC () {0x8;}' unless defined(&HD64465_PCCCSCR_PCDC);
    eval 'sub HD64465_PCCCSCR_PRC () {0x4;}' unless defined(&HD64465_PCCCSCR_PRC);
    eval 'sub HD64465_PCCCSCR_PBW () {0x2;}' unless defined(&HD64465_PCCCSCR_PBW);
    eval 'sub HD64465_PCCCSCR_PBD () {0x1;}' unless defined(&HD64465_PCCCSCR_PBD);
    eval 'sub HD64465_REG_PCC0CSCIER () {0x12006;}' unless defined(&HD64465_REG_PCC0CSCIER);
    eval 'sub HD64465_PCCCSCIER_PCRE () {0x80;}' unless defined(&HD64465_PCCCSCIER_PCRE);
    eval 'sub HD64465_PCCCSCIER_PIREQE_MASK () {0x60;}' unless defined(&HD64465_PCCCSCIER_PIREQE_MASK);
    eval 'sub HD64465_PCCCSCIER_PIREQE_DISABLED () {0x;}' unless defined(&HD64465_PCCCSCIER_PIREQE_DISABLED);
    eval 'sub HD64465_PCCCSCIER_PIREQE_LEVEL () {0x20;}' unless defined(&HD64465_PCCCSCIER_PIREQE_LEVEL);
    eval 'sub HD64465_PCCCSCIER_PIREQE_FALLING () {0x40;}' unless defined(&HD64465_PCCCSCIER_PIREQE_FALLING);
    eval 'sub HD64465_PCCCSCIER_PIREQE_RISING () {0x60;}' unless defined(&HD64465_PCCCSCIER_PIREQE_RISING);
    eval 'sub HD64465_PCCCSCIER_PSCE () {0x10;}' unless defined(&HD64465_PCCCSCIER_PSCE);
    eval 'sub HD64465_PCCCSCIER_PCDE () {0x8;}' unless defined(&HD64465_PCCCSCIER_PCDE);
    eval 'sub HD64465_PCCCSCIER_PRE () {0x4;}' unless defined(&HD64465_PCCCSCIER_PRE);
    eval 'sub HD64465_PCCCSCIER_PBWE () {0x2;}' unless defined(&HD64465_PCCCSCIER_PBWE);
    eval 'sub HD64465_PCCCSCIER_PBDE () {0x1;}' unless defined(&HD64465_PCCCSCIER_PBDE);
    eval 'sub HD64465_REG_PCC0SCR () {0x12008;}' unless defined(&HD64465_REG_PCC0SCR);
    eval 'sub HD64465_PCCSCR_SHDN () {0x10;}' unless defined(&HD64465_PCCSCR_SHDN);
    eval 'sub HD64465_PCCSCR_SWP () {0x1;}' unless defined(&HD64465_PCCSCR_SWP);
    eval 'sub HD64465_REG_PCCPSR () {0x1200a;}' unless defined(&HD64465_REG_PCCPSR);
    eval 'sub HD64465_REG_PCC1ISR () {0x12010;}' unless defined(&HD64465_REG_PCC1ISR);
    eval 'sub HD64465_REG_PCC1GCR () {0x12012;}' unless defined(&HD64465_REG_PCC1GCR);
    eval 'sub HD64465_REG_PCC1CSCR () {0x12014;}' unless defined(&HD64465_REG_PCC1CSCR);
    eval 'sub HD64465_REG_PCC1CSCIER () {0x12016;}' unless defined(&HD64465_REG_PCC1CSCIER);
    eval 'sub HD64465_REG_PCC1SCR () {0x12018;}' unless defined(&HD64465_REG_PCC1SCR);
    eval 'sub HD64465_REG_KBCSR () {0x1dc00;}' unless defined(&HD64465_REG_KBCSR);
    eval 'sub HD64465_KBCSR_KBCIE () {0x8000;}' unless defined(&HD64465_KBCSR_KBCIE);
    eval 'sub HD64465_KBCSR_KBCOE () {0x4000;}' unless defined(&HD64465_KBCSR_KBCOE);
    eval 'sub HD64465_KBCSR_KBDOE () {0x2000;}' unless defined(&HD64465_KBCSR_KBDOE);
    eval 'sub HD64465_KBCSR_KBCD () {0x1000;}' unless defined(&HD64465_KBCSR_KBCD);
    eval 'sub HD64465_KBCSR_KBDD () {0x800;}' unless defined(&HD64465_KBCSR_KBDD);
    eval 'sub HD64465_KBCSR_KBCS () {0x400;}' unless defined(&HD64465_KBCSR_KBCS);
    eval 'sub HD64465_KBCSR_KBDS () {0x200;}' unless defined(&HD64465_KBCSR_KBDS);
    eval 'sub HD64465_KBCSR_KBDP () {0x100;}' unless defined(&HD64465_KBCSR_KBDP);
    eval 'sub HD64465_KBCSR_KBD_MASK () {0xff;}' unless defined(&HD64465_KBCSR_KBD_MASK);
    eval 'sub HD64465_REG_KBISR () {0x1dc04;}' unless defined(&HD64465_REG_KBISR);
    eval 'sub HD64465_KBISR_KBRDF () {0x1;}' unless defined(&HD64465_KBISR_KBRDF);
    eval 'sub HD64465_REG_MSCSR () {0x1dc10;}' unless defined(&HD64465_REG_MSCSR);
    eval 'sub HD64465_REG_MSISR () {0x1dc14;}' unless defined(&HD64465_REG_MSISR);
    unless(defined(&CONFIG_HD64465_IOBASE)) {
	eval 'sub CONFIG_HD64465_IOBASE () {0xb0000000;}' unless defined(&CONFIG_HD64465_IOBASE);
    }
    unless(defined(&CONFIG_HD64465_IRQ)) {
	eval 'sub CONFIG_HD64465_IRQ () {5;}' unless defined(&CONFIG_HD64465_IRQ);
    }
    eval 'sub _HD64465_IO_MASK () {0xf8000000;}' unless defined(&_HD64465_IO_MASK);
    eval 'sub is_hd64465_addr {
        my($addr) = @_;
	    eval q((($addr &  &_HD64465_IO_MASK) == ( &CONFIG_HD64465_IOBASE &  &_HD64465_IO_MASK)));
    }' unless defined(&is_hd64465_addr);
    eval 'sub HD64465_IRQ_BASE () { &OFFCHIP_IRQ_BASE;}' unless defined(&HD64465_IRQ_BASE);
    eval 'sub HD64465_IRQ_NUM () {16;}' unless defined(&HD64465_IRQ_NUM);
    eval 'sub HD64465_IRQ_ADC () {( &HD64465_IRQ_BASE+0);}' unless defined(&HD64465_IRQ_ADC);
    eval 'sub HD64465_IRQ_USB () {( &HD64465_IRQ_BASE+1);}' unless defined(&HD64465_IRQ_USB);
    eval 'sub HD64465_IRQ_SCDI () {( &HD64465_IRQ_BASE+2);}' unless defined(&HD64465_IRQ_SCDI);
    eval 'sub HD64465_IRQ_PARALLEL () {( &HD64465_IRQ_BASE+3);}' unless defined(&HD64465_IRQ_PARALLEL);
    eval 'sub HD64465_IRQ_UART () {( &HD64465_IRQ_BASE+5);}' unless defined(&HD64465_IRQ_UART);
    eval 'sub HD64465_IRQ_IRDA () {( &HD64465_IRQ_BASE+6);}' unless defined(&HD64465_IRQ_IRDA);
    eval 'sub HD64465_IRQ_PS2MOUSE () {( &HD64465_IRQ_BASE+7);}' unless defined(&HD64465_IRQ_PS2MOUSE);
    eval 'sub HD64465_IRQ_KBC () {( &HD64465_IRQ_BASE+8);}' unless defined(&HD64465_IRQ_KBC);
    eval 'sub HD64465_IRQ_TIMER1 () {( &HD64465_IRQ_BASE+9);}' unless defined(&HD64465_IRQ_TIMER1);
    eval 'sub HD64465_IRQ_TIMER0 () {( &HD64465_IRQ_BASE+10);}' unless defined(&HD64465_IRQ_TIMER0);
    eval 'sub HD64465_IRQ_GPIO () {( &HD64465_IRQ_BASE+11);}' unless defined(&HD64465_IRQ_GPIO);
    eval 'sub HD64465_IRQ_AFE () {( &HD64465_IRQ_BASE+12);}' unless defined(&HD64465_IRQ_AFE);
    eval 'sub HD64465_IRQ_PCMCIA1 () {( &HD64465_IRQ_BASE+13);}' unless defined(&HD64465_IRQ_PCMCIA1);
    eval 'sub HD64465_IRQ_PCMCIA0 () {( &HD64465_IRQ_BASE+14);}' unless defined(&HD64465_IRQ_PCMCIA0);
    eval 'sub HD64465_IRQ_PS2KBD () {( &HD64465_IRQ_BASE+15);}' unless defined(&HD64465_IRQ_PS2KBD);
    eval 'sub HD64465_PCC_WINDOW () {0x1000000;}' unless defined(&HD64465_PCC_WINDOW);
    eval 'sub HD64465_PCC0_BASE () {0xb8000000;}' unless defined(&HD64465_PCC0_BASE);
    eval 'sub HD64465_PCC0_ATTR () {( &HD64465_PCC0_BASE);}' unless defined(&HD64465_PCC0_ATTR);
    eval 'sub HD64465_PCC0_COMM () {( &HD64465_PCC0_BASE+ &HD64465_PCC_WINDOW);}' unless defined(&HD64465_PCC0_COMM);
    eval 'sub HD64465_PCC0_IO () {( &HD64465_PCC0_BASE+2* &HD64465_PCC_WINDOW);}' unless defined(&HD64465_PCC0_IO);
    eval 'sub HD64465_PCC1_BASE () {0xb4000000;}' unless defined(&HD64465_PCC1_BASE);
    eval 'sub HD64465_PCC1_ATTR () {( &HD64465_PCC1_BASE);}' unless defined(&HD64465_PCC1_ATTR);
    eval 'sub HD64465_PCC1_COMM () {( &HD64465_PCC1_BASE+ &HD64465_PCC_WINDOW);}' unless defined(&HD64465_PCC1_COMM);
    eval 'sub HD64465_PCC1_IO () {( &HD64465_PCC1_BASE+2* &HD64465_PCC_WINDOW);}' unless defined(&HD64465_PCC1_IO);
    eval 'sub HD64465_USB_BASE () {( &CONFIG_HD64465_IOBASE+0xb000);}' unless defined(&HD64465_USB_BASE);
    eval 'sub HD64465_USB_LEN () {0x1000;}' unless defined(&HD64465_USB_LEN);
    eval 'sub HD64465_SRAM_BASE () {( &CONFIG_HD64465_IOBASE+0x9000);}' unless defined(&HD64465_SRAM_BASE);
    eval 'sub HD64465_SRAM_LEN () {0x1000;}' unless defined(&HD64465_SRAM_LEN);
}
1;
