require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_IO_H)) {
    eval 'sub __ASM_SH_IO_H () {1;}' unless defined(&__ASM_SH_IO_H);
    require 'asm/cache.ph';
    require 'asm/system.ph';
    require 'linux/config.ph';
    if(defined(&__KERNEL__)) {
	if(defined( &CONFIG_SH_GENERIC) || defined( &CONFIG_SH_CQREEK) || defined( &CONFIG_SH_UNKNOWN)) {
	    require 'asm/machvec.ph';
	    eval 'sub __inb {
	        my($p) = @_;
    		eval q( ($sh_mv->{mv_inb})(($p)));
	    }' unless defined(&__inb);
	    eval 'sub __inw {
	        my($p) = @_;
    		eval q( ($sh_mv->{mv_inw})(($p)));
	    }' unless defined(&__inw);
	    eval 'sub __inl {
	        my($p) = @_;
    		eval q( ($sh_mv->{mv_inl})(($p)));
	    }' unless defined(&__inl);
	    eval 'sub __outb {
	        my($x,$p) = @_;
    		eval q( ($sh_mv->{mv_outb})(($x),($p)));
	    }' unless defined(&__outb);
	    eval 'sub __outw {
	        my($x,$p) = @_;
    		eval q( ($sh_mv->{mv_outw})(($x),($p)));
	    }' unless defined(&__outw);
	    eval 'sub __outl {
	        my($x,$p) = @_;
    		eval q( ($sh_mv->{mv_outl})(($x),($p)));
	    }' unless defined(&__outl);
	    eval 'sub __inb_p {
	        my($p) = @_;
    		eval q( ($sh_mv->{mv_inb_p})(($p)));
	    }' unless defined(&__inb_p);
	    eval 'sub __inw_p {
	        my($p) = @_;
    		eval q( ($sh_mv->{mv_inw_p})(($p)));
	    }' unless defined(&__inw_p);
	    eval 'sub __inl_p {
	        my($p) = @_;
    		eval q( ($sh_mv->{mv_inl_p})(($p)));
	    }' unless defined(&__inl_p);
	    eval 'sub __outb_p {
	        my($x,$p) = @_;
    		eval q( ($sh_mv->{mv_outb_p})(($x),($p)));
	    }' unless defined(&__outb_p);
	    eval 'sub __outw_p {
	        my($x,$p) = @_;
    		eval q( ($sh_mv->{mv_outw_p})(($x),($p)));
	    }' unless defined(&__outw_p);
	    eval 'sub __outl_p {
	        my($x,$p) = @_;
    		eval q( ($sh_mv->{mv_outl_p})(($x),($p)));
	    }' unless defined(&__outl_p);
	    eval 'sub __insb {
	        my($p,$b,$c) = @_;
    		eval q( ($sh_mv->{mv_insb})(($p), ($b), ($c)));
	    }' unless defined(&__insb);
	    eval 'sub __insw {
	        my($p,$b,$c) = @_;
    		eval q( ($sh_mv->{mv_insw})(($p), ($b), ($c)));
	    }' unless defined(&__insw);
	    eval 'sub __insl {
	        my($p,$b,$c) = @_;
    		eval q( ($sh_mv->{mv_insl})(($p), ($b), ($c)));
	    }' unless defined(&__insl);
	    eval 'sub __outsb {
	        my($p,$b,$c) = @_;
    		eval q( ($sh_mv->{mv_outsb})(($p), ($b), ($c)));
	    }' unless defined(&__outsb);
	    eval 'sub __outsw {
	        my($p,$b,$c) = @_;
    		eval q( ($sh_mv->{mv_outsw})(($p), ($b), ($c)));
	    }' unless defined(&__outsw);
	    eval 'sub __outsl {
	        my($p,$b,$c) = @_;
    		eval q( ($sh_mv->{mv_outsl})(($p), ($b), ($c)));
	    }' unless defined(&__outsl);
	    eval 'sub __readb {
	        my($a) = @_;
    		eval q( ($sh_mv->{mv_readb})(($a)));
	    }' unless defined(&__readb);
	    eval 'sub __readw {
	        my($a) = @_;
    		eval q( ($sh_mv->{mv_readw})(($a)));
	    }' unless defined(&__readw);
	    eval 'sub __readl {
	        my($a) = @_;
    		eval q( ($sh_mv->{mv_readl})(($a)));
	    }' unless defined(&__readl);
	    eval 'sub __writeb {
	        my($v,$a) = @_;
    		eval q( ($sh_mv->{m$v_writeb})(($v),($a)));
	    }' unless defined(&__writeb);
	    eval 'sub __writew {
	        my($v,$a) = @_;
    		eval q( ($sh_mv->{m$v_writew})(($v),($a)));
	    }' unless defined(&__writew);
	    eval 'sub __writel {
	        my($v,$a) = @_;
    		eval q( ($sh_mv->{m$v_writel})(($v),($a)));
	    }' unless defined(&__writel);
	    eval 'sub __ioremap {
	        my($a,$s) = @_;
    		eval q( ($sh_mv->{mv_ioremap})(($a), ($s)));
	    }' unless defined(&__ioremap);
	    eval 'sub __iounmap {
	        my($a) = @_;
    		eval q( ($sh_mv->{mv_iounmap})(($a)));
	    }' unless defined(&__iounmap);
	    eval 'sub __isa_port2addr {
	        my($a) = @_;
    		eval q( ($sh_mv->{mv_isa_port2addr})($a));
	    }' unless defined(&__isa_port2addr);
	    eval 'sub inb () { &__inb;}' unless defined(&inb);
	    eval 'sub inw () { &__inw;}' unless defined(&inw);
	    eval 'sub inl () { &__inl;}' unless defined(&inl);
	    eval 'sub outb () { &__outb;}' unless defined(&outb);
	    eval 'sub outw () { &__outw;}' unless defined(&outw);
	    eval 'sub outl () { &__outl;}' unless defined(&outl);
	    eval 'sub inb_p () { &__inb_p;}' unless defined(&inb_p);
	    eval 'sub inw_p () { &__inw_p;}' unless defined(&inw_p);
	    eval 'sub inl_p () { &__inl_p;}' unless defined(&inl_p);
	    eval 'sub outb_p () { &__outb_p;}' unless defined(&outb_p);
	    eval 'sub outw_p () { &__outw_p;}' unless defined(&outw_p);
	    eval 'sub outl_p () { &__outl_p;}' unless defined(&outl_p);
	    eval 'sub insb () { &__insb;}' unless defined(&insb);
	    eval 'sub insw () { &__insw;}' unless defined(&insw);
	    eval 'sub insl () { &__insl;}' unless defined(&insl);
	    eval 'sub outsb () { &__outsb;}' unless defined(&outsb);
	    eval 'sub outsw () { &__outsw;}' unless defined(&outsw);
	    eval 'sub outsl () { &__outsl;}' unless defined(&outsl);
	    eval 'sub __raw_readb () { &__readb;}' unless defined(&__raw_readb);
	    eval 'sub __raw_readw () { &__readw;}' unless defined(&__raw_readw);
	    eval 'sub __raw_readl () { &__readl;}' unless defined(&__raw_readl);
	    eval 'sub __raw_writeb () { &__writeb;}' unless defined(&__raw_writeb);
	    eval 'sub __raw_writew () { &__writew;}' unless defined(&__raw_writew);
	    eval 'sub __raw_writel () { &__writel;}' unless defined(&__raw_writel);
	} else {
	    eval 'sub __WANT_IO_DEF () {1;}' unless defined(&__WANT_IO_DEF);
	    if(defined( &CONFIG_SH_HP600)) {
		require 'asm/io_hd64461.ph';
	    }
 elsif(defined( &CONFIG_SH_SOLUTION_ENGINE)) {
		require 'asm/io_se.ph';
	    }
 elsif(defined( &CONFIG_SH_SH2000)) {
		require 'asm/io_sh2000.ph';
	    }
 elsif(defined( &CONFIG_SH_DMIDA) || defined( &CONFIG_SH_STB1_HARP) || defined( &CONFIG_SH_STB1_OVERDRIVE)) {
		require 'asm/io_hd64465.ph';
	    }
 elsif(defined( &CONFIG_SH_EC3104)) {
		require 'asm/io_ec3104.ph';
	    }
 elsif(defined( &CONFIG_SH_DREAMCAST)) {
		require 'asm/io_dc.ph';
	    }
 elsif(defined( &CONFIG_SH_CAT68701)) {
		require 'asm/io_cat68701.ph';
	    }
 elsif(defined( &CONFIG_SH_BIGSUR)) {
		require 'asm/io_bigsur.ph';
	    }
 elsif(defined( &CONFIG_SH_HS7729PCI)) {
		require 'asm/io_hs7729pci.ph';
	    }
 elsif(defined( &CONFIG_SH_7751_SOLUTION_ENGINE)) {
		require 'asm/io_7751se.ph';
	    }
 elsif(defined( &CONFIG_SH_MOBILE_SOLUTION_ENGINE)) {
		require 'asm/io_shmse.ph';
	    }
 elsif(defined( &CONFIG_SH_ADX)) {
		require 'asm/io_adx.ph';
	    }
 elsif(defined( &CONFIG_SH_SECUREEDGE5410)) {
		require 'asm/io_snapgear.ph';
	    }
 elsif(defined( &CONFIG_SH_SH4202_MICRODEV)) {
		require 'asm/io_microdev.ph';
	    }
 elsif(defined( &CONFIG_SH_UNKNOWN)) {
		require 'asm/io_unknown.ph';
	    } else {
		die("What system is this?");
	    }
	    undef(&__WANT_IO_DEF) if defined(&__WANT_IO_DEF);
	}
    }
    if(defined(&__KERNEL__)) {
    }
    if(defined(&__KERNEL__)) {
	unless(defined(&inb)) {
	    eval 'sub inb {
	        my($p) = @_;
    		eval q( &_inb($p));
	    }' unless defined(&inb);
	}
	unless(defined(&inw)) {
	    eval 'sub inw {
	        my($p) = @_;
    		eval q( &_inw($p));
	    }' unless defined(&inw);
	}
	unless(defined(&inl)) {
	    eval 'sub inl {
	        my($p) = @_;
    		eval q( &_inl($p));
	    }' unless defined(&inl);
	}
	unless(defined(&outb)) {
	    eval 'sub outb {
	        my($b,$p) = @_;
    		eval q( &_outb(($b),($p)));
	    }' unless defined(&outb);
	}
	unless(defined(&outw)) {
	    eval 'sub outw {
	        my($w,$p) = @_;
    		eval q( &_outw(($w),($p)));
	    }' unless defined(&outw);
	}
	unless(defined(&outl)) {
	    eval 'sub outl {
	        my($l,$p) = @_;
    		eval q( &_outl(($l),($p)));
	    }' unless defined(&outl);
	}
	unless(defined(&inb_p)) {
	    eval 'sub inb_p () { &_inb_p;}' unless defined(&inb_p);
	}
	unless(defined(&inw_p)) {
	    eval 'sub inw_p () { &_inw_p;}' unless defined(&inw_p);
	}
	unless(defined(&inl_p)) {
	    eval 'sub inl_p () { &_inl_p;}' unless defined(&inl_p);
	}
	unless(defined(&outb_p)) {
	    eval 'sub outb_p () { &_outb_p;}' unless defined(&outb_p);
	}
	unless(defined(&outw_p)) {
	    eval 'sub outw_p () { &_outw_p;}' unless defined(&outw_p);
	}
	unless(defined(&outl_p)) {
	    eval 'sub outl_p () { &_outl_p;}' unless defined(&outl_p);
	}
	unless(defined(&insb)) {
	    eval 'sub insb {
	        my($p,$d,$c) = @_;
    		eval q( &_insb(($p),($d),($c)));
	    }' unless defined(&insb);
	}
	unless(defined(&insw)) {
	    eval 'sub insw {
	        my($p,$d,$c) = @_;
    		eval q( &_insw(($p),($d),($c)));
	    }' unless defined(&insw);
	}
	unless(defined(&insl)) {
	    eval 'sub insl {
	        my($p,$d,$c) = @_;
    		eval q( &_insl(($p),($d),($c)));
	    }' unless defined(&insl);
	}
	unless(defined(&outsb)) {
	    eval 'sub outsb {
	        my($p,$s,$c) = @_;
    		eval q( &_outsb(($p),($s),($c)));
	    }' unless defined(&outsb);
	}
	unless(defined(&outsw)) {
	    eval 'sub outsw {
	        my($p,$s,$c) = @_;
    		eval q( &_outsw(($p),($s),($c)));
	    }' unless defined(&outsw);
	}
	unless(defined(&outsl)) {
	    eval 'sub outsl {
	        my($p,$s,$c) = @_;
    		eval q( &_outsl(($p),($s),($c)));
	    }' unless defined(&outsl);
	}
	if(defined(&__raw_readb)) {
	    eval 'sub readb {
	        my($a) = @_;
    		eval q(({ \'unsigned long r_\' =  &__raw_readb($a);  &mb();  &r_; }));
	    }' unless defined(&readb);
	}
	if(defined(&__raw_readw)) {
	    eval 'sub readw {
	        my($a) = @_;
    		eval q(({ \'unsigned long r_\' =  &__raw_readw($a);  &mb();  &r_; }));
	    }' unless defined(&readw);
	}
	if(defined(&__raw_readl)) {
	    eval 'sub readl {
	        my($a) = @_;
    		eval q(({ \'unsigned long r_\' =  &__raw_readl($a);  &mb();  &r_; }));
	    }' unless defined(&readl);
	}
	if(defined(&__raw_writeb)) {
	    eval 'sub writeb {
	        my($v,$a) = @_;
    		eval q(({  &__raw_writeb(($v),($a));  &mb(); }));
	    }' unless defined(&writeb);
	}
	if(defined(&__raw_writew)) {
	    eval 'sub writew {
	        my($v,$a) = @_;
    		eval q(({  &__raw_writew(($v),($a));  &mb(); }));
	    }' unless defined(&writew);
	}
	if(defined(&__raw_writel)) {
	    eval 'sub writel {
	        my($v,$a) = @_;
    		eval q(({  &__raw_writel(($v),($a));  &mb(); }));
	    }' unless defined(&writel);
	}
	unless(defined(&__raw_readb)) {
	    eval 'sub __raw_readb {
	        my($a) = @_;
    		eval q( &___raw_readb(($a)));
	    }' unless defined(&__raw_readb);
	}
	unless(defined(&__raw_readw)) {
	    eval 'sub __raw_readw {
	        my($a) = @_;
    		eval q( &___raw_readw(($a)));
	    }' unless defined(&__raw_readw);
	}
	unless(defined(&__raw_readl)) {
	    eval 'sub __raw_readl {
	        my($a) = @_;
    		eval q( &___raw_readl(($a)));
	    }' unless defined(&__raw_readl);
	}
	unless(defined(&__raw_writeb)) {
	    eval 'sub __raw_writeb {
	        my($v,$a) = @_;
    		eval q( &___raw_writeb(,($a)));
	    }' unless defined(&__raw_writeb);
	}
	unless(defined(&__raw_writew)) {
	    eval 'sub __raw_writew {
	        my($v,$a) = @_;
    		eval q( &___raw_writew(,($a)));
	    }' unless defined(&__raw_writew);
	}
	unless(defined(&__raw_writel)) {
	    eval 'sub __raw_writel {
	        my($v,$a) = @_;
    		eval q( &___raw_writel(,($a)));
	    }' unless defined(&__raw_writel);
	}
	unless(defined(&readb)) {
	    eval 'sub readb {
	        my($a) = @_;
    		eval q( &_readb(($a)));
	    }' unless defined(&readb);
	}
	unless(defined(&readw)) {
	    eval 'sub readw {
	        my($a) = @_;
    		eval q( &_readw(($a)));
	    }' unless defined(&readw);
	}
	unless(defined(&readl)) {
	    eval 'sub readl {
	        my($a) = @_;
    		eval q( &_readl(($a)));
	    }' unless defined(&readl);
	}
	unless(defined(&writeb)) {
	    eval 'sub writeb {
	        my($v,$a) = @_;
    		eval q( &_writeb(,($a)));
	    }' unless defined(&writeb);
	}
	unless(defined(&writew)) {
	    eval 'sub writew {
	        my($v,$a) = @_;
    		eval q( &_writew(,($a)));
	    }' unless defined(&writew);
	}
	unless(defined(&writel)) {
	    eval 'sub writel {
	        my($v,$a) = @_;
    		eval q( &_writel(,($a)));
	    }' unless defined(&writel);
	}
    } else {
    }
    if(defined(&__KERNEL__)) {
	eval 'sub isa_readb {
	    my($a) = @_;
    	    eval q( &readb( &isa_port2addr($a)));
	}' unless defined(&isa_readb);
	eval 'sub isa_readw {
	    my($a) = @_;
    	    eval q( &readw( &isa_port2addr($a)));
	}' unless defined(&isa_readw);
	eval 'sub isa_readl {
	    my($a) = @_;
    	    eval q( &readl( &isa_port2addr($a)));
	}' unless defined(&isa_readl);
	eval 'sub isa_writeb {
	    my($b,$a) = @_;
    	    eval q( &writeb($b, &isa_port2addr($a)));
	}' unless defined(&isa_writeb);
	eval 'sub isa_writew {
	    my($w,$a) = @_;
    	    eval q( &writew($w, &isa_port2addr($a)));
	}' unless defined(&isa_writew);
	eval 'sub isa_writel {
	    my($l,$a) = @_;
    	    eval q( &writel($l, &isa_port2addr($a)));
	}' unless defined(&isa_writel);
	eval 'sub isa_memset_io {
	    my($a,$b,$c) = @_;
    	    eval q( &memset(( &void *)( &isa_port2addr($a)),($b),($c)));
	}' unless defined(&isa_memset_io);
	eval 'sub isa_memcpy_fromio {
	    my($a,$b,$c) = @_;
    	    eval q( &memcpy(($a),( &void *)( &isa_port2addr(($b))),($c)));
	}' unless defined(&isa_memcpy_fromio);
	eval 'sub isa_memcpy_toio {
	    my($a,$b,$c) = @_;
    	    eval q( &memcpy(( &void *)( &isa_port2addr(($a))),($b),($c)));
	}' unless defined(&isa_memcpy_toio);
	eval 'sub ctrl_inw {
	    my($addr) = @_;
    	    eval q({ *( &volatile my $short*)$addr; });
	}' unless defined(&ctrl_inw);
	eval 'sub ctrl_inl {
	    my($addr) = @_;
    	    eval q({ *( &volatile my $long*)$addr; });
	}' unless defined(&ctrl_inl);
	eval 'sub ctrl_outb {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $char*)$addr = $b; });
	}' unless defined(&ctrl_outb);
	eval 'sub ctrl_outw {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $short*)$addr = $b; });
	}' unless defined(&ctrl_outw);
	eval 'sub ctrl_outl {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $long*)$addr = $b; });
	}' unless defined(&ctrl_outl);
	eval 'sub IO_SPACE_LIMIT () {0xffffffff;}' unless defined(&IO_SPACE_LIMIT);
	require 'asm/addrspace.ph';
	eval 'sub phys_to_virt {
	    my($address) = @_;
    	    eval q({ ( &void *) &P1SEGADDR($address); });
	}' unless defined(&phys_to_virt);
	eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
	eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
	eval 'sub page_to_bus () { &page_to_phys;}' unless defined(&page_to_bus);
	eval 'sub iounmap {
	    my($addr) = @_;
    	    eval q({  &__iounmap($addr); });
	}' unless defined(&iounmap);
	eval 'sub ioremap_nocache {
	    my($off,$size) = @_;
    	    eval q( &ioremap($off,$size));
	}' unless defined(&ioremap_nocache);
	eval 'sub check_signature {
	    my($io_addr,$signature,$length) = @_;
    	    eval q({ \'int\'  &retval = 0;  &do {  &if ( &readb($io_addr) != *$signature)  &goto  &out; $io_addr++; $signature++; $length--; }  &while ($length);  &retval = 1;  &out:  &retval; });
	}' unless defined(&check_signature);
	eval 'sub dma_cache_wback_inv {
	    my($_start,$_size) = @_;
    	    eval q( &__flush_purge_region($_start,$_size));
	}' unless defined(&dma_cache_wback_inv);
	eval 'sub dma_cache_inv {
	    my($_start,$_size) = @_;
    	    eval q( &__flush_invalidate_region($_start,$_size));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    my($_start,$_size) = @_;
    	    eval q( &__flush_wback_region($_start,$_size));
	}' unless defined(&dma_cache_wback);
    }
}
1;
