require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_IRQ_H)) {
    eval 'sub __ASM_SH_IRQ_H () {1;}' unless defined(&__ASM_SH_IRQ_H);
    if(defined( &CONFIG_CPU_SUBTYPE_SH7300)) {
	require 'asm/irq-sh7300.ph';
    } else {
	require 'linux/config.ph';
	require 'asm/machvec.ph';
	require 'asm/ptrace.ph';
	if(defined( &__sh3__)) {
	    eval 'sub INTC_IPRA () {0xfffffee2;}' unless defined(&INTC_IPRA);
	    eval 'sub INTC_IPRB () {0xfffffee4;}' unless defined(&INTC_IPRB);
	}
 elsif(defined( &__SH4__)) {
	    eval 'sub INTC_IPRA () {0xffd00004;}' unless defined(&INTC_IPRA);
	    eval 'sub INTC_IPRB () {0xffd00008;}' unless defined(&INTC_IPRB);
	    eval 'sub INTC_IPRC () {0xffd0000c;}' unless defined(&INTC_IPRC);
	    if(defined( &CONFIG_CPU_SUBTYPE_SH7751)) {
		eval 'sub INTC_IPRD () {0xffd00010;}' unless defined(&INTC_IPRD);
	    }
	}
	eval 'sub TIMER_IRQ () {16;}' unless defined(&TIMER_IRQ);
	eval 'sub TIMER_IPR_ADDR () { &INTC_IPRA;}' unless defined(&TIMER_IPR_ADDR);
	eval 'sub TIMER_IPR_POS () {3;}' unless defined(&TIMER_IPR_POS);
	eval 'sub TIMER_PRIORITY () {2;}' unless defined(&TIMER_PRIORITY);
	eval 'sub RTC_IRQ () {22;}' unless defined(&RTC_IRQ);
	eval 'sub RTC_IPR_ADDR () { &INTC_IPRA;}' unless defined(&RTC_IPR_ADDR);
	eval 'sub RTC_IPR_POS () {0;}' unless defined(&RTC_IPR_POS);
	eval 'sub RTC_PRIORITY () { &TIMER_PRIORITY;}' unless defined(&RTC_PRIORITY);
	if(defined( &__sh3__)) {
	    eval 'sub DMTE0_IRQ () {48;}' unless defined(&DMTE0_IRQ);
	    eval 'sub DMTE1_IRQ () {49;}' unless defined(&DMTE1_IRQ);
	    eval 'sub DMTE2_IRQ () {50;}' unless defined(&DMTE2_IRQ);
	    eval 'sub DMTE3_IRQ () {51;}' unless defined(&DMTE3_IRQ);
	    eval 'sub DMA_IPR_ADDR () { &INTC_IPRE;}' unless defined(&DMA_IPR_ADDR);
	    eval 'sub DMA_IPR_POS () {3;}' unless defined(&DMA_IPR_POS);
	    eval 'sub DMA_PRIORITY () {7;}' unless defined(&DMA_PRIORITY);
	}
 elsif(defined( &__SH4__)) {
	    eval 'sub DMTE0_IRQ () {34;}' unless defined(&DMTE0_IRQ);
	    eval 'sub DMTE1_IRQ () {35;}' unless defined(&DMTE1_IRQ);
	    eval 'sub DMTE2_IRQ () {36;}' unless defined(&DMTE2_IRQ);
	    eval 'sub DMTE3_IRQ () {37;}' unless defined(&DMTE3_IRQ);
	    eval 'sub DMAE_IRQ () {38;}' unless defined(&DMAE_IRQ);
	    eval 'sub DMA_IPR_ADDR () { &INTC_IPRC;}' unless defined(&DMA_IPR_ADDR);
	    eval 'sub DMA_IPR_POS () {2;}' unless defined(&DMA_IPR_POS);
	    eval 'sub DMA_PRIORITY () {7;}' unless defined(&DMA_PRIORITY);
	}
	if(defined ( &CONFIG_CPU_SUBTYPE_SH7707) || defined ( &CONFIG_CPU_SUBTYPE_SH7708) || defined ( &CONFIG_CPU_SUBTYPE_SH7709) || defined ( &CONFIG_CPU_SUBTYPE_SH7750) || defined ( &CONFIG_CPU_SUBTYPE_SH7751)) {
	    eval 'sub SCI_ERI_IRQ () {23;}' unless defined(&SCI_ERI_IRQ);
	    eval 'sub SCI_RXI_IRQ () {24;}' unless defined(&SCI_RXI_IRQ);
	    eval 'sub SCI_TXI_IRQ () {25;}' unless defined(&SCI_TXI_IRQ);
	    eval 'sub SCI_IPR_ADDR () { &INTC_IPRB;}' unless defined(&SCI_IPR_ADDR);
	    eval 'sub SCI_IPR_POS () {1;}' unless defined(&SCI_IPR_POS);
	    eval 'sub SCI_PRIORITY () {3;}' unless defined(&SCI_PRIORITY);
	}
	if(defined( &CONFIG_CPU_SUBTYPE_SH7707) || defined( &CONFIG_CPU_SUBTYPE_SH7709)) {
	    eval 'sub SCIF_ERI_IRQ () {56;}' unless defined(&SCIF_ERI_IRQ);
	    eval 'sub SCIF_RXI_IRQ () {57;}' unless defined(&SCIF_RXI_IRQ);
	    eval 'sub SCIF_BRI_IRQ () {58;}' unless defined(&SCIF_BRI_IRQ);
	    eval 'sub SCIF_TXI_IRQ () {59;}' unless defined(&SCIF_TXI_IRQ);
	    eval 'sub SCIF_IPR_ADDR () { &INTC_IPRE;}' unless defined(&SCIF_IPR_ADDR);
	    eval 'sub SCIF_IPR_POS () {1;}' unless defined(&SCIF_IPR_POS);
	    eval 'sub SCIF_PRIORITY () {3;}' unless defined(&SCIF_PRIORITY);
	    eval 'sub IRDA_ERI_IRQ () {52;}' unless defined(&IRDA_ERI_IRQ);
	    eval 'sub IRDA_RXI_IRQ () {53;}' unless defined(&IRDA_RXI_IRQ);
	    eval 'sub IRDA_BRI_IRQ () {54;}' unless defined(&IRDA_BRI_IRQ);
	    eval 'sub IRDA_TXI_IRQ () {55;}' unless defined(&IRDA_TXI_IRQ);
	    eval 'sub IRDA_IPR_ADDR () { &INTC_IPRE;}' unless defined(&IRDA_IPR_ADDR);
	    eval 'sub IRDA_IPR_POS () {2;}' unless defined(&IRDA_IPR_POS);
	    eval 'sub IRDA_PRIORITY () {3;}' unless defined(&IRDA_PRIORITY);
	}
 elsif(defined( &CONFIG_CPU_SUBTYPE_SH7750) || defined( &CONFIG_CPU_SUBTYPE_SH7751) || defined( &CONFIG_CPU_SUBTYPE_ST40)) {
	    eval 'sub SCIF_ERI_IRQ () {40;}' unless defined(&SCIF_ERI_IRQ);
	    eval 'sub SCIF_RXI_IRQ () {41;}' unless defined(&SCIF_RXI_IRQ);
	    eval 'sub SCIF_BRI_IRQ () {42;}' unless defined(&SCIF_BRI_IRQ);
	    eval 'sub SCIF_TXI_IRQ () {43;}' unless defined(&SCIF_TXI_IRQ);
	    eval 'sub SCIF_IPR_ADDR () { &INTC_IPRC;}' unless defined(&SCIF_IPR_ADDR);
	    eval 'sub SCIF_IPR_POS () {1;}' unless defined(&SCIF_IPR_POS);
	    eval 'sub SCIF_PRIORITY () {3;}' unless defined(&SCIF_PRIORITY);
	    if(defined( &CONFIG_CPU_SUBTYPE_ST40)) {
		eval 'sub SCIF1_ERI_IRQ () {23;}' unless defined(&SCIF1_ERI_IRQ);
		eval 'sub SCIF1_RXI_IRQ () {24;}' unless defined(&SCIF1_RXI_IRQ);
		eval 'sub SCIF1_BRI_IRQ () {25;}' unless defined(&SCIF1_BRI_IRQ);
		eval 'sub SCIF1_TXI_IRQ () {26;}' unless defined(&SCIF1_TXI_IRQ);
		eval 'sub SCIF1_IPR_ADDR () { &INTC_IPRB;}' unless defined(&SCIF1_IPR_ADDR);
		eval 'sub SCIF1_IPR_POS () {1;}' unless defined(&SCIF1_IPR_POS);
		eval 'sub SCIF1_PRIORITY () {3;}' unless defined(&SCIF1_PRIORITY);
	    }
	}
	if(defined(&CONFIG_SH_GENERIC)) {
	    eval 'sub ONCHIP_NR_IRQS () {144;}' unless defined(&ONCHIP_NR_IRQS);
	} else {
	    if(defined( &CONFIG_CPU_SUBTYPE_SH7707)) {
		eval 'sub ONCHIP_NR_IRQS () {64;}' unless defined(&ONCHIP_NR_IRQS);
		eval 'sub PINT_NR_IRQS () {16;}' unless defined(&PINT_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_SH7708)) {
		eval 'sub ONCHIP_NR_IRQS () {32;}' unless defined(&ONCHIP_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_SH7709)) {
		eval 'sub ONCHIP_NR_IRQS () {64;}' unless defined(&ONCHIP_NR_IRQS);
		eval 'sub PINT_NR_IRQS () {16;}' unless defined(&PINT_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_SH7750)) {
		eval 'sub ONCHIP_NR_IRQS () {48;}' unless defined(&ONCHIP_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_SH7751)) {
		eval 'sub ONCHIP_NR_IRQS () {72;}' unless defined(&ONCHIP_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_SH4_202)) {
		eval 'sub ONCHIP_NR_IRQS () {72;}' unless defined(&ONCHIP_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_ST40STB1)) {
		eval 'sub ONCHIP_NR_IRQS () {144;}' unless defined(&ONCHIP_NR_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_ST40GX1)) {
		eval 'sub ONCHIP_NR_IRQS () {176;}' unless defined(&ONCHIP_NR_IRQS);
	    } else {
		die("Unknown\ chip");
	    }
	}
	if(defined(&CONFIG_SH_GENERIC)) {
	    eval 'sub PINT_NR_IRQS () {16;}' unless defined(&PINT_NR_IRQS);
	} else {
	    unless(defined(&PINT_NR_IRQS)) {
		eval 'sub PINT_NR_IRQS () {0;}' unless defined(&PINT_NR_IRQS);
	    }
	}
	if((defined(&PINT_NR_IRQS) ? &PINT_NR_IRQS : 0) > 0) {
	    eval 'sub PINT_IRQ_BASE () { &ONCHIP_NR_IRQS;}' unless defined(&PINT_IRQ_BASE);
	}
	if(defined(&CONFIG_SH_GENERIC)) {
	    eval 'sub OFFCHIP_NR_IRQS () {16;}' unless defined(&OFFCHIP_NR_IRQS);
	} else {
	    if(defined( &CONFIG_HD64461)) {
		eval 'sub OFFCHIP_NR_IRQS () {16;}' unless defined(&OFFCHIP_NR_IRQS);
	    }
 elsif(defined ( &CONFIG_SH_BIGSUR) ) {
		eval 'sub OFFCHIP_NR_IRQS () {48;}' unless defined(&OFFCHIP_NR_IRQS);
	    }
 elsif(defined( &CONFIG_HD64465)) {
		eval 'sub OFFCHIP_NR_IRQS () {16;}' unless defined(&OFFCHIP_NR_IRQS);
	    }
 elsif(defined ( &CONFIG_SH_EC3104)) {
		eval 'sub OFFCHIP_NR_IRQS () {16;}' unless defined(&OFFCHIP_NR_IRQS);
	    }
 elsif(defined ( &CONFIG_SH_DREAMCAST)) {
		eval 'sub OFFCHIP_NR_IRQS () {96;}' unless defined(&OFFCHIP_NR_IRQS);
	    } else {
		eval 'sub OFFCHIP_NR_IRQS () {0;}' unless defined(&OFFCHIP_NR_IRQS);
	    }
	}
	if((defined(&OFFCHIP_NR_IRQS) ? &OFFCHIP_NR_IRQS : 0) > 0) {
	    eval 'sub OFFCHIP_IRQ_BASE () {( &ONCHIP_NR_IRQS +  &PINT_NR_IRQS);}' unless defined(&OFFCHIP_IRQ_BASE);
	}
	eval 'sub NR_IRQS () {( &ONCHIP_NR_IRQS +  &PINT_NR_IRQS +  &OFFCHIP_NR_IRQS);}' unless defined(&NR_IRQS);
	if(defined(&CONFIG_SH_GENERIC)) {
	    eval 'sub ACTUAL_NR_IRQS () {( ($sh_mv->{mv_nr_irqs}));}' unless defined(&ACTUAL_NR_IRQS);
	} else {
	    eval 'sub ACTUAL_NR_IRQS () { &NR_IRQS;}' unless defined(&ACTUAL_NR_IRQS);
	}
	if(defined( &CONFIG_CPU_SUBTYPE_SH7707) || defined( &CONFIG_CPU_SUBTYPE_SH7709)) {
	    eval 'sub INTC_IRR0 () {0xa4000004;}' unless defined(&INTC_IRR0);
	    eval 'sub INTC_IRR1 () {0xa4000006;}' unless defined(&INTC_IRR1);
	    eval 'sub INTC_IRR2 () {0xa4000008;}' unless defined(&INTC_IRR2);
	    eval 'sub INTC_ICR0 () {0xfffffee0;}' unless defined(&INTC_ICR0);
	    eval 'sub INTC_ICR1 () {0xa4000010;}' unless defined(&INTC_ICR1);
	    eval 'sub INTC_ICR2 () {0xa4000012;}' unless defined(&INTC_ICR2);
	    eval 'sub INTC_INTER () {0xa4000014;}' unless defined(&INTC_INTER);
	    eval 'sub INTC_IPRC () {0xa4000016;}' unless defined(&INTC_IPRC);
	    eval 'sub INTC_IPRD () {0xa4000018;}' unless defined(&INTC_IPRD);
	    eval 'sub INTC_IPRE () {0xa400001a;}' unless defined(&INTC_IPRE);
	    if(defined( &CONFIG_CPU_SUBTYPE_SH7707)) {
		eval 'sub INTC_IPRF () {0xa400001c;}' unless defined(&INTC_IPRF);
	    }
	    eval 'sub PORT_PACR () {0xa4000100;}' unless defined(&PORT_PACR);
	    eval 'sub PORT_PBCR () {0xa4000102;}' unless defined(&PORT_PBCR);
	    eval 'sub PORT_PCCR () {0xa4000104;}' unless defined(&PORT_PCCR);
	    eval 'sub PORT_PFCR () {0xa400010a;}' unless defined(&PORT_PFCR);
	    eval 'sub PORT_PADR () {0xa4000120;}' unless defined(&PORT_PADR);
	    eval 'sub PORT_PBDR () {0xa4000122;}' unless defined(&PORT_PBDR);
	    eval 'sub PORT_PCDR () {0xa4000124;}' unless defined(&PORT_PCDR);
	    eval 'sub PORT_PFDR () {0xa400012a;}' unless defined(&PORT_PFDR);
	    eval 'sub IRQ0_IRQ () {32;}' unless defined(&IRQ0_IRQ);
	    eval 'sub IRQ1_IRQ () {33;}' unless defined(&IRQ1_IRQ);
	    eval 'sub IRQ2_IRQ () {34;}' unless defined(&IRQ2_IRQ);
	    eval 'sub IRQ3_IRQ () {35;}' unless defined(&IRQ3_IRQ);
	    eval 'sub IRQ4_IRQ () {36;}' unless defined(&IRQ4_IRQ);
	    eval 'sub IRQ5_IRQ () {37;}' unless defined(&IRQ5_IRQ);
	    eval 'sub IRQ0_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ0_IPR_ADDR);
	    eval 'sub IRQ1_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ1_IPR_ADDR);
	    eval 'sub IRQ2_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ2_IPR_ADDR);
	    eval 'sub IRQ3_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ3_IPR_ADDR);
	    eval 'sub IRQ4_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRQ4_IPR_ADDR);
	    eval 'sub IRQ5_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRQ5_IPR_ADDR);
	    eval 'sub IRQ0_IPR_POS () {0;}' unless defined(&IRQ0_IPR_POS);
	    eval 'sub IRQ1_IPR_POS () {1;}' unless defined(&IRQ1_IPR_POS);
	    eval 'sub IRQ2_IPR_POS () {2;}' unless defined(&IRQ2_IPR_POS);
	    eval 'sub IRQ3_IPR_POS () {3;}' unless defined(&IRQ3_IPR_POS);
	    eval 'sub IRQ4_IPR_POS () {0;}' unless defined(&IRQ4_IPR_POS);
	    eval 'sub IRQ5_IPR_POS () {1;}' unless defined(&IRQ5_IPR_POS);
	    eval 'sub IRQ0_PRIORITY () {1;}' unless defined(&IRQ0_PRIORITY);
	    eval 'sub IRQ1_PRIORITY () {1;}' unless defined(&IRQ1_PRIORITY);
	    eval 'sub IRQ2_PRIORITY () {1;}' unless defined(&IRQ2_PRIORITY);
	    eval 'sub IRQ3_PRIORITY () {1;}' unless defined(&IRQ3_PRIORITY);
	    eval 'sub IRQ4_PRIORITY () {1;}' unless defined(&IRQ4_PRIORITY);
	    eval 'sub IRQ5_PRIORITY () {1;}' unless defined(&IRQ5_PRIORITY);
	    eval 'sub PINT0_IRQ () {40;}' unless defined(&PINT0_IRQ);
	    eval 'sub PINT8_IRQ () {41;}' unless defined(&PINT8_IRQ);
	    eval 'sub PINT0_IPR_ADDR () { &INTC_IPRD;}' unless defined(&PINT0_IPR_ADDR);
	    eval 'sub PINT8_IPR_ADDR () { &INTC_IPRD;}' unless defined(&PINT8_IPR_ADDR);
	    eval 'sub PINT0_IPR_POS () {3;}' unless defined(&PINT0_IPR_POS);
	    eval 'sub PINT8_IPR_POS () {2;}' unless defined(&PINT8_IPR_POS);
	    eval 'sub PINT0_PRIORITY () {2;}' unless defined(&PINT0_PRIORITY);
	    eval 'sub PINT8_PRIORITY () {2;}' unless defined(&PINT8_PRIORITY);
	    eval 'sub __irq_demux {
	        my($irq) = @_;
    		eval q( &ipr_irq_demux($irq));
	    }' unless defined(&__irq_demux);
	} else {
	    eval 'sub __irq_demux {
	        my($irq) = @_;
    		eval q($irq);
	    }' unless defined(&__irq_demux);
	}
	if(defined( &CONFIG_CPU_SUBTYPE_SH7750) || defined( &CONFIG_CPU_SUBTYPE_SH7751) || defined( &CONFIG_CPU_SUBTYPE_ST40) || defined( &CONFIG_CPU_SUBTYPE_SH4_202)) {
	    eval 'sub INTC_ICR () {0xffd00000;}' unless defined(&INTC_ICR);
	    eval 'sub INTC_ICR_NMIL () {(1<<15);}' unless defined(&INTC_ICR_NMIL);
	    eval 'sub INTC_ICR_MAI () {(1<<14);}' unless defined(&INTC_ICR_MAI);
	    eval 'sub INTC_ICR_NMIB () {(1<<9);}' unless defined(&INTC_ICR_NMIB);
	    eval 'sub INTC_ICR_NMIE () {(1<<8);}' unless defined(&INTC_ICR_NMIE);
	    eval 'sub INTC_ICR_IRLM () {(1<<7);}' unless defined(&INTC_ICR_IRLM);
	}
	if(defined(&CONFIG_CPU_SUBTYPE_ST40)) {
	    eval 'sub INTC2_FIRST_IRQ () {64;}' unless defined(&INTC2_FIRST_IRQ);
	    if(defined( &CONFIG_CPU_SUBTYPE_ST40STB1)) {
		eval 'sub NR_INTC2_IRQS () {80;}' unless defined(&NR_INTC2_IRQS);
	    }
 elsif(defined( &CONFIG_CPU_SUBTYPE_ST40GX1)) {
		eval 'sub NR_INTC2_IRQS () {112;}' unless defined(&NR_INTC2_IRQS);
	    } else {
		die("Unknown\ CPU");
	    }
	    eval 'sub INTC2_BASE () {0xfe080000;}' unless defined(&INTC2_BASE);
	    eval 'sub INTC2_INTC2MODE () {( &INTC2_BASE+0x80);}' unless defined(&INTC2_INTC2MODE);
	    eval 'sub INTC2_INTPRI_OFFSET () {0x;}' unless defined(&INTC2_INTPRI_OFFSET);
	    eval 'sub INTC2_INTREQ_OFFSET () {0x20;}' unless defined(&INTC2_INTREQ_OFFSET);
	    eval 'sub INTC2_INTMSK_OFFSET () {0x40;}' unless defined(&INTC2_INTMSK_OFFSET);
	    eval 'sub INTC2_INTMSKCLR_OFFSET () {0x60;}' unless defined(&INTC2_INTMSKCLR_OFFSET);
	}
	if(defined(&CONFIG_SH_GENERIC)) {
	    eval 'sub irq_demux {
	        my($irq) = @_;
    		eval q({  &if ( ($sh_mv->{mv_irq_demux})) { $irq =  ($sh_mv->{mv_irq_demux})($irq); }  &__irq_demux($irq); });
	    }' unless defined(&irq_demux);
	}
 elsif(defined( &CONFIG_SH_BIGSUR)) {
	    eval 'sub irq_demux {
	        my($irq) = @_;
    		eval q( &bigsur_irq_demux($irq));
	    }' unless defined(&irq_demux);
	}
 elsif(defined( &CONFIG_HD64461)) {
	    eval 'sub irq_demux {
	        my($irq) = @_;
    		eval q( &hd64461_irq_demux($irq));
	    }' unless defined(&irq_demux);
	}
 elsif(defined( &CONFIG_HD64465)) {
	    eval 'sub irq_demux {
	        my($irq) = @_;
    		eval q( &hd64465_irq_demux($irq));
	    }' unless defined(&irq_demux);
	}
 elsif(defined( &CONFIG_SH_EC3104)) {
	    eval 'sub irq_demux () { &ec3104_irq_demux;}' unless defined(&irq_demux);
	}
 elsif(defined( &CONFIG_SH_CAT68701)) {
	    eval 'sub irq_demux () { &cat68701_irq_demux;}' unless defined(&irq_demux);
	}
 elsif(defined( &CONFIG_SH_DREAMCAST)) {
	    eval 'sub irq_demux () { &systemasic_irq_demux;}' unless defined(&irq_demux);
	} else {
	    eval 'sub irq_demux {
	        my($irq) = @_;
    		eval q( &__irq_demux($irq));
	    }' unless defined(&irq_demux);
	}
    }
}
1;
