require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SH_IRQ_MICRODEV_H)) {
    eval 'sub _ASM_SH_IRQ_MICRODEV_H () {1;}' unless defined(&_ASM_SH_IRQ_MICRODEV_H);
    eval 'sub MICRODEV_FPGA_INTC_BASE () {0xa6110000;}' unless defined(&MICRODEV_FPGA_INTC_BASE);
    eval 'sub MICRODEV_FPGA_INTENB_REG () {( &MICRODEV_FPGA_INTC_BASE+0);}' unless defined(&MICRODEV_FPGA_INTENB_REG);
    eval 'sub MICRODEV_FPGA_INTDSB_REG () {( &MICRODEV_FPGA_INTC_BASE+8);}' unless defined(&MICRODEV_FPGA_INTDSB_REG);
    eval 'sub MICRODEV_FPGA_INTC_MASK {
        my($n) = @_;
	    eval q((1<<($n)));
    }' unless defined(&MICRODEV_FPGA_INTC_MASK);
    eval 'sub MICRODEV_FPGA_INTPRI_REG {
        my($n) = @_;
	    eval q(( &MICRODEV_FPGA_INTC_BASE+0x10+(($n)/8)*8));
    }' unless defined(&MICRODEV_FPGA_INTPRI_REG);
    eval 'sub MICRODEV_FPGA_INTPRI_LEVEL {
        my($n,$x) = @_;
	    eval q((($x)<<((($n)%8)*4)));
    }' unless defined(&MICRODEV_FPGA_INTPRI_LEVEL);
    eval 'sub MICRODEV_FPGA_INTPRI_MASK {
        my($n) = @_;
	    eval q(( &MICRODEV_FPGA_INTPRI_LEVEL(($n),0xf)));
    }' unless defined(&MICRODEV_FPGA_INTPRI_MASK);
}
1;
