require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__KGDB_H)) {
    eval 'sub __KGDB_H () {1;}' unless defined(&__KGDB_H);
    require 'asm/ptrace.ph';
    eval 'sub _JBLEN () {9;}' unless defined(&_JBLEN);
    eval 'sub KGDB_PRINTK () {(...)  &printk("KGDB: "  &__VA_ARGS__);}' unless defined(&KGDB_PRINTK);
    eval 'sub BREAKPOINT () {
        eval q( &do {  &if ( &kgdb_enabled) {  &asm  &volatile(\\"trapa   #0xff\\"); } }  &while (0));
    }' unless defined(&BREAKPOINT);
    if(defined( &__sh3__)) {
	eval 'sub kgdb_flush_icache_range {
	    my($start, $end) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&kgdb_flush_icache_range);
    }
 elsif(defined( &__SH4__)) {
	eval 'sub kgdb_flush_icache_range {
	    my($start, $end) = @_;
    	    eval q({  &extern  &void  &__flush_purge_region( &void *, \'int\');  &__flush_purge_region(( &void*), - ($start));  &flush_icache_range(($start), ($end)); });
	}' unless defined(&kgdb_flush_icache_range);
    }
    if(defined(&CONFIG_KGDB_KERNEL_ASSERTS)) {
	eval 'sub KA_VALID_ERRNO {
	    my($errno) = @_;
    	    eval q((($errno) > 0 && ($errno) <=  &EMEDIUMTYPE));
	}' unless defined(&KA_VALID_ERRNO);
	eval 'sub KA_VALID_PTR_ERR {
	    my($ptr) = @_;
    	    eval q( &KA_VALID_ERRNO(- &PTR_ERR($ptr)));
	}' unless defined(&KA_VALID_PTR_ERR);
	eval 'sub KA_VALID_KPTR {
	    my($ptr) = @_;
    	    eval q((!($ptr) || (( &void *)($ptr) >= ( &void *) &PAGE_OFFSET  && ( &void *)($ptr) <  &ERR_PTR(- &EMEDIUMTYPE))));
	}' unless defined(&KA_VALID_KPTR);
	eval 'sub KA_VALID_PTRORERR {
	    my($errptr) = @_;
    	    eval q(( &KA_VALID_KPTR($errptr) ||  &KA_VALID_PTR_ERR($errptr)));
	}' unless defined(&KA_VALID_PTRORERR);
	eval 'sub KA_HELD_GKL () {
	    eval q(( ($current->{lock_depth}) >= 0));
	}' unless defined(&KA_HELD_GKL);
	eval 'sub KGDB_ASSERT {
	    my($condition, $message) = @_;
    	    eval q( &do {  &if (!($condition)  && ( &kgdb_enabled)) {  &KGDB_PRINTK(\\"Assertion failed at %s:%d: %s\\\\n\\",  &__FILE__,  &__LINE__, $message);  &BREAKPOINT(); } }  &while (0));
	}' unless defined(&KGDB_ASSERT);
    } else {
	eval 'sub KGDB_ASSERT {
	    my($condition, $message) = @_;
    	    eval q();
	}' unless defined(&KGDB_ASSERT);
    }
}
1;
