require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SH_MACHVEC_H)) {
    eval 'sub _ASM_SH_MACHVEC_H () {1;}' unless defined(&_ASM_SH_MACHVEC_H);
    require 'linux/config.ph';
    require 'linux/types.ph';
    if(defined(&CONFIG_SH_GENERIC)) {
	eval 'sub MACH_SE () {( ($sh_mv->{mv_hw_se}));}' unless defined(&MACH_SE);
	eval 'sub MACH_SHMSE () {( ($sh_mv->{mv_hw_shmse}));}' unless defined(&MACH_SHMSE);
	eval 'sub MACH_HP600 () {( ($sh_mv->{mv_hw_hp600}));}' unless defined(&MACH_HP600);
	eval 'sub MACH_HP620 () {( ($sh_mv->{mv_hw_hp620}));}' unless defined(&MACH_HP620);
	eval 'sub MACH_HP680 () {( ($sh_mv->{mv_hw_hp680}));}' unless defined(&MACH_HP680);
	eval 'sub MACH_HP690 () {( ($sh_mv->{mv_hw_hp690}));}' unless defined(&MACH_HP690);
	eval 'sub MACH_HD64461 () {( ($sh_mv->{mv_hw_hd64461}));}' unless defined(&MACH_HD64461);
	eval 'sub MACH_HD64465 () {( ($sh_mv->{mv_hw_hd64465}));}' unless defined(&MACH_HD64465);
	eval 'sub MACH_SH2000 () {( ($sh_mv->{mv_hw_sh2000}));}' unless defined(&MACH_SH2000);
	eval 'sub MACH_DREAMCAST () {( ($sh_mv->{mv_hw_dreamcast}));}' unless defined(&MACH_DREAMCAST);
	eval 'sub MACH_BIGSUR () {( ($sh_mv->{mv_hw_bigsur}));}' unless defined(&MACH_BIGSUR);
	eval 'sub MACH_HS7729PCI () {( ($sh_mv->{mv_hw_hs7729pci}));}' unless defined(&MACH_HS7729PCI);
	eval 'sub MACH_7751SE () {( ($sh_mv->{mv_hw_7751se}));}' unless defined(&MACH_7751SE);
	eval 'sub MACH_ADX () {( ($sh_mv->{mv_hw_adx}));}' unless defined(&MACH_ADX);
	eval 'sub MACH_SNAPGEAR () {( ($sh_mv->{mv_snapgear}));}' unless defined(&MACH_SNAPGEAR);
	eval 'sub MACH_SH4202_MICRODEV () {( ($sh_mv->{mv_hw_sh4202_microdev}));}' unless defined(&MACH_SH4202_MICRODEV);
    } else {
	if(defined(&CONFIG_SH_SOLUTION_ENGINE)) {
	    eval 'sub MACH_SE () {1;}' unless defined(&MACH_SE);
	} else {
	    eval 'sub MACH_SE () {0;}' unless defined(&MACH_SE);
	}
	if(defined(&CONFIG_SH_7751_SOLUTION_ENGINE)) {
	    eval 'sub MACH_7751SE () {1;}' unless defined(&MACH_7751SE);
	} else {
	    eval 'sub MACH_7751SE () {0;}' unless defined(&MACH_7751SE);
	}
	if(defined(&CONFIG_SH_MOBILE_SOLUTION_ENGINE)) {
	    eval 'sub MACH_SHMSE () {1;}' unless defined(&MACH_SHMSE);
	} else {
	    eval 'sub MACH_SHMSE () {0;}' unless defined(&MACH_SHMSE);
	}
	if(defined(&CONFIG_SH_HP600)) {
	    eval 'sub MACH_HP600 () {1;}' unless defined(&MACH_HP600);
	} else {
	    eval 'sub MACH_HP600 () {0;}' unless defined(&MACH_HP600);
	}
	if(defined(&CONFIG_SH_HP620)) {
	    eval 'sub MACH_HP620 () {1;}' unless defined(&MACH_HP620);
	} else {
	    eval 'sub MACH_HP620 () {0;}' unless defined(&MACH_HP620);
	}
	if(defined(&CONFIG_SH_HP680)) {
	    eval 'sub MACH_HP680 () {1;}' unless defined(&MACH_HP680);
	} else {
	    eval 'sub MACH_HP680 () {0;}' unless defined(&MACH_HP680);
	}
	if(defined(&CONFIG_SH_HP690)) {
	    eval 'sub MACH_HP690 () {1;}' unless defined(&MACH_HP690);
	} else {
	    eval 'sub MACH_HP690 () {0;}' unless defined(&MACH_HP690);
	}
	if(defined(&CONFIG_HD64461)) {
	    eval 'sub MACH_HD64461 () {1;}' unless defined(&MACH_HD64461);
	} else {
	    eval 'sub MACH_HD64461 () {0;}' unless defined(&MACH_HD64461);
	}
	if(defined(&CONFIG_HD64465)) {
	    eval 'sub MACH_HD64465 () {1;}' unless defined(&MACH_HD64465);
	} else {
	    eval 'sub MACH_HD64465 () {0;}' unless defined(&MACH_HD64465);
	}
	if(defined(&CONFIG_SH_SH2000)) {
	    eval 'sub MACH_SH2000 () {1;}' unless defined(&MACH_SH2000);
	} else {
	    eval 'sub MACH_SH2000 () {0;}' unless defined(&MACH_SH2000);
	}
	if(defined(&CONFIG_SH_EC3104)) {
	    eval 'sub MACH_EC3104 () {1;}' unless defined(&MACH_EC3104);
	} else {
	    eval 'sub MACH_EC3104 () {0;}' unless defined(&MACH_EC3104);
	}
	if(defined(&CONFIG_SH_DREAMCAST)) {
	    eval 'sub MACH_DREAMCAST () {1;}' unless defined(&MACH_DREAMCAST);
	} else {
	    eval 'sub MACH_DREAMCAST () {0;}' unless defined(&MACH_DREAMCAST);
	}
	if(defined(&CONFIG_SH_BIGSUR)) {
	    eval 'sub MACH_BIGSUR () {1;}' unless defined(&MACH_BIGSUR);
	} else {
	    eval 'sub MACH_BIGSUR () {0;}' unless defined(&MACH_BIGSUR);
	}
	if(defined(&CONFIG_SH_HS7729PCI)) {
	    eval 'sub MACH_HS7729PCI () {1;}' unless defined(&MACH_HS7729PCI);
	} else {
	    eval 'sub MACH_HS7729PCI () {0;}' unless defined(&MACH_HS7729PCI);
	}
	if(defined(&CONFIG_SH_ADX)) {
	    eval 'sub MACH_ADX () {1;}' unless defined(&MACH_ADX);
	} else {
	    eval 'sub MACH_ADX () {0;}' unless defined(&MACH_ADX);
	}
	if(defined(&CONFIG_SH_SECUREEDGE5410)) {
	    eval 'sub MACH_SNAPGEAR () {1;}' unless defined(&MACH_SNAPGEAR);
	} else {
	    eval 'sub MACH_SNAPGEAR () {0;}' unless defined(&MACH_SNAPGEAR);
	}
	if(defined(&CONFIG_SH_SH4202_MICRODEV)) {
	    eval 'sub MACH_SH4202_MICRODEV () {1;}' unless defined(&MACH_SH4202_MICRODEV);
	} else {
	    eval 'sub MACH_SH4202_MICRODEV () {0;}' unless defined(&MACH_SH4202_MICRODEV);
	}
    }
}
1;
