require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PCI_SH7751_H_)) {
    eval 'sub _PCI_SH7751_H_ () {1;}' unless defined(&_PCI_SH7751_H_);
    require 'linux/pci.ph';
    undef(&DEBUG_PCI) if defined(&DEBUG_PCI);
    if(defined(&DEBUG_PCI)) {
	eval 'sub PCIDBG () {( &n,  &x...) {  &if( &DEBUG_PCI>= &n)  &printk( &x); };}' unless defined(&PCIDBG);
    } else {
	eval 'sub PCIDBG () {( &n,  &x...);}' unless defined(&PCIDBG);
    }
    eval 'sub PCI_PROBE_BIOS () {1;}' unless defined(&PCI_PROBE_BIOS);
    eval 'sub PCI_PROBE_CONF1 () {2;}' unless defined(&PCI_PROBE_CONF1);
    eval 'sub PCI_PROBE_CONF2 () {4;}' unless defined(&PCI_PROBE_CONF2);
    eval 'sub PCI_NO_SORT () {0x100;}' unless defined(&PCI_NO_SORT);
    eval 'sub PCI_BIOS_SORT () {0x200;}' unless defined(&PCI_BIOS_SORT);
    eval 'sub PCI_NO_CHECKS () {0x400;}' unless defined(&PCI_NO_CHECKS);
    eval 'sub PCI_ASSIGN_ROMS () {0x1000;}' unless defined(&PCI_ASSIGN_ROMS);
    eval 'sub PCI_BIOS_IRQ_SCAN () {0x2000;}' unless defined(&PCI_BIOS_IRQ_SCAN);
    eval 'sub SH7751_VENDOR_ID () {0x1054;}' unless defined(&SH7751_VENDOR_ID);
    eval 'sub SH7751_DEVICE_ID () {0x3505;}' unless defined(&SH7751_DEVICE_ID);
    eval 'sub SH7751R_DEVICE_ID () {0x350e;}' unless defined(&SH7751R_DEVICE_ID);
    eval 'sub SH7751_PCI_CONFIG_BASE () {0xfd000000;}' unless defined(&SH7751_PCI_CONFIG_BASE);
    eval 'sub SH7751_PCI_CONFIG_SIZE () {0x1000000;}' unless defined(&SH7751_PCI_CONFIG_SIZE);
    eval 'sub SH7751_PCI_MEMORY_BASE () {0xfd000000;}' unless defined(&SH7751_PCI_MEMORY_BASE);
    eval 'sub SH7751_PCI_MEM_SIZE () {0x1000000;}' unless defined(&SH7751_PCI_MEM_SIZE);
    eval 'sub SH7751_PCI_IO_BASE () {0xfe240000;}' unless defined(&SH7751_PCI_IO_BASE);
    eval 'sub SH7751_PCI_IO_SIZE () {0x40000;}' unless defined(&SH7751_PCI_IO_SIZE);
    eval 'sub SH7751_PCIREG_BASE () {0xfe200000;}' unless defined(&SH7751_PCIREG_BASE);
    eval 'sub PCI_REG {
        my($n) = @_;
	    eval q(( &SH7751_PCIREG_BASE+ $n));
    }' unless defined(&PCI_REG);
    eval 'sub SH7751_PCICONF0 () {0x;}' unless defined(&SH7751_PCICONF0);
    eval 'sub SH7751_PCICONF0_DEVID () {0xffff0000;}' unless defined(&SH7751_PCICONF0_DEVID);
    eval 'sub SH7751_PCICONF0_VNDID () {0xffff;}' unless defined(&SH7751_PCICONF0_VNDID);
    eval 'sub SH7751_PCICONF1 () {0x4;}' unless defined(&SH7751_PCICONF1);
    eval 'sub SH7751_PCICONF1_DPE () {0x80000000;}' unless defined(&SH7751_PCICONF1_DPE);
    eval 'sub SH7751_PCICONF1_SSE () {0x40000000;}' unless defined(&SH7751_PCICONF1_SSE);
    eval 'sub SH7751_PCICONF1_RMA () {0x20000000;}' unless defined(&SH7751_PCICONF1_RMA);
    eval 'sub SH7751_PCICONF1_RTA () {0x10000000;}' unless defined(&SH7751_PCICONF1_RTA);
    eval 'sub SH7751_PCICONF1_STA () {0x8000000;}' unless defined(&SH7751_PCICONF1_STA);
    eval 'sub SH7751_PCICONF1_DEV () {0x6000000;}' unless defined(&SH7751_PCICONF1_DEV);
    eval 'sub SH7751_PCICONF1_DPD () {0x1000000;}' unless defined(&SH7751_PCICONF1_DPD);
    eval 'sub SH7751_PCICONF1_FBBC () {0x800000;}' unless defined(&SH7751_PCICONF1_FBBC);
    eval 'sub SH7751_PCICONF1_UDF () {0x400000;}' unless defined(&SH7751_PCICONF1_UDF);
    eval 'sub SH7751_PCICONF1_66M () {0x200000;}' unless defined(&SH7751_PCICONF1_66M);
    eval 'sub SH7751_PCICONF1_PM () {0x100000;}' unless defined(&SH7751_PCICONF1_PM);
    eval 'sub SH7751_PCICONF1_PBBE () {0x200;}' unless defined(&SH7751_PCICONF1_PBBE);
    eval 'sub SH7751_PCICONF1_SER () {0x100;}' unless defined(&SH7751_PCICONF1_SER);
    eval 'sub SH7751_PCICONF1_WCC () {0x80;}' unless defined(&SH7751_PCICONF1_WCC);
    eval 'sub SH7751_PCICONF1_PER () {0x40;}' unless defined(&SH7751_PCICONF1_PER);
    eval 'sub SH7751_PCICONF1_VPS () {0x20;}' unless defined(&SH7751_PCICONF1_VPS);
    eval 'sub SH7751_PCICONF1_MWIE () {0x10;}' unless defined(&SH7751_PCICONF1_MWIE);
    eval 'sub SH7751_PCICONF1_SPC () {0x8;}' unless defined(&SH7751_PCICONF1_SPC);
    eval 'sub SH7751_PCICONF1_BUM () {0x4;}' unless defined(&SH7751_PCICONF1_BUM);
    eval 'sub SH7751_PCICONF1_MES () {0x2;}' unless defined(&SH7751_PCICONF1_MES);
    eval 'sub SH7751_PCICONF1_IOS () {0x1;}' unless defined(&SH7751_PCICONF1_IOS);
    eval 'sub SH7751_PCICONF2 () {0x8;}' unless defined(&SH7751_PCICONF2);
    eval 'sub SH7751_PCICONF2_BCC () {0xff000000;}' unless defined(&SH7751_PCICONF2_BCC);
    eval 'sub SH7751_PCICONF2_SCC () {0xff0000;}' unless defined(&SH7751_PCICONF2_SCC);
    eval 'sub SH7751_PCICONF2_RLPI () {0xff00;}' unless defined(&SH7751_PCICONF2_RLPI);
    eval 'sub SH7751_PCICONF2_REV () {0xff;}' unless defined(&SH7751_PCICONF2_REV);
    eval 'sub SH7751_PCICONF3 () {0xc;}' unless defined(&SH7751_PCICONF3);
    eval 'sub SH7751_PCICONF3_BIST7 () {0x80000000;}' unless defined(&SH7751_PCICONF3_BIST7);
    eval 'sub SH7751_PCICONF3_BIST6 () {0x40000000;}' unless defined(&SH7751_PCICONF3_BIST6);
    eval 'sub SH7751_PCICONF3_BIST3_0 () {0xf000000;}' unless defined(&SH7751_PCICONF3_BIST3_0);
    eval 'sub SH7751_PCICONF3_HD7 () {0x800000;}' unless defined(&SH7751_PCICONF3_HD7);
    eval 'sub SH7751_PCICONF3_HD6_0 () {0x7f0000;}' unless defined(&SH7751_PCICONF3_HD6_0);
    eval 'sub SH7751_PCICONF3_LAT () {0xff00;}' unless defined(&SH7751_PCICONF3_LAT);
    eval 'sub SH7751_PCICONF3_CLS () {0xff;}' unless defined(&SH7751_PCICONF3_CLS);
    eval 'sub SH7751_PCICONF4 () {0x10;}' unless defined(&SH7751_PCICONF4);
    eval 'sub SH7751_PCICONF4_BASE () {0xfffffffc;}' unless defined(&SH7751_PCICONF4_BASE);
    eval 'sub SH7751_PCICONF4_ASI () {0x1;}' unless defined(&SH7751_PCICONF4_ASI);
    eval 'sub SH7751_PCICONF5 () {0x14;}' unless defined(&SH7751_PCICONF5);
    eval 'sub SH7751_PCICONF5_BASE () {0xfffffff0;}' unless defined(&SH7751_PCICONF5_BASE);
    eval 'sub SH7751_PCICONF5_LAP () {0x8;}' unless defined(&SH7751_PCICONF5_LAP);
    eval 'sub SH7751_PCICONF5_LAT () {0x6;}' unless defined(&SH7751_PCICONF5_LAT);
    eval 'sub SH7751_PCICONF5_ASI () {0x1;}' unless defined(&SH7751_PCICONF5_ASI);
    eval 'sub SH7751_PCICONF6 () {0x18;}' unless defined(&SH7751_PCICONF6);
    eval 'sub SH7751_PCICONF6_BASE () {0xfffffff0;}' unless defined(&SH7751_PCICONF6_BASE);
    eval 'sub SH7751_PCICONF6_LAP () {0x8;}' unless defined(&SH7751_PCICONF6_LAP);
    eval 'sub SH7751_PCICONF6_LAT () {0x6;}' unless defined(&SH7751_PCICONF6_LAT);
    eval 'sub SH7751_PCICONF6_ASI () {0x1;}' unless defined(&SH7751_PCICONF6_ASI);
    eval 'sub SH7751_PCICONF11 () {0x2c;}' unless defined(&SH7751_PCICONF11);
    eval 'sub SH7751_PCICONF11_SSID () {0xffff0000;}' unless defined(&SH7751_PCICONF11_SSID);
    eval 'sub SH7751_PCICONF11_SVID () {0xffff;}' unless defined(&SH7751_PCICONF11_SVID);
    eval 'sub SH7751_PCICONF13 () {0x34;}' unless defined(&SH7751_PCICONF13);
    eval 'sub SH7751_PCICONF13_CPTR () {0xff;}' unless defined(&SH7751_PCICONF13_CPTR);
    eval 'sub SH7751_PCICONF15 () {0x3c;}' unless defined(&SH7751_PCICONF15);
    eval 'sub SH7751_PCICONF15_IPIN () {0xff;}' unless defined(&SH7751_PCICONF15_IPIN);
    eval 'sub SH7751_PCICONF16 () {0x40;}' unless defined(&SH7751_PCICONF16);
    eval 'sub SH7751_PCICONF16_PMES () {0xf8000000;}' unless defined(&SH7751_PCICONF16_PMES);
    eval 'sub SH7751_PCICONF16_D2S () {0x4000000;}' unless defined(&SH7751_PCICONF16_D2S);
    eval 'sub SH7751_PCICONF16_D1S () {0x2000000;}' unless defined(&SH7751_PCICONF16_D1S);
    eval 'sub SH7751_PCICONF16_DSI () {0x200000;}' unless defined(&SH7751_PCICONF16_DSI);
    eval 'sub SH7751_PCICONF16_PMCK () {0x80000;}' unless defined(&SH7751_PCICONF16_PMCK);
    eval 'sub SH7751_PCICONF16_VER () {0x70000;}' unless defined(&SH7751_PCICONF16_VER);
    eval 'sub SH7751_PCICONF16_NIP () {0xff00;}' unless defined(&SH7751_PCICONF16_NIP);
    eval 'sub SH7751_PCICONF16_CID () {0xff;}' unless defined(&SH7751_PCICONF16_CID);
    eval 'sub SH7751_PCICONF17 () {0x44;}' unless defined(&SH7751_PCICONF17);
    eval 'sub SH7751_PCICONF17_DATA () {0xff000000;}' unless defined(&SH7751_PCICONF17_DATA);
    eval 'sub SH7751_PCICONF17_PMES () {0x800000;}' unless defined(&SH7751_PCICONF17_PMES);
    eval 'sub SH7751_PCICONF17_DSCL () {0x600000;}' unless defined(&SH7751_PCICONF17_DSCL);
    eval 'sub SH7751_PCICONF17_DSEL () {0x1e0000;}' unless defined(&SH7751_PCICONF17_DSEL);
    eval 'sub SH7751_PCICONF17_PMEN () {0x10000;}' unless defined(&SH7751_PCICONF17_PMEN);
    eval 'sub SH7751_PCICONF17_PWST () {0x3;}' unless defined(&SH7751_PCICONF17_PWST);
    eval 'sub SH7751_PCICR () {0x100;}' unless defined(&SH7751_PCICR);
    eval 'sub SH7751_PCICR_PREFIX () {0xa5000000;}' unless defined(&SH7751_PCICR_PREFIX);
    eval 'sub SH7751_PCICR_TRSB () {0x200;}' unless defined(&SH7751_PCICR_TRSB);
    eval 'sub SH7751_PCICR_BSWP () {0x100;}' unless defined(&SH7751_PCICR_BSWP);
    eval 'sub SH7751_PCICR_PLUP () {0x80;}' unless defined(&SH7751_PCICR_PLUP);
    eval 'sub SH7751_PCICR_ARBM () {0x40;}' unless defined(&SH7751_PCICR_ARBM);
    eval 'sub SH7751_PCICR_MD () {0x30;}' unless defined(&SH7751_PCICR_MD);
    eval 'sub SH7751_PCICR_SERR () {0x8;}' unless defined(&SH7751_PCICR_SERR);
    eval 'sub SH7751_PCICR_INTA () {0x4;}' unless defined(&SH7751_PCICR_INTA);
    eval 'sub SH7751_PCICR_PRST () {0x2;}' unless defined(&SH7751_PCICR_PRST);
    eval 'sub SH7751_PCICR_CFIN () {0x1;}' unless defined(&SH7751_PCICR_CFIN);
    eval 'sub SH7751_PCILSR0 () {0x104;}' unless defined(&SH7751_PCILSR0);
    eval 'sub SH7751_PCILSR1 () {0x108;}' unless defined(&SH7751_PCILSR1);
    eval 'sub SH7751_PCILAR0 () {0x10c;}' unless defined(&SH7751_PCILAR0);
    eval 'sub SH7751_PCILAR1 () {0x110;}' unless defined(&SH7751_PCILAR1);
    eval 'sub SH7751_PCIINT () {0x114;}' unless defined(&SH7751_PCIINT);
    eval 'sub SH7751_PCIINT_MLCK () {0x8000;}' unless defined(&SH7751_PCIINT_MLCK);
    eval 'sub SH7751_PCIINT_TABT () {0x4000;}' unless defined(&SH7751_PCIINT_TABT);
    eval 'sub SH7751_PCIINT_TRET () {0x200;}' unless defined(&SH7751_PCIINT_TRET);
    eval 'sub SH7751_PCIINT_MFDE () {0x100;}' unless defined(&SH7751_PCIINT_MFDE);
    eval 'sub SH7751_PCIINT_PRTY () {0x80;}' unless defined(&SH7751_PCIINT_PRTY);
    eval 'sub SH7751_PCIINT_SERR () {0x40;}' unless defined(&SH7751_PCIINT_SERR);
    eval 'sub SH7751_PCIINT_TWDP () {0x20;}' unless defined(&SH7751_PCIINT_TWDP);
    eval 'sub SH7751_PCIINT_TRDP () {0x10;}' unless defined(&SH7751_PCIINT_TRDP);
    eval 'sub SH7751_PCIINT_MTABT () {0x8;}' unless defined(&SH7751_PCIINT_MTABT);
    eval 'sub SH7751_PCIINT_MMABT () {0x4;}' unless defined(&SH7751_PCIINT_MMABT);
    eval 'sub SH7751_PCIINT_MWPD () {0x2;}' unless defined(&SH7751_PCIINT_MWPD);
    eval 'sub SH7751_PCIINT_MRPD () {0x2;}' unless defined(&SH7751_PCIINT_MRPD);
    eval 'sub SH7751_PCIINTM () {0x118;}' unless defined(&SH7751_PCIINTM);
    eval 'sub SH7751_PCIALR () {0x11c;}' unless defined(&SH7751_PCIALR);
    eval 'sub SH7751_PCICLR () {0x120;}' unless defined(&SH7751_PCICLR);
    eval 'sub SH7751_PCICLR_MPIO () {0x80000000;}' unless defined(&SH7751_PCICLR_MPIO);
    eval 'sub SH7751_PCICLR_MDMA0 () {0x40000000;}' unless defined(&SH7751_PCICLR_MDMA0);
    eval 'sub SH7751_PCICLR_MDMA1 () {0x20000000;}' unless defined(&SH7751_PCICLR_MDMA1);
    eval 'sub SH7751_PCICLR_MDMA2 () {0x10000000;}' unless defined(&SH7751_PCICLR_MDMA2);
    eval 'sub SH7751_PCICLR_MDMA3 () {0x8000000;}' unless defined(&SH7751_PCICLR_MDMA3);
    eval 'sub SH7751_PCICLR_TGT () {0x4000000;}' unless defined(&SH7751_PCICLR_TGT);
    eval 'sub SH7751_PCICLR_CMDL () {0xf;}' unless defined(&SH7751_PCICLR_CMDL);
    eval 'sub SH7751_PCIAINT () {0x130;}' unless defined(&SH7751_PCIAINT);
    eval 'sub SH7751_PCIAINT_MBKN () {0x2000;}' unless defined(&SH7751_PCIAINT_MBKN);
    eval 'sub SH7751_PCIAINT_TBTO () {0x1000;}' unless defined(&SH7751_PCIAINT_TBTO);
    eval 'sub SH7751_PCIAINT_MBTO () {0x1000;}' unless defined(&SH7751_PCIAINT_MBTO);
    eval 'sub SH7751_PCIAINT_TABT () {0x8;}' unless defined(&SH7751_PCIAINT_TABT);
    eval 'sub SH7751_PCIAINT_MABT () {0x4;}' unless defined(&SH7751_PCIAINT_MABT);
    eval 'sub SH7751_PCIAINT_RDPE () {0x2;}' unless defined(&SH7751_PCIAINT_RDPE);
    eval 'sub SH7751_PCIAINT_WDPE () {0x2;}' unless defined(&SH7751_PCIAINT_WDPE);
    eval 'sub SH7751_PCIAINTM () {0x134;}' unless defined(&SH7751_PCIAINTM);
    eval 'sub SH7751_PCIBMLR () {0x138;}' unless defined(&SH7751_PCIBMLR);
    eval 'sub SH7751_PCIBMLR_REQ4 () {0x10;}' unless defined(&SH7751_PCIBMLR_REQ4);
    eval 'sub SH7751_PCIBMLR_REQ3 () {0x8;}' unless defined(&SH7751_PCIBMLR_REQ3);
    eval 'sub SH7751_PCIBMLR_REQ2 () {0x4;}' unless defined(&SH7751_PCIBMLR_REQ2);
    eval 'sub SH7751_PCIBMLR_REQ1 () {0x2;}' unless defined(&SH7751_PCIBMLR_REQ1);
    eval 'sub SH7751_PCIBMLR_REQ0 () {0x1;}' unless defined(&SH7751_PCIBMLR_REQ0);
    eval 'sub SH7751_PCIDMABT () {0x140;}' unless defined(&SH7751_PCIDMABT);
    eval 'sub SH7751_PCIDMABT_RRBN () {0x1;}' unless defined(&SH7751_PCIDMABT_RRBN);
    eval 'sub SH7751_PCIDPA0 () {0x180;}' unless defined(&SH7751_PCIDPA0);
    eval 'sub SH7751_PCIDLA0 () {0x184;}' unless defined(&SH7751_PCIDLA0);
    eval 'sub SH7751_PCIDTC0 () {0x188;}' unless defined(&SH7751_PCIDTC0);
    eval 'sub SH7751_PCIDCR0 () {0x18c;}' unless defined(&SH7751_PCIDCR0);
    eval 'sub SH7751_PCIDCR_ALGN () {0x600;}' unless defined(&SH7751_PCIDCR_ALGN);
    eval 'sub SH7751_PCIDCR_MAST () {0x100;}' unless defined(&SH7751_PCIDCR_MAST);
    eval 'sub SH7751_PCIDCR_INTM () {0x80;}' unless defined(&SH7751_PCIDCR_INTM);
    eval 'sub SH7751_PCIDCR_INTS () {0x40;}' unless defined(&SH7751_PCIDCR_INTS);
    eval 'sub SH7751_PCIDCR_LHLD () {0x20;}' unless defined(&SH7751_PCIDCR_LHLD);
    eval 'sub SH7751_PCIDCR_PHLD () {0x10;}' unless defined(&SH7751_PCIDCR_PHLD);
    eval 'sub SH7751_PCIDCR_IOSEL () {0x8;}' unless defined(&SH7751_PCIDCR_IOSEL);
    eval 'sub SH7751_PCIDCR_DIR () {0x4;}' unless defined(&SH7751_PCIDCR_DIR);
    eval 'sub SH7751_PCIDCR_STOP () {0x2;}' unless defined(&SH7751_PCIDCR_STOP);
    eval 'sub SH7751_PCIDCR_STRT () {0x1;}' unless defined(&SH7751_PCIDCR_STRT);
    eval 'sub SH7751_PCIDPA1 () {0x190;}' unless defined(&SH7751_PCIDPA1);
    eval 'sub SH7751_PCIDLA1 () {0x194;}' unless defined(&SH7751_PCIDLA1);
    eval 'sub SH7751_PCIDTC1 () {0x198;}' unless defined(&SH7751_PCIDTC1);
    eval 'sub SH7751_PCIDCR1 () {0x19c;}' unless defined(&SH7751_PCIDCR1);
    eval 'sub SH7751_PCIDPA2 () {0x1a0;}' unless defined(&SH7751_PCIDPA2);
    eval 'sub SH7751_PCIDLA2 () {0x1a4;}' unless defined(&SH7751_PCIDLA2);
    eval 'sub SH7751_PCIDTC2 () {0x1a8;}' unless defined(&SH7751_PCIDTC2);
    eval 'sub SH7751_PCIDCR2 () {0x1ac;}' unless defined(&SH7751_PCIDCR2);
    eval 'sub SH7751_PCIDPA3 () {0x1b0;}' unless defined(&SH7751_PCIDPA3);
    eval 'sub SH7751_PCIDLA3 () {0x1b4;}' unless defined(&SH7751_PCIDLA3);
    eval 'sub SH7751_PCIDTC3 () {0x1b8;}' unless defined(&SH7751_PCIDTC3);
    eval 'sub SH7751_PCIDCR3 () {0x1bc;}' unless defined(&SH7751_PCIDCR3);
    eval 'sub SH7751_PCIPAR () {0x1c0;}' unless defined(&SH7751_PCIPAR);
    eval 'sub SH7751_PCIPAR_CFGEN () {0x80000000;}' unless defined(&SH7751_PCIPAR_CFGEN);
    eval 'sub SH7751_PCIPAR_BUSNO () {0xff0000;}' unless defined(&SH7751_PCIPAR_BUSNO);
    eval 'sub SH7751_PCIPAR_DEVNO () {0xff00;}' unless defined(&SH7751_PCIPAR_DEVNO);
    eval 'sub SH7751_PCIPAR_REGAD () {0xfc;}' unless defined(&SH7751_PCIPAR_REGAD);
    eval 'sub SH7751_PCIMBR () {0x1c4;}' unless defined(&SH7751_PCIMBR);
    eval 'sub SH7751_PCIMBR_MASK () {0xff000000;}' unless defined(&SH7751_PCIMBR_MASK);
    eval 'sub SH7751_PCIMBR_LOCK () {0x1;}' unless defined(&SH7751_PCIMBR_LOCK);
    eval 'sub SH7751_PCIIOBR () {0x1c8;}' unless defined(&SH7751_PCIIOBR);
    eval 'sub SH7751_PCIIOBR_MASK () {0xfffc0000;}' unless defined(&SH7751_PCIIOBR_MASK);
    eval 'sub SH7751_PCIIOBR_LOCK () {0x1;}' unless defined(&SH7751_PCIIOBR_LOCK);
    eval 'sub SH7751_PCIPINT () {0x1cc;}' unless defined(&SH7751_PCIPINT);
    eval 'sub SH7751_PCIPINT_D3 () {0x2;}' unless defined(&SH7751_PCIPINT_D3);
    eval 'sub SH7751_PCIPINT_D0 () {0x1;}' unless defined(&SH7751_PCIPINT_D0);
    eval 'sub SH7751_PCIPINTM () {0x1d0;}' unless defined(&SH7751_PCIPINTM);
    eval 'sub SH7751_PCICLKR () {0x1d4;}' unless defined(&SH7751_PCICLKR);
    eval 'sub SH7751_PCICLKR_PCSTP () {0x2;}' unless defined(&SH7751_PCICLKR_PCSTP);
    eval 'sub SH7751_PCICLKR_BCSTP () {0x2;}' unless defined(&SH7751_PCICLKR_BCSTP);
    eval 'sub SH7751_PCIBCR1 () {0x1e0;}' unless defined(&SH7751_PCIBCR1);
    eval 'sub SH7751_PCIBCR2 () {0x1e4;}' unless defined(&SH7751_PCIBCR2);
    eval 'sub SH7751_PCIWCR1 () {0x1e8;}' unless defined(&SH7751_PCIWCR1);
    eval 'sub SH7751_PCIWCR2 () {0x1ec;}' unless defined(&SH7751_PCIWCR2);
    eval 'sub SH7751_PCIWCR3 () {0x1f0;}' unless defined(&SH7751_PCIWCR3);
    eval 'sub SH7751_PCIMCR () {0x1f4;}' unless defined(&SH7751_PCIMCR);
    eval 'sub SH7751_PCIPCTR () {0x200;}' unless defined(&SH7751_PCIPCTR);
    eval 'sub SH7751_PCIPCTR_P2EN () {0x400000;}' unless defined(&SH7751_PCIPCTR_P2EN);
    eval 'sub SH7751_PCIPCTR_P1EN () {0x200000;}' unless defined(&SH7751_PCIPCTR_P1EN);
    eval 'sub SH7751_PCIPCTR_P0EN () {0x100000;}' unless defined(&SH7751_PCIPCTR_P0EN);
    eval 'sub SH7751_PCIPCTR_P2UP () {0x20;}' unless defined(&SH7751_PCIPCTR_P2UP);
    eval 'sub SH7751_PCIPCTR_P2IO () {0x10;}' unless defined(&SH7751_PCIPCTR_P2IO);
    eval 'sub SH7751_PCIPCTR_P1UP () {0x8;}' unless defined(&SH7751_PCIPCTR_P1UP);
    eval 'sub SH7751_PCIPCTR_P1IO () {0x4;}' unless defined(&SH7751_PCIPCTR_P1IO);
    eval 'sub SH7751_PCIPCTR_P0UP () {0x2;}' unless defined(&SH7751_PCIPCTR_P0UP);
    eval 'sub SH7751_PCIPCTR_P0IO () {0x1;}' unless defined(&SH7751_PCIPCTR_P0IO);
    eval 'sub SH7751_PCIPDTR () {0x204;}' unless defined(&SH7751_PCIPDTR);
    eval 'sub SH7751_PCIPDTR_PB5 () {0x20;}' unless defined(&SH7751_PCIPDTR_PB5);
    eval 'sub SH7751_PCIPDTR_PB4 () {0x10;}' unless defined(&SH7751_PCIPDTR_PB4);
    eval 'sub SH7751_PCIPDTR_PB3 () {0x8;}' unless defined(&SH7751_PCIPDTR_PB3);
    eval 'sub SH7751_PCIPDTR_PB2 () {0x4;}' unless defined(&SH7751_PCIPDTR_PB2);
    eval 'sub SH7751_PCIPDTR_PB1 () {0x2;}' unless defined(&SH7751_PCIPDTR_PB1);
    eval 'sub SH7751_PCIPDTR_PB0 () {0x1;}' unless defined(&SH7751_PCIPDTR_PB0);
    eval 'sub SH7751_PCIPDR () {0x220;}' unless defined(&SH7751_PCIPDR);
    eval 'sub SH7751_BCR1 () {0xff800000;}' unless defined(&SH7751_BCR1);
    eval 'sub SH7751_BCR2 () {0xff800004;}' unless defined(&SH7751_BCR2);
    eval 'sub SH7751_WCR1 () {0xff800008;}' unless defined(&SH7751_WCR1);
    eval 'sub SH7751_WCR2 () {0xff80000c;}' unless defined(&SH7751_WCR2);
    eval 'sub SH7751_WCR3 () {0xff800010;}' unless defined(&SH7751_WCR3);
    eval 'sub SH7751_MCR () {0xff800014;}' unless defined(&SH7751_MCR);
    eval 'sub SH7751_CS0_BASE_ADDR () {0x;}' unless defined(&SH7751_CS0_BASE_ADDR);
    eval 'sub SH7751_MEM_REGION_SIZE () {0x4000000;}' unless defined(&SH7751_MEM_REGION_SIZE);
    eval 'sub SH7751_CS1_BASE_ADDR () {( &SH7751_CS0_BASE_ADDR +  &SH7751_MEM_REGION_SIZE);}' unless defined(&SH7751_CS1_BASE_ADDR);
    eval 'sub SH7751_CS2_BASE_ADDR () {( &SH7751_CS1_BASE_ADDR +  &SH7751_MEM_REGION_SIZE);}' unless defined(&SH7751_CS2_BASE_ADDR);
    eval 'sub SH7751_CS3_BASE_ADDR () {( &SH7751_CS2_BASE_ADDR +  &SH7751_MEM_REGION_SIZE);}' unless defined(&SH7751_CS3_BASE_ADDR);
    eval 'sub SH7751_CS4_BASE_ADDR () {( &SH7751_CS3_BASE_ADDR +  &SH7751_MEM_REGION_SIZE);}' unless defined(&SH7751_CS4_BASE_ADDR);
    eval 'sub SH7751_CS5_BASE_ADDR () {( &SH7751_CS4_BASE_ADDR +  &SH7751_MEM_REGION_SIZE);}' unless defined(&SH7751_CS5_BASE_ADDR);
    eval 'sub SH7751_CS6_BASE_ADDR () {( &SH7751_CS5_BASE_ADDR +  &SH7751_MEM_REGION_SIZE);}' unless defined(&SH7751_CS6_BASE_ADDR);
    eval 'sub SH7751_PCI_HOST_BRIDGE () {0x6;}' unless defined(&SH7751_PCI_HOST_BRIDGE);
}
1;
