require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PCI_H)) {
    eval 'sub __ASM_SH_PCI_H () {1;}' unless defined(&__ASM_SH_PCI_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	eval 'sub pcibios_assign_all_busses () {
	    eval q(1);
	}' unless defined(&pcibios_assign_all_busses);
	eval 'sub pcibios_scan_all_fns () {
	    eval q(0);
	}' unless defined(&pcibios_scan_all_fns);
	if(defined( &CONFIG_CPU_SUBTYPE_ST40)) {
	    eval 'sub PCIBIOS_MIN_IO () {0x2000;}' unless defined(&PCIBIOS_MIN_IO);
	    eval 'sub PCIBIOS_MIN_MEM () {0x10000000;}' unless defined(&PCIBIOS_MIN_MEM);
	}
 elsif(defined( &CONFIG_SH_DREAMCAST)) {
	    eval 'sub PCIBIOS_MIN_IO () {0x2000;}' unless defined(&PCIBIOS_MIN_IO);
	    eval 'sub PCIBIOS_MIN_MEM () {0x10000000;}' unless defined(&PCIBIOS_MIN_MEM);
	}
 elsif(defined( &CONFIG_SH_BIGSUR)  && defined( &CONFIG_CPU_SUBTYPE_SH7751)) {
	    eval 'sub PCIBIOS_MIN_IO () {0x2000;}' unless defined(&PCIBIOS_MIN_IO);
	    eval 'sub PCIBIOS_MIN_MEM () {0xfd000000;}' unless defined(&PCIBIOS_MIN_MEM);
	}
 elsif(defined( &CONFIG_SH_7751_SOLUTION_ENGINE) || defined( &CONFIG_SH_SECUREEDGE5410)) {
	    eval 'sub PCIBIOS_MIN_IO () {0x4000;}' unless defined(&PCIBIOS_MIN_IO);
	    eval 'sub PCIBIOS_MIN_MEM () {0xfd000000;}' unless defined(&PCIBIOS_MIN_MEM);
	}
 elsif(defined( &CONFIG_PCI_SD0001)) {
	    eval 'sub PCIBIOS_MIN_IO () {0x2000;}' unless defined(&PCIBIOS_MIN_IO);
	    eval 'sub PCIBIOS_MIN_MEM () {0x1000000;}' unless defined(&PCIBIOS_MIN_MEM);
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pcibios_penalize_isa_irq {
	    my($irq) = @_;
    	    eval q({ }  &include < &linux/ ($types->{h})>  &include < &linux/ ($slab->{h})>  &include < &asm/ ($scatterlist->{h})>  &include < &linux/ ($string->{h})>  &include < &asm/ ($io->{h})> \'struct pci_dev\';  &define  &PCI_DMA_BUS_IS_PHYS (1)  &void * &pci_alloc_consistent(\'struct pci_dev\' * &hwdev, \'size_t\'  &size,  &dma_addr_t * &dma_handle);  &void  &pci_free_consistent(\'struct pci_dev\' * &hwdev, \'size_t\'  &size,  &void * &vaddr,  &dma_addr_t  &dma_handle);  &dma_addr_t  &pci_map_single(\'struct pci_dev\' * &hwdev,  &void * &ptr, \'size_t\'  &size, \'int\'  &direction) {  &if ( &direction ==  &PCI_DMA_NONE)  &BUG();  &virt_to_bus( &ptr); });
	}' unless defined(&pcibios_penalize_isa_irq);
	if(defined(&CONFIG_SH_PCIDMA_NONCOHERENT)) {
	    eval 'sub DECLARE_PCI_UNMAP_ADDR {
	        my($ADDR_NAME) = @_;
    		eval q( &dma_addr_t $ADDR_NAME;);
	    }' unless defined(&DECLARE_PCI_UNMAP_ADDR);
	    eval 'sub DECLARE_PCI_UNMAP_LEN {
	        my($LEN_NAME) = @_;
    		eval q( &__u32 $LEN_NAME;);
	    }' unless defined(&DECLARE_PCI_UNMAP_LEN);
	    eval 'sub pci_unmap_addr {
	        my($PTR, $ADDR_NAME) = @_;
    		eval q((($PTR)->$ADDR_NAME));
	    }' unless defined(&pci_unmap_addr);
	    eval 'sub pci_unmap_addr_set {
	        my($PTR, $ADDR_NAME, $VAL) = @_;
    		eval q(((($PTR)->$ADDR_NAME) = ($VAL)));
	    }' unless defined(&pci_unmap_addr_set);
	    eval 'sub pci_unmap_len {
	        my($PTR, $LEN_NAME) = @_;
    		eval q((($PTR)->$LEN_NAME));
	    }' unless defined(&pci_unmap_len);
	    eval 'sub pci_unmap_len_set {
	        my($PTR, $LEN_NAME, $VAL) = @_;
    		eval q(((($PTR)->$LEN_NAME) = ($VAL)));
	    }' unless defined(&pci_unmap_len_set);
	} else {
	    eval 'sub DECLARE_PCI_UNMAP_ADDR {
	        my($ADDR_NAME) = @_;
    		eval q();
	    }' unless defined(&DECLARE_PCI_UNMAP_ADDR);
	    eval 'sub DECLARE_PCI_UNMAP_LEN {
	        my($LEN_NAME) = @_;
    		eval q();
	    }' unless defined(&DECLARE_PCI_UNMAP_LEN);
	    eval 'sub pci_unmap_addr {
	        my($PTR, $ADDR_NAME) = @_;
    		eval q((0));
	    }' unless defined(&pci_unmap_addr);
	    eval 'sub pci_unmap_addr_set {
	        my($PTR, $ADDR_NAME, $VAL) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pci_unmap_addr_set);
	    eval 'sub pci_unmap_len {
	        my($PTR, $LEN_NAME) = @_;
    		eval q((0));
	    }' unless defined(&pci_unmap_len);
	    eval 'sub pci_unmap_len_set {
	        my($PTR, $LEN_NAME, $VAL) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pci_unmap_len_set);
	}
	if(defined(&CONFIG_SH_PCIDMA_NONCOHERENT)) {
	}
	if(defined(&CONFIG_SH_PCIDMA_NONCOHERENT)) {
	}
	if(defined(&CONFIG_SH_PCIDMA_NONCOHERENT)) {
	}
	eval 'sub pci_dac_dma_supported {
	    my($pci_dev, $mask) = @_;
    	    eval q((0));
	}' unless defined(&pci_dac_dma_supported);
	eval 'sub pci_controller_num {
	    my($PDEV) = @_;
    	    eval q((0));
	}' unless defined(&pci_controller_num);
	eval 'sub sg_dma_address {
	    my($sg) = @_;
    	    eval q(( &virt_to_bus(($sg)-> &address)));
	}' unless defined(&sg_dma_address);
	eval 'sub sg_dma_len {
	    my($sg) = @_;
    	    eval q((($sg)-> &length));
	}' unless defined(&sg_dma_len);
    }
}
1;
