require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PGALLOC_H)) {
    eval 'sub __ASM_SH_PGALLOC_H () {1;}' unless defined(&__ASM_SH_PGALLOC_H);
    require 'asm/processor.ph';
    require 'linux/threads.ph';
    require 'linux/slab.ph';
    eval 'sub pgd_quicklist () {(0);}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {(0);}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {0;}' unless defined(&pgtable_cache_size);
    eval 'sub pmd_populate {
        my($mm, $pmd, $pte) = @_;
	    eval q( &set_pmd($pmd,  &__pmd( &_PAGE_TABLE +  &__pa($pte))));
    }' unless defined(&pmd_populate);
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q({  &kfree($pgd); });
    }' unless defined(&pgd_free);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &pte_t * &pte = ( &pte_t *)  &__get_free_page( &GFP_KERNEL);  &if ( &pte)  &clear_page( &pte);  &pte; });
    }' unless defined(&pte_t);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one_fast(\'struct mm_struct\' * &mm, my $address) { 0; });
    }' unless defined(&pte_t);
    eval 'sub pte_free_slow {
        my($pte) = @_;
	    eval q({  &free_page($pte); });
    }' unless defined(&pte_free_slow);
    eval 'sub pte_free {
        my($pte) = @_;
	    eval q( &pte_free_slow($pte));
    }' unless defined(&pte_free);
    eval 'sub pmd_alloc_one_fast {
        my($mm, $addr) = @_;
	    eval q(({  &BUG(); (( &pmd_t *)1); }));
    }' unless defined(&pmd_alloc_one_fast);
    eval 'sub pmd_alloc_one {
        my($mm, $addr) = @_;
	    eval q(({  &BUG(); (( &pmd_t *)2); }));
    }' unless defined(&pmd_alloc_one);
    eval 'sub pmd_free_slow {
        my($x) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&pmd_free_slow);
    eval 'sub pmd_free_fast {
        my($x) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&pmd_free_fast);
    eval 'sub pmd_free {
        my($x) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&pmd_free);
    eval 'sub pgd_populate {
        my($mm, $pmd, $pte) = @_;
	    eval q( &BUG());
    }' unless defined(&pgd_populate);
    eval 'sub flush_tlb_pgtables {
        my($mm,$start,$end) = @_;
	    eval q({ });
    }' unless defined(&flush_tlb_pgtables);
    if(defined( &__SH4__)) {
    } else {
	eval 'sub ptep_get_and_clear {
	    my($ptep) = @_;
    	    eval q({  &pte_t  &pte = *$ptep;  &pte_clear($ptep);  &pte; });
	}' unless defined(&ptep_get_and_clear);
    }
    eval 'sub ptep_test_and_clear_dirty {
        my($ptep) = @_;
	    eval q({  &pte_t  &pte = *$ptep;  &if (! &pte_dirty( &pte)) 0;  &set_pte($ptep,  &pte_mkclean( &pte)); 1; });
    }' unless defined(&ptep_test_and_clear_dirty);
    eval 'sub ptep_set_wrprotect {
        my($ptep) = @_;
	    eval q({  &pte_t  &old_pte = *$ptep;  &set_pte($ptep,  &pte_wrprotect( &old_pte)); });
    }' unless defined(&ptep_set_wrprotect);
    eval 'sub ptep_mkdirty {
        my($ptep) = @_;
	    eval q({  &pte_t  &old_pte = *$ptep;  &set_pte($ptep,  &pte_mkdirty( &old_pte)); });
    }' unless defined(&ptep_mkdirty);
}
1;
