require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PROCESSOR_H)) {
    eval 'sub __ASM_SH_PROCESSOR_H () {1;}' unless defined(&__ASM_SH_PROCESSOR_H);
    require 'asm/page.ph';
    require 'asm/types.ph';
    require 'linux/threads.ph';
    eval 'sub current_text_addr () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&current_text_addr);
    eval("sub CPU_SH7708 () { 0; }") unless defined(&CPU_SH7708);
    eval("sub CPU_SH7729 () { 1; }") unless defined(&CPU_SH7729);
    eval("sub CPU_SH7750 () { 2; }") unless defined(&CPU_SH7750);
    eval("sub CPU_ST40 () { 3; }") unless defined(&CPU_ST40);
    eval("sub CPU_SH4202 () { 4; }") unless defined(&CPU_SH4202);
    eval("sub CPU_SH_NONE () { 5; }") unless defined(&CPU_SH_NONE);
    if(defined(&CONFIG_CPU_SUBTYPE_ST40)) {
    }
    eval 'sub cpu_data () {( &boot_cpu_data);}' unless defined(&cpu_data);
    eval 'sub current_cpu_data () { &boot_cpu_data;}' unless defined(&current_cpu_data);
    eval 'sub TASK_SIZE () {0x7c000000;}' unless defined(&TASK_SIZE);
    eval 'sub TASK_UNMAPPED_BASE () {( &TASK_SIZE / 3);}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub SR_FD () {0x8000;}' unless defined(&SR_FD);
    eval 'sub SR_DSP () {0x1000;}' unless defined(&SR_DSP);
    eval 'sub SR_IMASK () {0xf0;}' unless defined(&SR_IMASK);
    eval 'sub INIT_THREAD () {{ $sizeof{ &init_stack} +   &init_stack, 0, 0, 0, 0, 0, -1, {{{0,}},} };}' unless defined(&INIT_THREAD);
    eval 'sub start_thread {
        my($regs, $new_pc, $new_sp) = @_;
	    eval q( &set_fs( &USER_DS);  ($regs->{pr}) = 0;  ($regs->{sr}) = 0;  ($regs->{pc}) = $new_pc;  ($regs->{regs[15]}) = $new_sp);
    }' unless defined(&start_thread);
    eval 'sub EISA_bus () {0;}' unless defined(&EISA_bus);
    eval 'sub EISA_bus__is_a_macro () {1;}' unless defined(&EISA_bus__is_a_macro);
    eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
    eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
    eval 'sub copy_segments {
        my($p, $mm) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&copy_segments);
    eval 'sub release_segments {
        my($mm) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&release_segments);
    eval 'sub grab_fpu {
        my($void) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&grab_fpu);
    eval 'sub unlazy_fpu {
        my($tsk) = @_;
	    eval q( &do {  &if (($tsk)-> &flags &  &PF_USEDFPU) {  &save_fpu($tsk); } }  &while (0));
    }' unless defined(&unlazy_fpu);
    eval 'sub clear_fpu {
        my($tsk) = @_;
	    eval q( &do {  &if (($tsk)-> &flags &  &PF_USEDFPU) { ($tsk)-> &flags &= ~ &PF_USEDFPU;  &release_fpu(); } }  &while (0));
    }' unless defined(&clear_fpu);
    eval 'sub FPSCR_INIT () {0x80000;}' unless defined(&FPSCR_INIT);
    eval 'sub FPSCR_CAUSE_MASK () {0x1f000;}' unless defined(&FPSCR_CAUSE_MASK);
    eval 'sub FPSCR_FLAG_MASK () {0x7c;}' unless defined(&FPSCR_FLAG_MASK);
    eval 'sub KSTK_EIP {
        my($tsk) = @_;
	    eval q((($tsk)-> ($thread->{pc})));
    }' unless defined(&KSTK_EIP);
    eval 'sub KSTK_ESP {
        my($tsk) = @_;
	    eval q((($tsk)-> ($thread->{sp})));
    }' unless defined(&KSTK_ESP);
    eval 'sub THREAD_SIZE () {(2* &PAGE_SIZE);}' unless defined(&THREAD_SIZE);
    eval 'sub get_task_struct {
        my($tsk) = @_;
	    eval q( &atomic_inc( &virt_to_page($tsk)-> &count));
    }' unless defined(&get_task_struct);
    eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
    eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
    eval 'sub cpu_relax () {
        eval q( &do { }  &while (0));
    }' unless defined(&cpu_relax);
}
1;
