require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PTRACE_H)) {
    eval 'sub __ASM_SH_PTRACE_H () {1;}' unless defined(&__ASM_SH_PTRACE_H);
    require 'asm/processor.ph';
    require 'asm/ubc.ph';
    eval 'sub REG_REG0 () {0;}' unless defined(&REG_REG0);
    eval 'sub REG_REG15 () {15;}' unless defined(&REG_REG15);
    eval 'sub REG_PC () {16;}' unless defined(&REG_PC);
    eval 'sub REG_PR () {17;}' unless defined(&REG_PR);
    eval 'sub REG_SR () {18;}' unless defined(&REG_SR);
    eval 'sub REG_GBR () {19;}' unless defined(&REG_GBR);
    eval 'sub REG_MACH () {20;}' unless defined(&REG_MACH);
    eval 'sub REG_MACL () {21;}' unless defined(&REG_MACL);
    eval 'sub REG_EXPEVT () {22;}' unless defined(&REG_EXPEVT);
    eval 'sub REG_FPREG0 () {23;}' unless defined(&REG_FPREG0);
    eval 'sub REG_FPREG15 () {38;}' unless defined(&REG_FPREG15);
    eval 'sub REG_XFREG0 () {39;}' unless defined(&REG_XFREG0);
    eval 'sub REG_XFREG15 () {54;}' unless defined(&REG_XFREG15);
    eval 'sub REG_FPSCR () {55;}' unless defined(&REG_FPSCR);
    eval 'sub REG_FPUL () {56;}' unless defined(&REG_FPUL);
    eval 'sub PTRACE_SETOPTIONS () {21;}' unless defined(&PTRACE_SETOPTIONS);
    eval 'sub PTRACE_O_TRACESYSGOOD () {0x1;}' unless defined(&PTRACE_O_TRACESYSGOOD);
    eval 'sub PTRACE_GETDSPREGS () {55;}' unless defined(&PTRACE_GETDSPREGS);
    eval 'sub PTRACE_SETDSPREGS () {56;}' unless defined(&PTRACE_SETDSPREGS);
    if(defined(&__KERNEL__)) {
	eval 'sub user_mode {
	    my($regs) = @_;
    	    eval q(((($regs)-> &sr & 0x40000000)==0));
	}' unless defined(&user_mode);
	eval 'sub instruction_pointer {
	    my($regs) = @_;
    	    eval q((($regs)-> &pc));
	}' unless defined(&instruction_pointer);
    }
}
1;
