require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&AUTOCONF_INCLUDED)) {
    sub AUTOCONF_INCLUDED () {	1;}
}
unless(defined(&CONFIG_SUPERH)) {
    sub CONFIG_SUPERH () {	1;}
}
unless(defined(&CONFIG_UID16)) {
    sub CONFIG_UID16 () {	1;}
}
unless(defined(&CONFIG_RWSEM_GENERIC_SPINLOCK)) {
    sub CONFIG_RWSEM_GENERIC_SPINLOCK () {	1;}
}
undef(&CONFIG_RWSEM_XCHGADD_ALGORITHM) if defined(&CONFIG_RWSEM_XCHGADD_ALGORITHM);
undef(&CONFIG_EXPERIMENTAL) if defined(&CONFIG_EXPERIMENTAL);
undef(&CONFIG_MODULES) if defined(&CONFIG_MODULES);
unless(defined(&CONFIG_SH_GENERIC)) {
    sub CONFIG_SH_GENERIC () {	1;}
}
undef(&CONFIG_SH_SH4202_MICRODEV) if defined(&CONFIG_SH_SH4202_MICRODEV);
undef(&CONFIG_SH_SOLUTION_ENGINE) if defined(&CONFIG_SH_SOLUTION_ENGINE);
undef(&CONFIG_SH_7751_SOLUTION_ENGINE) if defined(&CONFIG_SH_7751_SOLUTION_ENGINE);
undef(&CONFIG_SH_MOBILE_SOLUTION_ENGINE) if defined(&CONFIG_SH_MOBILE_SOLUTION_ENGINE);
undef(&CONFIG_SH_STB1_HARP) if defined(&CONFIG_SH_STB1_HARP);
undef(&CONFIG_SH_STB1_OVERDRIVE) if defined(&CONFIG_SH_STB1_OVERDRIVE);
undef(&CONFIG_SH_HP620) if defined(&CONFIG_SH_HP620);
undef(&CONFIG_SH_HP680) if defined(&CONFIG_SH_HP680);
undef(&CONFIG_SH_HP690) if defined(&CONFIG_SH_HP690);
undef(&CONFIG_SH_CQREEK) if defined(&CONFIG_SH_CQREEK);
undef(&CONFIG_SH_DMIDA) if defined(&CONFIG_SH_DMIDA);
undef(&CONFIG_SH_EC3104) if defined(&CONFIG_SH_EC3104);
undef(&CONFIG_SH_DREAMCAST) if defined(&CONFIG_SH_DREAMCAST);
undef(&CONFIG_SH_CAT68701) if defined(&CONFIG_SH_CAT68701);
undef(&CONFIG_SH_BIGSUR) if defined(&CONFIG_SH_BIGSUR);
undef(&CONFIG_SH_SH2000) if defined(&CONFIG_SH_SH2000);
undef(&CONFIG_SH_HS7729PCI) if defined(&CONFIG_SH_HS7729PCI);
undef(&CONFIG_SH_ADX) if defined(&CONFIG_SH_ADX);
undef(&CONFIG_SH_SECUREEDGE5410) if defined(&CONFIG_SH_SECUREEDGE5410);
undef(&CONFIG_SH_KEYWEST) if defined(&CONFIG_SH_KEYWEST);
undef(&CONFIG_SH_UNKNOWN) if defined(&CONFIG_SH_UNKNOWN);
unless(defined(&CONFIG_SH_RTC)) {
    sub CONFIG_SH_RTC () {	1;}
}
undef(&CONFIG_CPU_SUBTYPE_SH7300) if defined(&CONFIG_CPU_SUBTYPE_SH7300);
undef(&CONFIG_CPU_SUBTYPE_SH7707) if defined(&CONFIG_CPU_SUBTYPE_SH7707);
unless(defined(&CONFIG_CPU_SUBTYPE_SH7708)) {
    sub CONFIG_CPU_SUBTYPE_SH7708 () {	1;}
}
undef(&CONFIG_CPU_SUBTYPE_SH7709) if defined(&CONFIG_CPU_SUBTYPE_SH7709);
undef(&CONFIG_CPU_SUBTYPE_SH7750) if defined(&CONFIG_CPU_SUBTYPE_SH7750);
undef(&CONFIG_CPU_SUBTYPE_SH7751R) if defined(&CONFIG_CPU_SUBTYPE_SH7751R);
undef(&CONFIG_CPU_SUBTYPE_SH7751) if defined(&CONFIG_CPU_SUBTYPE_SH7751);
undef(&CONFIG_CPU_SUBTYPE_SH4_202) if defined(&CONFIG_CPU_SUBTYPE_SH4_202);
undef(&CONFIG_CPU_SUBTYPE_ST40STB1) if defined(&CONFIG_CPU_SUBTYPE_ST40STB1);
undef(&CONFIG_CPU_SUBTYPE_ST40GX1) if defined(&CONFIG_CPU_SUBTYPE_ST40GX1);
unless(defined(&CONFIG_CPU_SH3)) {
    sub CONFIG_CPU_SH3 () {	1;}
}
undef(&CONFIG_CPU_SH4) if defined(&CONFIG_CPU_SH4);
unless(defined(&CONFIG_CPU_LITTLE_ENDIAN)) {
    sub CONFIG_CPU_LITTLE_ENDIAN () {	1;}
}
unless(defined(&CONFIG_MEMORY_START)) {
    sub CONFIG_MEMORY_START () {	0xc000000;}
}
unless(defined(&CONFIG_MEMORY_SIZE)) {
    sub CONFIG_MEMORY_SIZE () {	0x400000;}
}
unless(defined(&CONFIG_BOOT_LINK_OFFSET)) {
    sub CONFIG_BOOT_LINK_OFFSET () {	0x210000;}
}
undef(&CONFIG_SCRATCH_SPACE) if defined(&CONFIG_SCRATCH_SPACE);
undef(&CONFIG_SH_DSP) if defined(&CONFIG_SH_DSP);
undef(&CONFIG_DISCONTIGMEM) if defined(&CONFIG_DISCONTIGMEM);
unless(defined(&CONFIG_ISA)) {
    sub CONFIG_ISA () {	1;}
}
undef(&CONFIG_EISA) if defined(&CONFIG_EISA);
undef(&CONFIG_MCA) if defined(&CONFIG_MCA);
undef(&CONFIG_SBUS) if defined(&CONFIG_SBUS);
undef(&CONFIG_NET) if defined(&CONFIG_NET);
unless(defined(&CONFIG_CF_ENABLER)) {
    sub CONFIG_CF_ENABLER () {	1;}
}
undef(&CONFIG_CF_AREA5) if defined(&CONFIG_CF_AREA5);
unless(defined(&CONFIG_CF_AREA6)) {
    sub CONFIG_CF_AREA6 () {	1;}
}
unless(defined(&CONFIG_CF_BASE_ADDR)) {
    sub CONFIG_CF_BASE_ADDR () {	0xb8000000;}
}
undef(&CONFIG_HD64461) if defined(&CONFIG_HD64461);
undef(&CONFIG_HD64465) if defined(&CONFIG_HD64465);
undef(&CONFIG_UBC_WAKEUP) if defined(&CONFIG_UBC_WAKEUP);
undef(&CONFIG_SH_DMA) if defined(&CONFIG_SH_DMA);
unless(defined(&CONFIG_SH_PCLK_FREQ)) {
    sub CONFIG_SH_PCLK_FREQ () {	(0);}
}
undef(&CONFIG_CMDLINE_BOOL) if defined(&CONFIG_CMDLINE_BOOL);
undef(&CONFIG_PCI) if defined(&CONFIG_PCI);
undef(&CONFIG_HOTPLUG) if defined(&CONFIG_HOTPLUG);
undef(&CONFIG_PCMCIA) if defined(&CONFIG_PCMCIA);
undef(&CONFIG_SYSVIPC) if defined(&CONFIG_SYSVIPC);
undef(&CONFIG_BSD_PROCESS_ACCT) if defined(&CONFIG_BSD_PROCESS_ACCT);
undef(&CONFIG_SYSCTL) if defined(&CONFIG_SYSCTL);
unless(defined(&CONFIG_KCORE_ELF)) {
    sub CONFIG_KCORE_ELF () {	1;}
}
undef(&CONFIG_KCORE_AOUT) if defined(&CONFIG_KCORE_AOUT);
unless(defined(&CONFIG_BINFMT_ELF)) {
    sub CONFIG_BINFMT_ELF () {	1;}
}
undef(&CONFIG_BINFMT_MISC) if defined(&CONFIG_BINFMT_MISC);
undef(&CONFIG_OOM_KILLER) if defined(&CONFIG_OOM_KILLER);
undef(&CONFIG_PARPORT) if defined(&CONFIG_PARPORT);
undef(&CONFIG_MTD) if defined(&CONFIG_MTD);
undef(&CONFIG_BLK_DEV_FD) if defined(&CONFIG_BLK_DEV_FD);
undef(&CONFIG_BLK_DEV_XD) if defined(&CONFIG_BLK_DEV_XD);
undef(&CONFIG_PARIDE) if defined(&CONFIG_PARIDE);
undef(&CONFIG_BLK_CPQ_DA) if defined(&CONFIG_BLK_CPQ_DA);
undef(&CONFIG_BLK_CPQ_CISS_DA) if defined(&CONFIG_BLK_CPQ_CISS_DA);
undef(&CONFIG_CISS_SCSI_TAPE) if defined(&CONFIG_CISS_SCSI_TAPE);
undef(&CONFIG_CISS_MONITOR_THREAD) if defined(&CONFIG_CISS_MONITOR_THREAD);
undef(&CONFIG_BLK_DEV_DAC960) if defined(&CONFIG_BLK_DEV_DAC960);
undef(&CONFIG_BLK_DEV_UMEM) if defined(&CONFIG_BLK_DEV_UMEM);
undef(&CONFIG_BLK_DEV_LOOP) if defined(&CONFIG_BLK_DEV_LOOP);
undef(&CONFIG_BLK_DEV_NBD) if defined(&CONFIG_BLK_DEV_NBD);
unless(defined(&CONFIG_BLK_DEV_RAM)) {
    sub CONFIG_BLK_DEV_RAM () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_RAM_SIZE)) {
    sub CONFIG_BLK_DEV_RAM_SIZE () {	(4096);}
}
unless(defined(&CONFIG_BLK_DEV_INITRD)) {
    sub CONFIG_BLK_DEV_INITRD () {	1;}
}
undef(&CONFIG_BLK_STATS) if defined(&CONFIG_BLK_STATS);
undef(&CONFIG_MD) if defined(&CONFIG_MD);
undef(&CONFIG_BLK_DEV_MD) if defined(&CONFIG_BLK_DEV_MD);
undef(&CONFIG_MD_LINEAR) if defined(&CONFIG_MD_LINEAR);
undef(&CONFIG_MD_RAID0) if defined(&CONFIG_MD_RAID0);
undef(&CONFIG_MD_RAID1) if defined(&CONFIG_MD_RAID1);
undef(&CONFIG_MD_RAID5) if defined(&CONFIG_MD_RAID5);
undef(&CONFIG_MD_MULTIPATH) if defined(&CONFIG_MD_MULTIPATH);
undef(&CONFIG_BLK_DEV_LVM) if defined(&CONFIG_BLK_DEV_LVM);
unless(defined(&CONFIG_IDE)) {
    sub CONFIG_IDE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_IDE)) {
    sub CONFIG_BLK_DEV_IDE () {	1;}
}
undef(&CONFIG_BLK_DEV_HD_IDE) if defined(&CONFIG_BLK_DEV_HD_IDE);
undef(&CONFIG_BLK_DEV_HD) if defined(&CONFIG_BLK_DEV_HD);
unless(defined(&CONFIG_BLK_DEV_IDEDISK)) {
    sub CONFIG_BLK_DEV_IDEDISK () {	1;}
}
undef(&CONFIG_IDEDISK_MULTI_MODE) if defined(&CONFIG_IDEDISK_MULTI_MODE);
undef(&CONFIG_IDEDISK_STROKE) if defined(&CONFIG_IDEDISK_STROKE);
undef(&CONFIG_BLK_DEV_IDECS) if defined(&CONFIG_BLK_DEV_IDECS);
undef(&CONFIG_BLK_DEV_IDECD) if defined(&CONFIG_BLK_DEV_IDECD);
undef(&CONFIG_BLK_DEV_IDETAPE) if defined(&CONFIG_BLK_DEV_IDETAPE);
undef(&CONFIG_BLK_DEV_IDEFLOPPY) if defined(&CONFIG_BLK_DEV_IDEFLOPPY);
undef(&CONFIG_BLK_DEV_IDESCSI) if defined(&CONFIG_BLK_DEV_IDESCSI);
undef(&CONFIG_IDE_TASK_IOCTL) if defined(&CONFIG_IDE_TASK_IOCTL);
undef(&CONFIG_BLK_DEV_CMD640) if defined(&CONFIG_BLK_DEV_CMD640);
undef(&CONFIG_BLK_DEV_CMD640_ENHANCED) if defined(&CONFIG_BLK_DEV_CMD640_ENHANCED);
undef(&CONFIG_BLK_DEV_ISAPNP) if defined(&CONFIG_BLK_DEV_ISAPNP);
undef(&CONFIG_IDE_CHIPSETS) if defined(&CONFIG_IDE_CHIPSETS);
undef(&CONFIG_IDEDMA_AUTO) if defined(&CONFIG_IDEDMA_AUTO);
undef(&CONFIG_DMA_NONPCI) if defined(&CONFIG_DMA_NONPCI);
undef(&CONFIG_BLK_DEV_ATARAID) if defined(&CONFIG_BLK_DEV_ATARAID);
undef(&CONFIG_BLK_DEV_ATARAID_PDC) if defined(&CONFIG_BLK_DEV_ATARAID_PDC);
undef(&CONFIG_BLK_DEV_ATARAID_HPT) if defined(&CONFIG_BLK_DEV_ATARAID_HPT);
undef(&CONFIG_BLK_DEV_ATARAID_MEDLEY) if defined(&CONFIG_BLK_DEV_ATARAID_MEDLEY);
undef(&CONFIG_BLK_DEV_ATARAID_SII) if defined(&CONFIG_BLK_DEV_ATARAID_SII);
undef(&CONFIG_SCSI) if defined(&CONFIG_SCSI);
undef(&CONFIG_CD_NO_IDESCSI) if defined(&CONFIG_CD_NO_IDESCSI);
undef(&CONFIG_INPUT) if defined(&CONFIG_INPUT);
undef(&CONFIG_INPUT_KEYBDEV) if defined(&CONFIG_INPUT_KEYBDEV);
undef(&CONFIG_INPUT_MOUSEDEV) if defined(&CONFIG_INPUT_MOUSEDEV);
undef(&CONFIG_INPUT_JOYDEV) if defined(&CONFIG_INPUT_JOYDEV);
undef(&CONFIG_INPUT_EVDEV) if defined(&CONFIG_INPUT_EVDEV);
undef(&CONFIG_INPUT_UINPUT) if defined(&CONFIG_INPUT_UINPUT);
undef(&CONFIG_VT) if defined(&CONFIG_VT);
undef(&CONFIG_SERIAL) if defined(&CONFIG_SERIAL);
unless(defined(&CONFIG_SH_SCI)) {
    sub CONFIG_SH_SCI () {	1;}
}
unless(defined(&CONFIG_SERIAL_CONSOLE)) {
    sub CONFIG_SERIAL_CONSOLE () {	1;}
}
undef(&CONFIG_UNIX98_PTYS) if defined(&CONFIG_UNIX98_PTYS);
undef(&CONFIG_HEARTBEAT) if defined(&CONFIG_HEARTBEAT);
undef(&CONFIG_INPUT_GAMEPORT) if defined(&CONFIG_INPUT_GAMEPORT);
undef(&CONFIG_PSMOUSE) if defined(&CONFIG_PSMOUSE);
undef(&CONFIG_WATCHDOG) if defined(&CONFIG_WATCHDOG);
undef(&CONFIG_RTC) if defined(&CONFIG_RTC);
undef(&CONFIG_QUOTA) if defined(&CONFIG_QUOTA);
undef(&CONFIG_QFMT_V2) if defined(&CONFIG_QFMT_V2);
undef(&CONFIG_AUTOFS_FS) if defined(&CONFIG_AUTOFS_FS);
undef(&CONFIG_AUTOFS4_FS) if defined(&CONFIG_AUTOFS4_FS);
undef(&CONFIG_REISERFS_FS) if defined(&CONFIG_REISERFS_FS);
undef(&CONFIG_REISERFS_CHECK) if defined(&CONFIG_REISERFS_CHECK);
undef(&CONFIG_REISERFS_PROC_INFO) if defined(&CONFIG_REISERFS_PROC_INFO);
undef(&CONFIG_ADFS_FS) if defined(&CONFIG_ADFS_FS);
undef(&CONFIG_ADFS_FS_RW) if defined(&CONFIG_ADFS_FS_RW);
undef(&CONFIG_AFFS_FS) if defined(&CONFIG_AFFS_FS);
undef(&CONFIG_HFS_FS) if defined(&CONFIG_HFS_FS);
undef(&CONFIG_HFSPLUS_FS) if defined(&CONFIG_HFSPLUS_FS);
undef(&CONFIG_BEFS_FS) if defined(&CONFIG_BEFS_FS);
undef(&CONFIG_BEFS_DEBUG) if defined(&CONFIG_BEFS_DEBUG);
undef(&CONFIG_BFS_FS) if defined(&CONFIG_BFS_FS);
undef(&CONFIG_EXT3_FS) if defined(&CONFIG_EXT3_FS);
undef(&CONFIG_JBD) if defined(&CONFIG_JBD);
undef(&CONFIG_JBD_DEBUG) if defined(&CONFIG_JBD_DEBUG);
undef(&CONFIG_FAT_FS) if defined(&CONFIG_FAT_FS);
undef(&CONFIG_MSDOS_FS) if defined(&CONFIG_MSDOS_FS);
undef(&CONFIG_UMSDOS_FS) if defined(&CONFIG_UMSDOS_FS);
undef(&CONFIG_VFAT_FS) if defined(&CONFIG_VFAT_FS);
undef(&CONFIG_EFS_FS) if defined(&CONFIG_EFS_FS);
undef(&CONFIG_JFFS_FS) if defined(&CONFIG_JFFS_FS);
undef(&CONFIG_JFFS2_FS) if defined(&CONFIG_JFFS2_FS);
undef(&CONFIG_CRAMFS) if defined(&CONFIG_CRAMFS);
undef(&CONFIG_TMPFS) if defined(&CONFIG_TMPFS);
unless(defined(&CONFIG_RAMFS)) {
    sub CONFIG_RAMFS () {	1;}
}
undef(&CONFIG_ISO9660_FS) if defined(&CONFIG_ISO9660_FS);
undef(&CONFIG_JOLIET) if defined(&CONFIG_JOLIET);
undef(&CONFIG_ZISOFS) if defined(&CONFIG_ZISOFS);
undef(&CONFIG_JFS_FS) if defined(&CONFIG_JFS_FS);
undef(&CONFIG_JFS_DEBUG) if defined(&CONFIG_JFS_DEBUG);
undef(&CONFIG_JFS_STATISTICS) if defined(&CONFIG_JFS_STATISTICS);
undef(&CONFIG_MINIX_FS) if defined(&CONFIG_MINIX_FS);
undef(&CONFIG_VXFS_FS) if defined(&CONFIG_VXFS_FS);
undef(&CONFIG_NTFS_FS) if defined(&CONFIG_NTFS_FS);
undef(&CONFIG_NTFS_RW) if defined(&CONFIG_NTFS_RW);
undef(&CONFIG_HPFS_FS) if defined(&CONFIG_HPFS_FS);
unless(defined(&CONFIG_PROC_FS)) {
    sub CONFIG_PROC_FS () {	1;}
}
undef(&CONFIG_DEVFS_FS) if defined(&CONFIG_DEVFS_FS);
undef(&CONFIG_DEVFS_MOUNT) if defined(&CONFIG_DEVFS_MOUNT);
undef(&CONFIG_DEVFS_DEBUG) if defined(&CONFIG_DEVFS_DEBUG);
undef(&CONFIG_DEVPTS_FS) if defined(&CONFIG_DEVPTS_FS);
undef(&CONFIG_QNX4FS_FS) if defined(&CONFIG_QNX4FS_FS);
undef(&CONFIG_QNX4FS_RW) if defined(&CONFIG_QNX4FS_RW);
undef(&CONFIG_ROMFS_FS) if defined(&CONFIG_ROMFS_FS);
unless(defined(&CONFIG_EXT2_FS)) {
    sub CONFIG_EXT2_FS () {	1;}
}
undef(&CONFIG_SYSV_FS) if defined(&CONFIG_SYSV_FS);
undef(&CONFIG_UDF_FS) if defined(&CONFIG_UDF_FS);
undef(&CONFIG_UDF_RW) if defined(&CONFIG_UDF_RW);
undef(&CONFIG_UFS_FS) if defined(&CONFIG_UFS_FS);
undef(&CONFIG_UFS_FS_WRITE) if defined(&CONFIG_UFS_FS_WRITE);
undef(&CONFIG_XFS_FS) if defined(&CONFIG_XFS_FS);
undef(&CONFIG_XFS_QUOTA) if defined(&CONFIG_XFS_QUOTA);
undef(&CONFIG_XFS_RT) if defined(&CONFIG_XFS_RT);
undef(&CONFIG_XFS_TRACE) if defined(&CONFIG_XFS_TRACE);
undef(&CONFIG_XFS_DEBUG) if defined(&CONFIG_XFS_DEBUG);
undef(&CONFIG_NCPFS_NLS) if defined(&CONFIG_NCPFS_NLS);
undef(&CONFIG_SMB_FS) if defined(&CONFIG_SMB_FS);
undef(&CONFIG_ZISOFS_FS) if defined(&CONFIG_ZISOFS_FS);
undef(&CONFIG_PARTITION_ADVANCED) if defined(&CONFIG_PARTITION_ADVANCED);
unless(defined(&CONFIG_MSDOS_PARTITION)) {
    sub CONFIG_MSDOS_PARTITION () {	1;}
}
undef(&CONFIG_SMB_NLS) if defined(&CONFIG_SMB_NLS);
undef(&CONFIG_NLS) if defined(&CONFIG_NLS);
undef(&CONFIG_VIDEO_DEV) if defined(&CONFIG_VIDEO_DEV);
undef(&CONFIG_SOUND) if defined(&CONFIG_SOUND);
undef(&CONFIG_MAGIC_SYSRQ) if defined(&CONFIG_MAGIC_SYSRQ);
unless(defined(&CONFIG_SH_STANDARD_BIOS)) {
    sub CONFIG_SH_STANDARD_BIOS () {	1;}
}
unless(defined(&CONFIG_SH_EARLY_PRINTK)) {
    sub CONFIG_SH_EARLY_PRINTK () {	1;}
}
undef(&CONFIG_SH_KGDB) if defined(&CONFIG_SH_KGDB);
unless(defined(&CONFIG_LOG_BUF_SHIFT)) {
    sub CONFIG_LOG_BUF_SHIFT () {	(0);}
}
undef(&CONFIG_CRYPTO) if defined(&CONFIG_CRYPTO);
undef(&CONFIG_CRC32) if defined(&CONFIG_CRC32);
undef(&CONFIG_ZLIB_INFLATE) if defined(&CONFIG_ZLIB_INFLATE);
undef(&CONFIG_ZLIB_DEFLATE) if defined(&CONFIG_ZLIB_DEFLATE);
1;
