require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ATOMICITY_H)) {
    eval 'sub _ATOMICITY_H () {1;}' unless defined(&_ATOMICITY_H);
    require 'inttypes.ph';
    warn("stub\ atomicity\ functions\ are\ not\ really\ atomic");
    eval 'sub exchange_and_add {
        my($mem,$val) = @_;
	    eval q({ \'int\'  &result = *$mem; *$mem += $val;  &result; });
    }' unless defined(&exchange_and_add);
    eval 'sub atomic_add {
        my($mem,$val) = @_;
	    eval q({ *$mem += $val; });
    }' unless defined(&atomic_add);
    eval 'sub compare_and_swap {
        my($p,$oldval,$newval) = @_;
	    eval q({  &if (*$p != $oldval) 0; *$p = $newval; 1; });
    }' unless defined(&compare_and_swap);
}
1;
