require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SIGCONTEXT)) {
    sub SIGCONTEXT () {	'int'  &_a2, 'int'  &_a3, 'int'  &_a4, 'struct sigcontext';}
}
unless(defined(&SIGCONTEXT_EXTRA_ARGS)) {
    sub SIGCONTEXT_EXTRA_ARGS () {	 &_a2,  &_a3,  &_a4,;}
}
unless(defined(&GET_PC)) {
    sub GET_PC {
	my($ctx) = @_;
	eval q((( &void *)  ($ctx->{sc_pc})));
    }
}
unless(defined(&GET_FRAME)) {
    sub GET_FRAME {
	my($ctx) = @_;
	eval q((( &void *)  ($ctx->{sc_regs[14]})));
    }
}
unless(defined(&GET_STACK)) {
    sub GET_STACK {
	my($ctx) = @_;
	eval q((( &void *)  ($ctx->{sc_regs[15]})));
    }
}
unless(defined(&CALL_SIGHANDLER)) {
    sub CALL_SIGHANDLER {
	my($handler, $signo, $ctx) = @_;
	eval q(($handler)(($signo),  &SIGCONTEXT_EXTRA_ARGS ($ctx)));
    }
}
1;
