require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_ATOMIC_H)) {
    eval 'sub __ASM_SH_ATOMIC_H () {1;}' unless defined(&__ASM_SH_ATOMIC_H);
    eval 'sub ATOMIC_INIT {
        my($i) = @_;
	    eval q(( ( &atomic_t) { ($i) } ));
    }' unless defined(&ATOMIC_INIT);
    eval 'sub atomic_read {
        my($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic_read);
    eval 'sub atomic_set {
        my($v,$i) = @_;
	    eval q((($v)-> &counter = ($i)));
    }' unless defined(&atomic_set);
    require 'asm/system.ph';
    eval 'sub atomic_sub {
        my($i,$v) = @_;
	    eval q({ my $flags;  &save_and_cli; *$v -= $i;  &restore_flags( $flags); });
    }' unless defined(&atomic_sub);
    eval 'sub atomic_add_return {
        my($i,$v) = @_;
	    eval q({ my $temp,  &flags;  &save_and_cli;  $temp = *$v;  $temp += $i; *$v =  $temp;  &restore_flags( &flags);  $temp; });
    }' unless defined(&atomic_add_return);
    eval 'sub atomic_sub_return {
        my($i,$v) = @_;
	    eval q({ my $temp,  &flags;  &save_and_cli;  $temp = *$v;  $temp -= $i; *$v =  $temp;  &restore_flags( &flags);  $temp; });
    }' unless defined(&atomic_sub_return);
    eval 'sub atomic_dec_return {
        my($v) = @_;
	    eval q( &atomic_sub_return(1,($v)));
    }' unless defined(&atomic_dec_return);
    eval 'sub atomic_inc_return {
        my($v) = @_;
	    eval q( &atomic_add_return(1,($v)));
    }' unless defined(&atomic_inc_return);
    eval 'sub atomic_sub_and_test {
        my($i,$v) = @_;
	    eval q(( &atomic_sub_return(($i), ($v)) == 0));
    }' unless defined(&atomic_sub_and_test);
    eval 'sub atomic_dec_and_test {
        my($v) = @_;
	    eval q(( &atomic_sub_return(1, ($v)) == 0));
    }' unless defined(&atomic_dec_and_test);
    eval 'sub atomic_inc {
        my($v) = @_;
	    eval q( &atomic_add(1,($v)));
    }' unless defined(&atomic_inc);
    eval 'sub atomic_dec {
        my($v) = @_;
	    eval q( &atomic_sub(1,($v)));
    }' unless defined(&atomic_dec);
    eval 'sub atomic_clear_mask {
        my($mask,$v) = @_;
	    eval q({ my $flags;  &save_and_cli; *$v &= ~$mask;  &restore_flags( $flags); });
    }' unless defined(&atomic_clear_mask);
    eval 'sub atomic_set_mask {
        my($mask,$v) = @_;
	    eval q({ my $flags;  &save_and_cli; *$v |= $mask;  &restore_flags( $flags); });
    }' unless defined(&atomic_set_mask);
    eval 'sub smp_mb__before_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_dec);
    eval 'sub smp_mb__after_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_dec);
    eval 'sub smp_mb__before_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_inc);
    eval 'sub smp_mb__after_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_inc);
}
1;
