require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_BYTEORDER_H)) {
    eval 'sub __ASM_SH_BYTEORDER_H () {1;}' unless defined(&__ASM_SH_BYTEORDER_H);
    require 'asm/types.ph';
    eval 'sub ___arch__swab32 {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&___arch__swab32);
    eval 'sub ___arch__swab16 {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&___arch__swab16);
    eval 'sub __arch__swab32 {
        my($x) = @_;
	    eval q( &___arch__swab32($x));
    }' unless defined(&__arch__swab32);
    eval 'sub __arch__swab16 {
        my($x) = @_;
	    eval q( &___arch__swab16($x));
    }' unless defined(&__arch__swab16);
    if(!defined( &__STRICT_ANSI__) || defined( &__KERNEL__)) {
	eval 'sub __BYTEORDER_HAS_U64__ () {1;}' unless defined(&__BYTEORDER_HAS_U64__);
	eval 'sub __SWAB_64_THRU_32__ () {1;}' unless defined(&__SWAB_64_THRU_32__);
    }
    if(defined(&__LITTLE_ENDIAN__)) {
	require 'linux/byteorder/little_endian.ph';
    } else {
	require 'linux/byteorder/big_endian.ph';
    }
}
1;
