require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_ELF_H)) {
    eval 'sub __ASM_SH_ELF_H () {1;}' unless defined(&__ASM_SH_ELF_H);
    require 'asm/ptrace.ph';
    require 'asm/user.ph';
    eval 'sub ELF_NGREG () {($sizeof{\'struct pt_regs\'} / $sizeof{ &elf_greg_t});}' unless defined(&ELF_NGREG);
    eval 'sub elf_check_arch {
        my($x) = @_;
	    eval q(( ($x)-> &e_machine ==  &EM_SH ));
    }' unless defined(&elf_check_arch);
    eval 'sub ELF_CLASS () { &ELFCLASS32;}' unless defined(&ELF_CLASS);
    if(defined(&__LITTLE_ENDIAN__)) {
	eval 'sub ELF_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_DATA);
    } else {
	eval 'sub ELF_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_DATA);
    }
    eval 'sub ELF_ARCH () { &EM_SH;}' unless defined(&ELF_ARCH);
    eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
    eval 'sub ELF_EXEC_PAGESIZE () {4096;}' unless defined(&ELF_EXEC_PAGESIZE);
    eval 'sub ELF_ET_DYN_BASE () {(2*  &TASK_SIZE / 3);}' unless defined(&ELF_ET_DYN_BASE);
    eval 'sub ELF_CORE_COPY_REGS {
        my($_dest,$_regs) = @_;
	    eval q( &memcpy( &$_dest, $_regs, $sizeof{\'struct pt_regs\'}););
    }' unless defined(&ELF_CORE_COPY_REGS);
    eval 'sub ELF_HWCAP () {(0);}' unless defined(&ELF_HWCAP);
    eval 'sub ELF_PLATFORM () {( &NULL);}' unless defined(&ELF_PLATFORM);
    eval 'sub ELF_PLAT_INIT {
        my($_r, $load_addr) = @_;
	    eval q( &do {  ($_r->{regs[0]})=0;  ($_r->{regs[1]})=0;  ($_r->{regs[2]})=0;  ($_r->{regs[3]})=0;  ($_r->{regs[4]})=0;  ($_r->{regs[5]})=0;  ($_r->{regs[6]})=0;  ($_r->{regs[7]})=0;  ($_r->{regs[8]})=0;  ($_r->{regs[9]})=0;  ($_r->{regs[10]})=0;  ($_r->{regs[11]})=0;  ($_r->{regs[12]})=0;  ($_r->{regs[13]})=0;  ($_r->{regs[14]})=0;  ($_r->{sr}) =  &SR_FD; }  &while (0));
    }' unless defined(&ELF_PLAT_INIT);
    if(defined(&__KERNEL__)) {
	eval 'sub SET_PERSONALITY {
	    my($ex, $ibcs2) = @_;
    	    eval q( &set_personality( &PER_LINUX_32BIT));
	}' unless defined(&SET_PERSONALITY);
    }
}
1;
