require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_HD64461)) {
    eval 'sub __ASM_SH_HD64461 () {1;}' unless defined(&__ASM_SH_HD64461);
    require 'linux/config.ph';
    eval 'sub HD64461_STBCR () {0x10000;}' unless defined(&HD64461_STBCR);
    eval 'sub HD64461_SYSCR () {0x10002;}' unless defined(&HD64461_SYSCR);
    eval 'sub HD64461_SCPUCR () {0x10004;}' unless defined(&HD64461_SCPUCR);
    eval 'sub HD64461_LCDCBAR () {0x11000;}' unless defined(&HD64461_LCDCBAR);
    eval 'sub HD64461_LCDCLOR () {0x11002;}' unless defined(&HD64461_LCDCLOR);
    eval 'sub HD64461_LCDCCRR () {0x11004;}' unless defined(&HD64461_LCDCCRR);
    eval 'sub HD64461_LDR1 () {0x11010;}' unless defined(&HD64461_LDR1);
    eval 'sub HD64461_LDR2 () {0x11012;}' unless defined(&HD64461_LDR2);
    eval 'sub HD64461_LDHNCR () {0x11014;}' unless defined(&HD64461_LDHNCR);
    eval 'sub HD64461_LDHNSR () {0x11016;}' unless defined(&HD64461_LDHNSR);
    eval 'sub HD64461_LDVNTR () {0x11018;}' unless defined(&HD64461_LDVNTR);
    eval 'sub HD64461_LDVNDR () {0x1101a;}' unless defined(&HD64461_LDVNDR);
    eval 'sub HD64461_LDVSPR () {0x1101c;}' unless defined(&HD64461_LDVSPR);
    eval 'sub HD64461_LDR3 () {0x1101e;}' unless defined(&HD64461_LDR3);
    eval 'sub HD64461_CPTWAR () {0x11030;}' unless defined(&HD64461_CPTWAR);
    eval 'sub HD64461_CPTWDR () {0x11032;}' unless defined(&HD64461_CPTWDR);
    eval 'sub HD64461_CPTRAR () {0x11034;}' unless defined(&HD64461_CPTRAR);
    eval 'sub HD64461_CPTRDR () {0x11036;}' unless defined(&HD64461_CPTRDR);
    eval 'sub HD64461_PCC0ISR () {0x12000;}' unless defined(&HD64461_PCC0ISR);
    eval 'sub HD64461_PCC0GCR () {0x12002;}' unless defined(&HD64461_PCC0GCR);
    eval 'sub HD64461_PCC0CSCR () {0x12004;}' unless defined(&HD64461_PCC0CSCR);
    eval 'sub HD64461_PCC0CSCIER () {0x12006;}' unless defined(&HD64461_PCC0CSCIER);
    eval 'sub HD64461_PCC0SCR () {0x12008;}' unless defined(&HD64461_PCC0SCR);
    eval 'sub HD64461_PCC1ISR () {0x12010;}' unless defined(&HD64461_PCC1ISR);
    eval 'sub HD64461_PCC1GCR () {0x12012;}' unless defined(&HD64461_PCC1GCR);
    eval 'sub HD64461_PCC1CSCR () {0x12014;}' unless defined(&HD64461_PCC1CSCR);
    eval 'sub HD64461_PCC1CSCIER () {0x12016;}' unless defined(&HD64461_PCC1CSCIER);
    eval 'sub HD64461_PCC1SCR () {0x12018;}' unless defined(&HD64461_PCC1SCR);
    eval 'sub HD64461_P0OCR () {0x1202a;}' unless defined(&HD64461_P0OCR);
    eval 'sub HD64461_P1OCR () {0x1202c;}' unless defined(&HD64461_P1OCR);
    eval 'sub HD64461_PGCR () {0x1202e;}' unless defined(&HD64461_PGCR);
    eval 'sub HD64461_GPACR () {0x14000;}' unless defined(&HD64461_GPACR);
    eval 'sub HD64461_GPBCR () {0x14002;}' unless defined(&HD64461_GPBCR);
    eval 'sub HD64461_GPCCR () {0x14004;}' unless defined(&HD64461_GPCCR);
    eval 'sub HD64461_GPDCR () {0x14006;}' unless defined(&HD64461_GPDCR);
    eval 'sub HD64461_GPADR () {0x14010;}' unless defined(&HD64461_GPADR);
    eval 'sub HD64461_GPBDR () {0x14012;}' unless defined(&HD64461_GPBDR);
    eval 'sub HD64461_GPCDR () {0x14014;}' unless defined(&HD64461_GPCDR);
    eval 'sub HD64461_GPDDR () {0x14016;}' unless defined(&HD64461_GPDDR);
    eval 'sub HD64461_GPAICR () {0x14020;}' unless defined(&HD64461_GPAICR);
    eval 'sub HD64461_GPBICR () {0x14022;}' unless defined(&HD64461_GPBICR);
    eval 'sub HD64461_GPCICR () {0x14024;}' unless defined(&HD64461_GPCICR);
    eval 'sub HD64461_GPDICR () {0x14026;}' unless defined(&HD64461_GPDICR);
    eval 'sub HD64461_GPAISR () {0x14040;}' unless defined(&HD64461_GPAISR);
    eval 'sub HD64461_GPBISR () {0x14042;}' unless defined(&HD64461_GPBISR);
    eval 'sub HD64461_GPCISR () {0x14044;}' unless defined(&HD64461_GPCISR);
    eval 'sub HD64461_GPDISR () {0x14046;}' unless defined(&HD64461_GPDISR);
    eval 'sub HD64461_NIRR () {0x15000;}' unless defined(&HD64461_NIRR);
    eval 'sub HD64461_NIMR () {0x15002;}' unless defined(&HD64461_NIMR);
    unless(defined(&CONFIG_HD64461_IOBASE)) {
	eval 'sub CONFIG_HD64461_IOBASE () {0xb0000000;}' unless defined(&CONFIG_HD64461_IOBASE);
    }
    unless(defined(&CONFIG_HD64461_IRQ)) {
	eval 'sub CONFIG_HD64461_IRQ () {36;}' unless defined(&CONFIG_HD64461_IRQ);
    }
    eval 'sub HD64461_IRQBASE () { &OFFCHIP_IRQ_BASE;}' unless defined(&HD64461_IRQBASE);
    eval 'sub HD64461_IRQ_NUM () {16;}' unless defined(&HD64461_IRQ_NUM);
}
1;
