require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_IDE_H)) {
    eval 'sub __ASM_SH_IDE_H () {1;}' unless defined(&__ASM_SH_IDE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'asm-generic/ide_iops.ph';
	require 'asm/machvec.ph';
	unless(defined(&MAX_HWIFS)) {
	    eval 'sub MAX_HWIFS () {4;}' unless defined(&MAX_HWIFS);
	}
	eval 'sub ide_default_irq_hs7729pci {
	    my($base) = @_;
    	    eval q({  &switch ($base) {  &case 0x1f0: 9;  &case 0x170: 14;  &default: 0; } });
	}' unless defined(&ide_default_irq_hs7729pci);
	eval 'sub ide_default_irq_hp600 {
	    my($base) = @_;
    	    eval q({  &switch ($base) {  &case 0x1f0: 93;  &case 0x170: 94;  &default: 0; } });
	}' unless defined(&ide_default_irq_hp600);
	eval 'sub ide_default_irq {
	    my($base) = @_;
    	    eval q({  &if ( &MACH_HP600) {  &ide_default_irq_hp600($base); }  &if ( &MACH_HS7729PCI) {  &ide_default_irq_hs7729pci($base); }  &switch ($base) {  &case 0x1f0: 14;  &case 0x170: 15;  &default: 0; } });
	}' unless defined(&ide_default_irq);
	eval 'sub ide_default_io_base_hp600 {
	    my($index) = @_;
    	    eval q({  &switch ($index) {  &case 0: 0x1f0;  &case 1: 0x170;  &default: 0; } });
	}' unless defined(&ide_default_io_base_hp600);
	eval 'sub ide_default_io_base {
	    my($index) = @_;
    	    eval q({  &if ( &MACH_HP600) {  &ide_default_io_base_hp600($index); }  &switch ($index) {  &case 0: 0x1f0;  &case 1: 0x170;  &default: 0; } });
	}' unless defined(&ide_default_io_base);
	eval 'sub ide_init_hwif_ports {
	    my($hw,$data_port,$ctrl_port,$irq) = @_;
    	    eval q({  &ide_ioreg_t  &reg = $data_port; \'int\'  &i;  &for ( &i =  &IDE_DATA_OFFSET;  &i <=  &IDE_STATUS_OFFSET;  &i++) {  ($hw->{io_ports[&i]}) =  &reg;  &reg += 1; }  &if ($ctrl_port) {  ($hw->{io_ports[&IDE_CONTROL_OFFSET]}) = $ctrl_port; }  &else {  ($hw->{io_ports[&IDE_CONTROL_OFFSET]}) =  ($hw->{io_ports[&IDE_DATA_OFFSET]}) + 0x206; }  &if ($irq !=  &NULL) *$irq = 0;  ($hw->{io_ports[&IDE_IRQ_OFFSET]}) = 0; });
	}' unless defined(&ide_init_hwif_ports);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub ide_init_default_hwifs {
	    my($void) = @_;
    	    eval q({ });
	}' unless defined(&ide_init_default_hwifs);
    }
}
1;
