require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SH_IO_SNAPGEAR_H)) {
    eval 'sub _ASM_SH_IO_SNAPGEAR_H () {1;}' unless defined(&_ASM_SH_IO_SNAPGEAR_H);
    require 'asm/irq.ph';
    if(defined( &__SH4__)) {
	eval 'sub IRL0_IRQ () {2;}' unless defined(&IRL0_IRQ);
	eval 'sub IRL0_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRL0_IPR_ADDR);
	eval 'sub IRL0_IPR_POS () {3;}' unless defined(&IRL0_IPR_POS);
	eval 'sub IRL0_PRIORITY () {13;}' unless defined(&IRL0_PRIORITY);
	eval 'sub IRL1_IRQ () {5;}' unless defined(&IRL1_IRQ);
	eval 'sub IRL1_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRL1_IPR_ADDR);
	eval 'sub IRL1_IPR_POS () {2;}' unless defined(&IRL1_IPR_POS);
	eval 'sub IRL1_PRIORITY () {10;}' unless defined(&IRL1_PRIORITY);
	eval 'sub IRL2_IRQ () {8;}' unless defined(&IRL2_IRQ);
	eval 'sub IRL2_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRL2_IPR_ADDR);
	eval 'sub IRL2_IPR_POS () {1;}' unless defined(&IRL2_IPR_POS);
	eval 'sub IRL2_PRIORITY () {7;}' unless defined(&IRL2_PRIORITY);
	eval 'sub IRL3_IRQ () {11;}' unless defined(&IRL3_IRQ);
	eval 'sub IRL3_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRL3_IPR_ADDR);
	eval 'sub IRL3_IPR_POS () {0;}' unless defined(&IRL3_IPR_POS);
	eval 'sub IRL3_PRIORITY () {4;}' unless defined(&IRL3_PRIORITY);
    }
    require 'asm/io_generic.ph';
    if(defined(&__WANT_IO_DEF)) {
	eval 'sub __inb () { &snapgear_inb;}' unless defined(&__inb);
	eval 'sub __inw () { &snapgear_inw;}' unless defined(&__inw);
	eval 'sub __inl () { &snapgear_inl;}' unless defined(&__inl);
	eval 'sub __outb () { &snapgear_outb;}' unless defined(&__outb);
	eval 'sub __outw () { &snapgear_outw;}' unless defined(&__outw);
	eval 'sub __outl () { &snapgear_outl;}' unless defined(&__outl);
	eval 'sub __inb_p () { &snapgear_inb_p;}' unless defined(&__inb_p);
	eval 'sub __inw_p () { &snapgear_inw;}' unless defined(&__inw_p);
	eval 'sub __inl_p () { &snapgear_inl;}' unless defined(&__inl_p);
	eval 'sub __outb_p () { &snapgear_outb_p;}' unless defined(&__outb_p);
	eval 'sub __outw_p () { &snapgear_outw;}' unless defined(&__outw_p);
	eval 'sub __outl_p () { &snapgear_outl;}' unless defined(&__outl_p);
	eval 'sub __insb () { &snapgear_insb;}' unless defined(&__insb);
	eval 'sub __insw () { &snapgear_insw;}' unless defined(&__insw);
	eval 'sub __insl () { &snapgear_insl;}' unless defined(&__insl);
	eval 'sub __outsb () { &snapgear_outsb;}' unless defined(&__outsb);
	eval 'sub __outsw () { &snapgear_outsw;}' unless defined(&__outsw);
	eval 'sub __outsl () { &snapgear_outsl;}' unless defined(&__outsl);
	eval 'sub __readb () { &snapgear_readb;}' unless defined(&__readb);
	eval 'sub __readw () { &snapgear_readw;}' unless defined(&__readw);
	eval 'sub __readl () { &snapgear_readl;}' unless defined(&__readl);
	eval 'sub __writeb () { &snapgear_writeb;}' unless defined(&__writeb);
	eval 'sub __writew () { &snapgear_writew;}' unless defined(&__writew);
	eval 'sub __writel () { &snapgear_writel;}' unless defined(&__writel);
	eval 'sub __isa_port2addr () { &snapgear_isa_port2addr;}' unless defined(&__isa_port2addr);
	eval 'sub __ioremap () { &generic_ioremap;}' unless defined(&__ioremap);
	eval 'sub __iounmap () { &generic_iounmap;}' unless defined(&__iounmap);
    }
    if(defined(&CONFIG_SH_SECUREEDGE5410)) {
	eval 'sub SECUREEDGE_IOPORT_ADDR () {(( &volatile \'short\' *) 0xb0000000);}' unless defined(&SECUREEDGE_IOPORT_ADDR);
	eval 'sub SECUREEDGE_WRITE_IOPORT {
	    my($val, $mask) = @_;
    	    eval q((* &SECUREEDGE_IOPORT_ADDR = ( &secureedge5410_ioport = (( &secureedge5410_ioport & ~($mask)) | (($val) & ($mask))))));
	}' unless defined(&SECUREEDGE_WRITE_IOPORT);
	eval 'sub SECUREEDGE_READ_IOPORT () {
	    eval q(((* &SECUREEDGE_IOPORT_ADDR&0x817) | ( &secureedge5410_ioport&~0x817)));
	}' unless defined(&SECUREEDGE_READ_IOPORT);
    }
}
1;
