require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_IRQ_SH7300_H)) {
    eval 'sub __ASM_SH_IRQ_SH7300_H () {1;}' unless defined(&__ASM_SH_IRQ_SH7300_H);
    require 'linux/config.ph';
    require 'asm/machvec.ph';
    require 'asm/ptrace.ph';
    eval 'sub INTC_IPRA () {0xa414fee2;}' unless defined(&INTC_IPRA);
    eval 'sub INTC_IPRB () {0xa414fee4;}' unless defined(&INTC_IPRB);
    eval 'sub INTC_IPRC () {0xa4140016;}' unless defined(&INTC_IPRC);
    eval 'sub INTC_IPRD () {0xa4140018;}' unless defined(&INTC_IPRD);
    eval 'sub INTC_IPRE () {0xa414001a;}' unless defined(&INTC_IPRE);
    eval 'sub INTC_IPRF () {0xa4080000;}' unless defined(&INTC_IPRF);
    eval 'sub INTC_IPRG () {0xa4080002;}' unless defined(&INTC_IPRG);
    eval 'sub INTC_IPRH () {0xa4080004;}' unless defined(&INTC_IPRH);
    eval 'sub INTC_IPRI () {0xa4080006;}' unless defined(&INTC_IPRI);
    eval 'sub INTC_IPRJ () {0xa4080008;}' unless defined(&INTC_IPRJ);
    eval 'sub INTC_IMR0 () {0xa4080040;}' unless defined(&INTC_IMR0);
    eval 'sub INTC_IMR1 () {0xa4080042;}' unless defined(&INTC_IMR1);
    eval 'sub INTC_IMR2 () {0xa4080044;}' unless defined(&INTC_IMR2);
    eval 'sub INTC_IMR3 () {0xa4080046;}' unless defined(&INTC_IMR3);
    eval 'sub INTC_IMR4 () {0xa4080048;}' unless defined(&INTC_IMR4);
    eval 'sub INTC_IMR5 () {0xa408004a;}' unless defined(&INTC_IMR5);
    eval 'sub INTC_IMR6 () {0xa408004c;}' unless defined(&INTC_IMR6);
    eval 'sub INTC_IMR7 () {0xa408004e;}' unless defined(&INTC_IMR7);
    eval 'sub INTC_IMR8 () {0xa4080050;}' unless defined(&INTC_IMR8);
    eval 'sub INTC_IMR9 () {0xa4080052;}' unless defined(&INTC_IMR9);
    eval 'sub INTC_IMR10 () {0xa4080054;}' unless defined(&INTC_IMR10);
    eval 'sub INTC_IMCR0 () {0xa4080060;}' unless defined(&INTC_IMCR0);
    eval 'sub INTC_IMCR1 () {0xa4080062;}' unless defined(&INTC_IMCR1);
    eval 'sub INTC_IMCR2 () {0xa4080064;}' unless defined(&INTC_IMCR2);
    eval 'sub INTC_IMCR3 () {0xa4080066;}' unless defined(&INTC_IMCR3);
    eval 'sub INTC_IMCR4 () {0xa4080068;}' unless defined(&INTC_IMCR4);
    eval 'sub INTC_IMCR5 () {0xa408006a;}' unless defined(&INTC_IMCR5);
    eval 'sub INTC_IMCR6 () {0xa408006c;}' unless defined(&INTC_IMCR6);
    eval 'sub INTC_IMCR7 () {0xa408006e;}' unless defined(&INTC_IMCR7);
    eval 'sub INTC_IMCR8 () {0xa4080070;}' unless defined(&INTC_IMCR8);
    eval 'sub INTC_IMCR9 () {0xa4080072;}' unless defined(&INTC_IMCR9);
    eval 'sub INTC_IMCR10 () {0xa4080074;}' unless defined(&INTC_IMCR10);
    eval 'sub INTC_ICR0 () {0xa414fee0;}' unless defined(&INTC_ICR0);
    eval 'sub INTC_ICR1 () {0xa4140010;}' unless defined(&INTC_ICR1);
    eval 'sub INTC_IRR0 () {0xa4140004;}' unless defined(&INTC_IRR0);
    eval 'sub TMU0_IRQ () {16;}' unless defined(&TMU0_IRQ);
    eval 'sub TMU0_IPR_ADDR () { &INTC_IPRA;}' unless defined(&TMU0_IPR_ADDR);
    eval 'sub TMU0_IPR_POS () {3;}' unless defined(&TMU0_IPR_POS);
    eval 'sub TMU0_PRIORITY () {2;}' unless defined(&TMU0_PRIORITY);
    eval 'sub TIMER_IRQ () {16;}' unless defined(&TIMER_IRQ);
    eval 'sub TIMER_IPR_ADDR () { &INTC_IPRA;}' unless defined(&TIMER_IPR_ADDR);
    eval 'sub TIMER_IPR_POS () {3;}' unless defined(&TIMER_IPR_POS);
    eval 'sub TIMER_PRIORITY () {2;}' unless defined(&TIMER_PRIORITY);
    eval 'sub TMU1_IRQ () {17;}' unless defined(&TMU1_IRQ);
    eval 'sub TMU1_IPR_ADDR () { &INTC_IPRA;}' unless defined(&TMU1_IPR_ADDR);
    eval 'sub TMU1_IPR_POS () {2;}' unless defined(&TMU1_IPR_POS);
    eval 'sub TMU1_PRIORITY () {2;}' unless defined(&TMU1_PRIORITY);
    eval 'sub TMU2_IRQ () {18;}' unless defined(&TMU2_IRQ);
    eval 'sub TMU2_IPR_ADDR () { &INTC_IPRA;}' unless defined(&TMU2_IPR_ADDR);
    eval 'sub TMU2_IPR_POS () {1;}' unless defined(&TMU2_IPR_POS);
    eval 'sub TMU2_PRIORITY () {2;}' unless defined(&TMU2_PRIORITY);
    eval 'sub WDT_IRQ () {27;}' unless defined(&WDT_IRQ);
    eval 'sub WDT_IPR_ADDR () { &INTC_IPRB;}' unless defined(&WDT_IPR_ADDR);
    eval 'sub WDT_IPR_POS () {3;}' unless defined(&WDT_IPR_POS);
    eval 'sub WDT_PRIORITY () {2;}' unless defined(&WDT_PRIORITY);
    eval 'sub SIM_ERI_IRQ () {23;}' unless defined(&SIM_ERI_IRQ);
    eval 'sub SIM_RXI_IRQ () {24;}' unless defined(&SIM_RXI_IRQ);
    eval 'sub SIM_TXI_IRQ () {25;}' unless defined(&SIM_TXI_IRQ);
    eval 'sub SIM_TEND_IRQ () {26;}' unless defined(&SIM_TEND_IRQ);
    eval 'sub SIM_IPR_ADDR () { &INTC_IPRB;}' unless defined(&SIM_IPR_ADDR);
    eval 'sub SIM_IPR_POS () {1;}' unless defined(&SIM_IPR_POS);
    eval 'sub SIM_PRIORITY () {2;}' unless defined(&SIM_PRIORITY);
    eval 'sub VIO_IRQ () {52;}' unless defined(&VIO_IRQ);
    eval 'sub VIO_IPR_ADDR () { &INTC_IPRE;}' unless defined(&VIO_IPR_ADDR);
    eval 'sub VIO_IPR_POS () {2;}' unless defined(&VIO_IPR_POS);
    eval 'sub VIO_PRIORITY () {2;}' unless defined(&VIO_PRIORITY);
    eval 'sub MFI_IRQ () {56;}' unless defined(&MFI_IRQ);
    eval 'sub MFI_IPR_ADDR () { &INTC_IPRE;}' unless defined(&MFI_IPR_ADDR);
    eval 'sub MFI_IPR_POS () {1;}' unless defined(&MFI_IPR_POS);
    eval 'sub MFI_PRIORITY () {2;}' unless defined(&MFI_PRIORITY);
    eval 'sub VPU_IRQ () {60;}' unless defined(&VPU_IRQ);
    eval 'sub VPU_IPR_ADDR () { &INTC_IPRE;}' unless defined(&VPU_IPR_ADDR);
    eval 'sub VPU_IPR_POS () {0;}' unless defined(&VPU_IPR_POS);
    eval 'sub VPU_PRIORITY () {2;}' unless defined(&VPU_PRIORITY);
    eval 'sub KEY_IRQ () {79;}' unless defined(&KEY_IRQ);
    eval 'sub KEY_IPR_ADDR () { &INTC_IPRF;}' unless defined(&KEY_IPR_ADDR);
    eval 'sub KEY_IPR_POS () {3;}' unless defined(&KEY_IPR_POS);
    eval 'sub KEY_PRIORITY () {2;}' unless defined(&KEY_PRIORITY);
    eval 'sub CMT_IRQ () {104;}' unless defined(&CMT_IRQ);
    eval 'sub CMT_IPR_ADDR () { &INTC_IPRF;}' unless defined(&CMT_IPR_ADDR);
    eval 'sub CMT_IPR_POS () {0;}' unless defined(&CMT_IPR_POS);
    eval 'sub CMT_PRIORITY () {2;}' unless defined(&CMT_PRIORITY);
    eval 'sub DMTE0_IRQ () {48;}' unless defined(&DMTE0_IRQ);
    eval 'sub DMTE1_IRQ () {49;}' unless defined(&DMTE1_IRQ);
    eval 'sub DMTE2_IRQ () {50;}' unless defined(&DMTE2_IRQ);
    eval 'sub DMTE3_IRQ () {51;}' unless defined(&DMTE3_IRQ);
    eval 'sub DMA1_IPR_ADDR () { &INTC_IPRE;}' unless defined(&DMA1_IPR_ADDR);
    eval 'sub DMA1_IPR_POS () {3;}' unless defined(&DMA1_IPR_POS);
    eval 'sub DMA1_PRIORITY () {7;}' unless defined(&DMA1_PRIORITY);
    eval 'sub DMTE4_IRQ () {76;}' unless defined(&DMTE4_IRQ);
    eval 'sub DMTE5_IRQ () {77;}' unless defined(&DMTE5_IRQ);
    eval 'sub DMA2_IPR_ADDR () { &INTC_IPRF;}' unless defined(&DMA2_IPR_ADDR);
    eval 'sub DMA2_IPR_POS () {2;}' unless defined(&DMA2_IPR_POS);
    eval 'sub DMA2_PRIORITY () {7;}' unless defined(&DMA2_PRIORITY);
    eval 'sub SCIF0_IRQ () {80;}' unless defined(&SCIF0_IRQ);
    eval 'sub SCIF0_IPR_ADDR () { &INTC_IPRG;}' unless defined(&SCIF0_IPR_ADDR);
    eval 'sub SCIF0_IPR_POS () {3;}' unless defined(&SCIF0_IPR_POS);
    eval 'sub SCIF0_PRIORITY () {3;}' unless defined(&SCIF0_PRIORITY);
    eval 'sub SIOF0_IRQ () {55;}' unless defined(&SIOF0_IRQ);
    eval 'sub SIOF0_IPR_ADDR () { &INTC_IPRH;}' unless defined(&SIOF0_IPR_ADDR);
    eval 'sub SIOF0_IPR_POS () {3;}' unless defined(&SIOF0_IPR_POS);
    eval 'sub SIOF0_PRIORITY () {3;}' unless defined(&SIOF0_PRIORITY);
    eval 'sub FLSTE_IRQ () {92;}' unless defined(&FLSTE_IRQ);
    eval 'sub FLTEND_IRQ () {93;}' unless defined(&FLTEND_IRQ);
    eval 'sub FLTRQ0_IRQ () {94;}' unless defined(&FLTRQ0_IRQ);
    eval 'sub FLTRQ1_IRQ () {95;}' unless defined(&FLTRQ1_IRQ);
    eval 'sub FLCTL_IPR_ADDR () { &INTC_IPRH;}' unless defined(&FLCTL_IPR_ADDR);
    eval 'sub FLCTL_IPR_POS () {1;}' unless defined(&FLCTL_IPR_POS);
    eval 'sub FLCTL_PRIORITY () {3;}' unless defined(&FLCTL_PRIORITY);
    eval 'sub IIC_ALI_IRQ () {96;}' unless defined(&IIC_ALI_IRQ);
    eval 'sub IIC_TACKI_IRQ () {97;}' unless defined(&IIC_TACKI_IRQ);
    eval 'sub IIC_WAITI_IRQ () {98;}' unless defined(&IIC_WAITI_IRQ);
    eval 'sub IIC_DTEI_IRQ () {99;}' unless defined(&IIC_DTEI_IRQ);
    eval 'sub IIC_IPR_ADDR () { &INTC_IPRH;}' unless defined(&IIC_IPR_ADDR);
    eval 'sub IIC_IPR_POS () {0;}' unless defined(&IIC_IPR_POS);
    eval 'sub IIC_PRIORITY () {3;}' unless defined(&IIC_PRIORITY);
    eval 'sub SIO0_IRQ () {88;}' unless defined(&SIO0_IRQ);
    eval 'sub SIO0_IPR_ADDR () { &INTC_IPRI;}' unless defined(&SIO0_IPR_ADDR);
    eval 'sub SIO0_IPR_POS () {3;}' unless defined(&SIO0_IPR_POS);
    eval 'sub SIO0_PRIORITY () {3;}' unless defined(&SIO0_PRIORITY);
    eval 'sub SIU_IRQ () {108;}' unless defined(&SIU_IRQ);
    eval 'sub SIU_IPR_ADDR () { &INTC_IPRJ;}' unless defined(&SIU_IPR_ADDR);
    eval 'sub SIU_IPR_POS () {1;}' unless defined(&SIU_IPR_POS);
    eval 'sub SIU_PRIORITY () {3;}' unless defined(&SIU_PRIORITY);
    eval 'sub NR_IRQS () {109;}' unless defined(&NR_IRQS);
    eval 'sub ACTUAL_NR_IRQS () { &NR_IRQS;}' unless defined(&ACTUAL_NR_IRQS);
    eval 'sub PORT_PACR () {0xa4050100;}' unless defined(&PORT_PACR);
    eval 'sub PORT_PBCR () {0xa4050102;}' unless defined(&PORT_PBCR);
    eval 'sub PORT_PCCR () {0xa4050104;}' unless defined(&PORT_PCCR);
    eval 'sub PORT_PDCR () {0xa4050106;}' unless defined(&PORT_PDCR);
    eval 'sub PORT_PECR () {0xa4050108;}' unless defined(&PORT_PECR);
    eval 'sub PORT_PFCR () {0xa405010a;}' unless defined(&PORT_PFCR);
    eval 'sub PORT_PGCR () {0xa405010c;}' unless defined(&PORT_PGCR);
    eval 'sub PORT_PHCR () {0xa405010e;}' unless defined(&PORT_PHCR);
    eval 'sub PORT_PJCR () {0xa4050110;}' unless defined(&PORT_PJCR);
    eval 'sub PORT_PKCR () {0xa4050112;}' unless defined(&PORT_PKCR);
    eval 'sub PORT_PLCR () {0xa4050114;}' unless defined(&PORT_PLCR);
    eval 'sub PORT_SCPCR () {0xa4050116;}' unless defined(&PORT_SCPCR);
    eval 'sub PORT_PMCR () {0xa4050118;}' unless defined(&PORT_PMCR);
    eval 'sub PORT_PNCR () {0xa405011a;}' unless defined(&PORT_PNCR);
    eval 'sub PORT_PQCR () {0xa405011c;}' unless defined(&PORT_PQCR);
    eval 'sub PORT_PSELA () {0xa4050140;}' unless defined(&PORT_PSELA);
    eval 'sub PORT_PSELB () {0xa4050142;}' unless defined(&PORT_PSELB);
    eval 'sub PORT_PSELC () {0xa4050144;}' unless defined(&PORT_PSELC);
    eval 'sub PORT_HIZCRA () {0xa4050146;}' unless defined(&PORT_HIZCRA);
    eval 'sub PORT_HIZCRB () {0xa4050148;}' unless defined(&PORT_HIZCRB);
    eval 'sub PORT_DRVCR () {0xa4050150;}' unless defined(&PORT_DRVCR);
    eval 'sub PORT_PADR () {0xa4050120;}' unless defined(&PORT_PADR);
    eval 'sub PORT_PBDR () {0xa4050122;}' unless defined(&PORT_PBDR);
    eval 'sub PORT_PCDR () {0xa4050124;}' unless defined(&PORT_PCDR);
    eval 'sub PORT_PDDR () {0xa4050126;}' unless defined(&PORT_PDDR);
    eval 'sub PORT_PEDR () {0xa4050128;}' unless defined(&PORT_PEDR);
    eval 'sub PORT_PFDR () {0xa405012a;}' unless defined(&PORT_PFDR);
    eval 'sub PORT_PGDR () {0xa405012c;}' unless defined(&PORT_PGDR);
    eval 'sub PORT_PHDR () {0xa405012e;}' unless defined(&PORT_PHDR);
    eval 'sub PORT_PJDR () {0xa4050130;}' unless defined(&PORT_PJDR);
    eval 'sub PORT_PKDR () {0xa4050132;}' unless defined(&PORT_PKDR);
    eval 'sub PORT_PLDR () {0xa4050134;}' unless defined(&PORT_PLDR);
    eval 'sub PORT_SCPDR () {0xa4050136;}' unless defined(&PORT_SCPDR);
    eval 'sub PORT_PMDR () {0xa4050138;}' unless defined(&PORT_PMDR);
    eval 'sub PORT_PNDR () {0xa405013a;}' unless defined(&PORT_PNDR);
    eval 'sub PORT_PQDR () {0xa405013c;}' unless defined(&PORT_PQDR);
    eval 'sub IRQ0_IRQ () {32;}' unless defined(&IRQ0_IRQ);
    eval 'sub IRQ1_IRQ () {33;}' unless defined(&IRQ1_IRQ);
    eval 'sub IRQ2_IRQ () {34;}' unless defined(&IRQ2_IRQ);
    eval 'sub IRQ3_IRQ () {35;}' unless defined(&IRQ3_IRQ);
    eval 'sub IRQ4_IRQ () {36;}' unless defined(&IRQ4_IRQ);
    eval 'sub IRQ5_IRQ () {37;}' unless defined(&IRQ5_IRQ);
    eval 'sub IRQ0_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ0_IPR_ADDR);
    eval 'sub IRQ1_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ1_IPR_ADDR);
    eval 'sub IRQ2_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ2_IPR_ADDR);
    eval 'sub IRQ3_IPR_ADDR () { &INTC_IPRC;}' unless defined(&IRQ3_IPR_ADDR);
    eval 'sub IRQ4_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRQ4_IPR_ADDR);
    eval 'sub IRQ5_IPR_ADDR () { &INTC_IPRD;}' unless defined(&IRQ5_IPR_ADDR);
    eval 'sub IRQ0_IPR_POS () {0;}' unless defined(&IRQ0_IPR_POS);
    eval 'sub IRQ1_IPR_POS () {1;}' unless defined(&IRQ1_IPR_POS);
    eval 'sub IRQ2_IPR_POS () {2;}' unless defined(&IRQ2_IPR_POS);
    eval 'sub IRQ3_IPR_POS () {3;}' unless defined(&IRQ3_IPR_POS);
    eval 'sub IRQ4_IPR_POS () {0;}' unless defined(&IRQ4_IPR_POS);
    eval 'sub IRQ5_IPR_POS () {1;}' unless defined(&IRQ5_IPR_POS);
    eval 'sub IRQ0_PRIORITY () {1;}' unless defined(&IRQ0_PRIORITY);
    eval 'sub IRQ1_PRIORITY () {1;}' unless defined(&IRQ1_PRIORITY);
    eval 'sub IRQ2_PRIORITY () {1;}' unless defined(&IRQ2_PRIORITY);
    eval 'sub IRQ3_PRIORITY () {1;}' unless defined(&IRQ3_PRIORITY);
    eval 'sub IRQ4_PRIORITY () {1;}' unless defined(&IRQ4_PRIORITY);
    eval 'sub IRQ5_PRIORITY () {1;}' unless defined(&IRQ5_PRIORITY);
    eval 'sub __irq_demux {
        my($irq) = @_;
	    eval q( &ipr_irq_demux($irq));
    }' unless defined(&__irq_demux);
    eval 'sub irq_demux {
        my($irq) = @_;
	    eval q( &__irq_demux($irq));
    }' unless defined(&irq_demux);
}
1;
