require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_KEYBOARD_H)) {
    eval 'sub __ASM_SH_KEYBOARD_H () {1;}' unless defined(&__ASM_SH_KEYBOARD_H);
    require 'linux/kd.ph';
    require 'linux/config.ph';
    require 'asm/machvec.ph';
    if(defined(&CONFIG_SH_EC3104)) {
	require 'asm/keyboard-ec3104.ph';
    }
 elsif(defined( &CONFIG_SH_HS7729PCI)) {
	require 'asm/keyboard-hs7729pci.ph';
    } else {
	eval 'sub kbd_setkeycode {
	    my($scancode,$keycode) = @_;
    	    eval q({ - &EOPNOTSUPP; });
	}' unless defined(&kbd_setkeycode);
	eval 'sub kbd_getkeycode {
	    my($scancode) = @_;
    	    eval q({ $scancode > 127? - &EINVAL : $scancode; });
	}' unless defined(&kbd_getkeycode);
	if(defined(&CONFIG_SH_DREAMCAST)) {
	} else {
	    eval 'sub kbd_translate {
	        my($scancode,$keycode,$raw_mode) = @_;
    		eval q({ *$keycode = $scancode; 1; });
	    }' unless defined(&kbd_translate);
	}
	eval 'sub kbd_unexpected_up {
	    my($keycode) = @_;
    	    eval q({ 0200; });
	}' unless defined(&kbd_unexpected_up);
	eval 'sub kbd_leds {
	    my($leds) = @_;
    	    eval q({ });
	}' unless defined(&kbd_leds);
	eval 'sub kbd_init_hw {
	    my($void) = @_;
    	    eval q({  &if ( &MACH_HP600) {  &hp600_kbd_init_hw(); } });
	}' unless defined(&kbd_init_hw);
    }
}
1;
