require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_MMU_CONTEXT_H)) {
    eval 'sub __ASM_SH_MMU_CONTEXT_H () {1;}' unless defined(&__ASM_SH_MMU_CONTEXT_H);
    eval 'sub MMU_CONTEXT_ASID_MASK () {0xff;}' unless defined(&MMU_CONTEXT_ASID_MASK);
    eval 'sub MMU_CONTEXT_VERSION_MASK () {0xffffff00;}' unless defined(&MMU_CONTEXT_VERSION_MASK);
    eval 'sub MMU_CONTEXT_FIRST_VERSION () {0x100;}' unless defined(&MMU_CONTEXT_FIRST_VERSION);
    eval 'sub NO_CONTEXT () {0;}' unless defined(&NO_CONTEXT);
    eval 'sub MMU_NO_ASID () {0x100;}' unless defined(&MMU_NO_ASID);
    eval 'sub MMU_VPN_MASK () {0xfffff000;}' unless defined(&MMU_VPN_MASK);
    if(defined( &__sh3__)) {
	eval 'sub MMU_PTEH () {0xfffffff0;}' unless defined(&MMU_PTEH);
	eval 'sub MMU_PTEL () {0xfffffff4;}' unless defined(&MMU_PTEL);
	eval 'sub MMU_TTB () {0xfffffff8;}' unless defined(&MMU_TTB);
	eval 'sub MMU_TEA () {0xfffffffc;}' unless defined(&MMU_TEA);
	eval 'sub MMUCR () {0xffffffe0;}' unless defined(&MMUCR);
	eval 'sub MMU_TLB_ADDRESS_ARRAY () {0xf2000000;}' unless defined(&MMU_TLB_ADDRESS_ARRAY);
	eval 'sub MMU_PAGE_ASSOC_BIT () {0x80;}' unless defined(&MMU_PAGE_ASSOC_BIT);
	eval 'sub MMU_NTLB_ENTRIES () {128;}' unless defined(&MMU_NTLB_ENTRIES);
	eval 'sub MMU_CONTROL_INIT () {0x7;}' unless defined(&MMU_CONTROL_INIT);
    }
 elsif(defined( &__SH4__)) {
	eval 'sub MMU_PTEH () {0xff000000;}' unless defined(&MMU_PTEH);
	eval 'sub MMU_PTEL () {0xff000004;}' unless defined(&MMU_PTEL);
	eval 'sub MMU_TTB () {0xff000008;}' unless defined(&MMU_TTB);
	eval 'sub MMU_TEA () {0xff00000c;}' unless defined(&MMU_TEA);
	eval 'sub MMU_PTEA () {0xff000034;}' unless defined(&MMU_PTEA);
	eval 'sub MMUCR () {0xff000010;}' unless defined(&MMUCR);
	eval 'sub MMU_ITLB_ADDRESS_ARRAY () {0xf2000000;}' unless defined(&MMU_ITLB_ADDRESS_ARRAY);
	eval 'sub MMU_UTLB_ADDRESS_ARRAY () {0xf6000000;}' unless defined(&MMU_UTLB_ADDRESS_ARRAY);
	eval 'sub MMU_PAGE_ASSOC_BIT () {0x80;}' unless defined(&MMU_PAGE_ASSOC_BIT);
	eval 'sub MMU_NTLB_ENTRIES () {64;}' unless defined(&MMU_NTLB_ENTRIES);
	eval 'sub MMU_CONTROL_INIT () {0x205;}' unless defined(&MMU_CONTROL_INIT);
	eval 'sub MMU_ITLB_DATA_ARRAY () {0xf3000000;}' unless defined(&MMU_ITLB_DATA_ARRAY);
	eval 'sub MMU_UTLB_DATA_ARRAY () {0xf7000000;}' unless defined(&MMU_UTLB_DATA_ARRAY);
	eval 'sub MMU_UTLB_ENTRIES () {64;}' unless defined(&MMU_UTLB_ENTRIES);
	eval 'sub MMU_U_ENTRY_SHIFT () {8;}' unless defined(&MMU_U_ENTRY_SHIFT);
	eval 'sub MMU_UTLB_VALID () {0x100;}' unless defined(&MMU_UTLB_VALID);
	eval 'sub MMU_ITLB_ENTRIES () {4;}' unless defined(&MMU_ITLB_ENTRIES);
	eval 'sub MMU_I_ENTRY_SHIFT () {8;}' unless defined(&MMU_I_ENTRY_SHIFT);
	eval 'sub MMU_ITLB_VALID () {0x100;}' unless defined(&MMU_ITLB_VALID);
    }
    eval 'sub set_asid {
        my($asid) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&set_asid);
    eval 'sub get_asid {
        my($void) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&get_asid);
    eval 'sub activate_mm {
        my($prev, $next) = @_;
	    eval q( &switch_mm(($prev),($next), &NULL, &smp_processor_id()));
    }' unless defined(&activate_mm);
    eval 'sub enter_lazy_tlb {
        my($mm,$tsk,$cpu) = @_;
	    eval q({ });
    }' unless defined(&enter_lazy_tlb);
}
1;
