require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_MMZONE_H)) {
    eval 'sub __ASM_SH_MMZONE_H () {1;}' unless defined(&__ASM_SH_MMZONE_H);
    require 'linux/config.ph';
    eval 'sub PHYSADDR_TO_NID {
        my($phys) = @_;
	    eval q((((($phys) -  &__MEMORY_START) >= 0x1000000)?1:0));
    }' unless defined(&PHYSADDR_TO_NID);
    eval 'sub NR_NODES () {2;}' unless defined(&NR_NODES);
    if(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub KVADDR_TO_NID {
	    my($kaddr) = @_;
    	    eval q( &PHYSADDR_TO_NID( &__pa($kaddr)));
	}' unless defined(&KVADDR_TO_NID);
	eval 'sub NODE_DATA {
	    my($nid) = @_;
    	    eval q(( $discontig_page_data[$nid]));
	}' unless defined(&NODE_DATA);
	eval 'sub NODE_MEM_MAP {
	    my($nid) = @_;
    	    eval q(( &NODE_DATA($nid)-> &node_mem_map));
	}' unless defined(&NODE_MEM_MAP);
	eval 'sub phys_to_page {
	    my($phys) = @_;
    	    eval q(({ \'unsigned int node\' =  &PHYSADDR_TO_NID($phys);  &NODE_MEM_MAP( &node) + ((($phys) -  &NODE_DATA( &node)-> &node_start_paddr) >>  &PAGE_SHIFT); }));
	}' unless defined(&phys_to_page);
	eval 'sub is_valid_page {
	    my($page) = @_;
    	    eval q({ my $i;  &for ( $i = 0;  $i <  &NR_NODES;  $i++) {  &if ($page >=  &NODE_MEM_MAP( $i)  && $page <  &NODE_MEM_MAP( $i) +  &NODE_DATA( $i)-> &node_size) 1; } 0; });
	}' unless defined(&is_valid_page);
	eval 'sub VALID_PAGE {
	    my($page) = @_;
    	    eval q( &is_valid_page($page));
	}' unless defined(&VALID_PAGE);
	eval 'sub page_to_phys {
	    my($page) = @_;
    	    eval q( &PHYSADDR( &page_address($page)));
	}' unless defined(&page_to_phys);
    }
}
1;
