require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PGTABLE_2LEVEL_H)) {
    eval 'sub __ASM_SH_PGTABLE_2LEVEL_H () {1;}' unless defined(&__ASM_SH_PGTABLE_2LEVEL_H);
    eval 'sub PGDIR_SHIFT () {22;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PTRS_PER_PGD () {1024;}' unless defined(&PTRS_PER_PGD);
    eval 'sub PMD_SHIFT () {22;}' unless defined(&PMD_SHIFT);
    eval 'sub PTRS_PER_PMD () {1;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PTE () {1024;}' unless defined(&PTRS_PER_PTE);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub pte_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pte %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pte_val($e)));
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pmd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pmd_val($e)));
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pgd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pgd_val($e)));
	}' unless defined(&pgd_ERROR);
	eval 'sub set_pte {
	    my($pteptr, $pteval) = @_;
    	    eval q((*($pteptr) = $pteval));
	}' unless defined(&set_pte);
	eval 'sub set_pmd {
	    my($pmdptr, $pmdval) = @_;
    	    eval q((*($pmdptr) = $pmdval));
	}' unless defined(&set_pmd);
	eval 'sub set_pgd {
	    my($pgdptr, $pgdval) = @_;
    	    eval q((*($pgdptr) = $pgdval));
	}' unless defined(&set_pgd);
	eval 'sub pgd_page {
	    my($pgd) = @_;
    	    eval q((  &__va( &pgd_val($pgd) &  &PAGE_MASK)));
	}' unless defined(&pgd_page);
	eval 'sub pmd_offset {
	    my($dir,$address) = @_;
    	    eval q({ ( &pmd_t *) $dir; });
	}' unless defined(&pmd_offset);
    }
}
1;
