require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_RTC_H)) {
    eval 'sub _ASM_RTC_H () {1;}' unless defined(&_ASM_RTC_H);
    require 'asm/machvec.ph';
    eval 'sub rtc_gettimeofday () { ($sh_mv->{mv_rtc_gettimeofday});}' unless defined(&rtc_gettimeofday);
    eval 'sub rtc_settimeofday () { ($sh_mv->{mv_rtc_settimeofday});}' unless defined(&rtc_settimeofday);
    eval 'sub RCR1_CF () {0x80;}' unless defined(&RCR1_CF);
    eval 'sub RCR1_CIE () {0x10;}' unless defined(&RCR1_CIE);
    eval 'sub RCR1_AIE () {0x8;}' unless defined(&RCR1_AIE);
    eval 'sub RCR1_AF () {0x1;}' unless defined(&RCR1_AF);
    eval 'sub RCR2_PEF () {0x80;}' unless defined(&RCR2_PEF);
    eval 'sub RCR2_PESMASK () {0x70;}' unless defined(&RCR2_PESMASK);
    eval 'sub RCR2_RTCEN () {0x8;}' unless defined(&RCR2_RTCEN);
    eval 'sub RCR2_ADJ () {0x4;}' unless defined(&RCR2_ADJ);
    eval 'sub RCR2_RESET () {0x2;}' unless defined(&RCR2_RESET);
    eval 'sub RCR2_START () {0x1;}' unless defined(&RCR2_START);
    if(defined( &__sh3__)) {
	eval 'sub R64CNT () {0xfffffec0;}' unless defined(&R64CNT);
	eval 'sub RSECCNT () {0xfffffec2;}' unless defined(&RSECCNT);
	eval 'sub RMINCNT () {0xfffffec4;}' unless defined(&RMINCNT);
	eval 'sub RHRCNT () {0xfffffec6;}' unless defined(&RHRCNT);
	eval 'sub RWKCNT () {0xfffffec8;}' unless defined(&RWKCNT);
	eval 'sub RDAYCNT () {0xfffffeca;}' unless defined(&RDAYCNT);
	eval 'sub RMONCNT () {0xfffffecc;}' unless defined(&RMONCNT);
	eval 'sub RYRCNT () {0xfffffece;}' unless defined(&RYRCNT);
	eval 'sub RSECAR () {0xfffffed0;}' unless defined(&RSECAR);
	eval 'sub RMINAR () {0xfffffed2;}' unless defined(&RMINAR);
	eval 'sub RHRAR () {0xfffffed4;}' unless defined(&RHRAR);
	eval 'sub RWKAR () {0xfffffed6;}' unless defined(&RWKAR);
	eval 'sub RDAYAR () {0xfffffed8;}' unless defined(&RDAYAR);
	eval 'sub RMONAR () {0xfffffeda;}' unless defined(&RMONAR);
	eval 'sub RCR1 () {0xfffffedc;}' unless defined(&RCR1);
	eval 'sub RCR2 () {0xfffffede;}' unless defined(&RCR2);
	eval 'sub RTC_BIT_INVERTED () {0;}' unless defined(&RTC_BIT_INVERTED);
    }
 elsif(defined( &__SH4__)) {
	eval 'sub R64CNT () {0xffc80000;}' unless defined(&R64CNT);
	eval 'sub RSECCNT () {0xffc80004;}' unless defined(&RSECCNT);
	eval 'sub RMINCNT () {0xffc80008;}' unless defined(&RMINCNT);
	eval 'sub RHRCNT () {0xffc8000c;}' unless defined(&RHRCNT);
	eval 'sub RWKCNT () {0xffc80010;}' unless defined(&RWKCNT);
	eval 'sub RDAYCNT () {0xffc80014;}' unless defined(&RDAYCNT);
	eval 'sub RMONCNT () {0xffc80018;}' unless defined(&RMONCNT);
	eval 'sub RYRCNT () {0xffc8001c;}' unless defined(&RYRCNT);
	eval 'sub RSECAR () {0xffc80020;}' unless defined(&RSECAR);
	eval 'sub RMINAR () {0xffc80024;}' unless defined(&RMINAR);
	eval 'sub RHRAR () {0xffc80028;}' unless defined(&RHRAR);
	eval 'sub RWKAR () {0xffc8002c;}' unless defined(&RWKAR);
	eval 'sub RDAYAR () {0xffc80030;}' unless defined(&RDAYAR);
	eval 'sub RMONAR () {0xffc80034;}' unless defined(&RMONAR);
	eval 'sub RCR1 () {0xffc80038;}' unless defined(&RCR1);
	eval 'sub RCR2 () {0xffc8003c;}' unless defined(&RCR2);
	eval 'sub RTC_BIT_INVERTED () {0x40;}' unless defined(&RTC_BIT_INVERTED);
    }
}
1;
