require '_h2ph_pre.ph';

no warnings 'redefine';

require 'asm/ec3104.ph';
unless(defined(&BASE_BAUD)) {
    sub BASE_BAUD () {	(16800000/ 16);}
}
unless(defined(&RS_TABLE_SIZE)) {
    sub RS_TABLE_SIZE () {	3;}
}
unless(defined(&STD_COM_FLAGS)) {
    sub STD_COM_FLAGS () {	( &ASYNC_BOOT_AUTOCONF |  &ASYNC_SKIP_TEST);}
}
unless(defined(&STD_SERIAL_PORT_DEFNS)) {
    sub STD_SERIAL_PORT_DEFNS () {	{ 0,  &BASE_BAUD, 0x11c00,  &EC3104_IRQBASE+7,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x12000,  &EC3104_IRQBASE+8,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x12400,  &EC3104_IRQBASE+9,  &STD_COM_FLAGS },;}
}
unless(defined(&SERIAL_PORT_DFNS)) {
    sub SERIAL_PORT_DFNS () {	 &STD_SERIAL_PORT_DEFNS;}
}
unless(defined(&irq_cannonicalize)) {
    sub irq_cannonicalize {
	my($x) = @_;
	eval q(($x));
    }
}
1;
