require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SERIAL_H)) {
    eval 'sub _ASM_SERIAL_H () {1;}' unless defined(&_ASM_SERIAL_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    if(defined(&CONFIG_SH_EC3104)) {
	require 'asm/serial-ec3104.ph';
    }
 elsif(defined ( &CONFIG_SH_BIGSUR)) {
	require 'asm/serial-bigsur.ph';
    } else {
	eval 'sub BASE_BAUD () {( 1843200/ 16);}' unless defined(&BASE_BAUD);
	eval 'sub STD_COM_FLAGS () {( &ASYNC_BOOT_AUTOCONF |  &ASYNC_SKIP_TEST);}' unless defined(&STD_COM_FLAGS);
	if(defined(&CONFIG_HD64465)) {
	    require 'asm/hd64465.ph';
	    eval 'sub RS_TABLE_SIZE () {1;}' unless defined(&RS_TABLE_SIZE);
	    eval 'sub STD_SERIAL_PORT_DEFNS () {{ 0,  &BASE_BAUD, 0x3f8,  &HD64465_IRQ_UART,  &STD_COM_FLAGS };}' unless defined(&STD_SERIAL_PORT_DEFNS);
	} else {
	    eval 'sub RS_TABLE_SIZE () {2;}' unless defined(&RS_TABLE_SIZE);
	    eval 'sub STD_SERIAL_PORT_DEFNS () {{ 0,  &BASE_BAUD, 0x3f8, 4,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x2f8, 3,  &STD_COM_FLAGS };}' unless defined(&STD_SERIAL_PORT_DEFNS);
	}
	eval 'sub SERIAL_PORT_DFNS () { &STD_SERIAL_PORT_DEFNS;}' unless defined(&SERIAL_PORT_DFNS);
	eval 'sub irq_cannonicalize {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&irq_cannonicalize);
    }
}
1;
