require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_UBC_H)) {
    eval 'sub __ASM_SH_UBC_H () {1;}' unless defined(&__ASM_SH_UBC_H);
    if(defined( &CONFIG_CPU_SUBTYPE_SH7709)) {
	eval 'sub UBC_TYPE_SH7729 () {( ($cpu_data->{type}) ==  &CPU_SH7729);}' unless defined(&UBC_TYPE_SH7729);
    } else {
	eval 'sub UBC_TYPE_SH7729 () {0;}' unless defined(&UBC_TYPE_SH7729);
    }
    if(defined( &__sh3__)) {
	eval 'sub UBC_BARA () {0xffffffb0;}' unless defined(&UBC_BARA);
	eval 'sub UBC_BAMRA () {0xffffffb4;}' unless defined(&UBC_BAMRA);
	eval 'sub UBC_BBRA () {0xffffffb8;}' unless defined(&UBC_BBRA);
	eval 'sub UBC_BASRA () {0xffffffe4;}' unless defined(&UBC_BASRA);
	eval 'sub UBC_BARB () {0xffffffa0;}' unless defined(&UBC_BARB);
	eval 'sub UBC_BAMRB () {0xffffffa4;}' unless defined(&UBC_BAMRB);
	eval 'sub UBC_BBRB () {0xffffffa8;}' unless defined(&UBC_BBRB);
	eval 'sub UBC_BASRB () {0xffffffe8;}' unless defined(&UBC_BASRB);
	eval 'sub UBC_BDRB () {0xffffff90;}' unless defined(&UBC_BDRB);
	eval 'sub UBC_BDMRB () {0xffffff94;}' unless defined(&UBC_BDMRB);
	eval 'sub UBC_BRCR () {0xffffff98;}' unless defined(&UBC_BRCR);
    }
 elsif(defined( &__SH4__)) {
	eval 'sub UBC_BARA () {0xff200000;}' unless defined(&UBC_BARA);
	eval 'sub UBC_BAMRA () {0xff200004;}' unless defined(&UBC_BAMRA);
	eval 'sub UBC_BBRA () {0xff200008;}' unless defined(&UBC_BBRA);
	eval 'sub UBC_BASRA () {0xff000014;}' unless defined(&UBC_BASRA);
	eval 'sub UBC_BARB () {0xff20000c;}' unless defined(&UBC_BARB);
	eval 'sub UBC_BAMRB () {0xff200010;}' unless defined(&UBC_BAMRB);
	eval 'sub UBC_BBRB () {0xff200014;}' unless defined(&UBC_BBRB);
	eval 'sub UBC_BASRB () {0xff000018;}' unless defined(&UBC_BASRB);
	eval 'sub UBC_BDRB () {0xff200018;}' unless defined(&UBC_BDRB);
	eval 'sub UBC_BDMRB () {0xff20001c;}' unless defined(&UBC_BDMRB);
	eval 'sub UBC_BRCR () {0xff200020;}' unless defined(&UBC_BRCR);
    }
    eval 'sub BAMR_ASID () {(1<< 2);}' unless defined(&BAMR_ASID);
    eval 'sub BAMR_NONE () {0;}' unless defined(&BAMR_NONE);
    eval 'sub BAMR_10 () {0x1;}' unless defined(&BAMR_10);
    eval 'sub BAMR_12 () {0x2;}' unless defined(&BAMR_12);
    eval 'sub BAMR_ALL () {0x3;}' unless defined(&BAMR_ALL);
    eval 'sub BAMR_16 () {0x8;}' unless defined(&BAMR_16);
    eval 'sub BAMR_20 () {0x9;}' unless defined(&BAMR_20);
    eval 'sub BBR_INST () {(1<< 4);}' unless defined(&BBR_INST);
    eval 'sub BBR_DATA () {(2<< 4);}' unless defined(&BBR_DATA);
    eval 'sub BBR_READ () {(1<< 2);}' unless defined(&BBR_READ);
    eval 'sub BBR_WRITE () {(2<< 2);}' unless defined(&BBR_WRITE);
    eval 'sub BBR_BYTE () {0x1;}' unless defined(&BBR_BYTE);
    eval 'sub BBR_HALF () {0x2;}' unless defined(&BBR_HALF);
    eval 'sub BBR_LONG () {0x3;}' unless defined(&BBR_LONG);
    eval 'sub BBR_QUAD () {(1<< 6);}' unless defined(&BBR_QUAD);
    eval 'sub BBR_CPU () {(1<< 6);}' unless defined(&BBR_CPU);
    eval 'sub BBR_DMA () {(2<< 6);}' unless defined(&BBR_DMA);
    eval 'sub BRCR_CMFA () {(1<< 15);}' unless defined(&BRCR_CMFA);
    eval 'sub BRCR_CMFB () {(1<< 14);}' unless defined(&BRCR_CMFB);
    eval 'sub BRCR_PCTE () {(1<< 11);}' unless defined(&BRCR_PCTE);
    eval 'sub BRCR_PCBA () {(1<< 10);}' unless defined(&BRCR_PCBA);
    eval 'sub BRCR_DBEB () {(1<< 7);}' unless defined(&BRCR_DBEB);
    eval 'sub BRCR_PCBB () {(1<< 6);}' unless defined(&BRCR_PCBB);
    eval 'sub BRCR_SEQ () {(1<< 3);}' unless defined(&BRCR_SEQ);
    eval 'sub BRCR_UBDE () {(1<< 0);}' unless defined(&BRCR_UBDE);
    unless(defined(&__ASSEMBLY__)) {
    }
}
1;
