require '_h2ph_pre.ph';

no warnings 'redefine';

require 'stdint.ph';
unless(defined(&__arch_compare_and_exchange_val_8_acq)) {
    sub __arch_compare_and_exchange_val_8_acq {
	my($mem, $newval, $oldval) = @_;
	eval q(({  &__typeof (*($mem))  &__result;  &__asm  &__volatile (\"	.align 2\\n	mova 1f,r0\\n	nop\\n	mov r15,r1\\n	mov #-8,r15\\n     0: mov.b @%1,%0\\n	cmp/eq %0,%3\\n	bf 1f\\n	mov.b %2,@%1\\n     1: mov r1,r15\" : \"=&r\" ( &__result) : \"r\" ($mem), \"r\" ($newval), \"r\" ($oldval) : \"r0\", \"r1\", \"t\", \"memory\");  &__result; }));
    }
}
unless(defined(&__arch_compare_and_exchange_val_16_acq)) {
    sub __arch_compare_and_exchange_val_16_acq {
	my($mem, $newval, $oldval) = @_;
	eval q(({  &__typeof (*($mem))  &__result;  &__asm  &__volatile (\"	.align 2\\n	mova 1f,r0\\n	nop\\n	mov r15,r1\\n	mov #-8,r15\\n     0: mov.w @%1,%0\\n	cmp/eq %0,%3\\n	bf 1f\\n	mov.w %2,@%1\\n     1: mov r1,r15\" : \"=&r\" ( &__result) : \"r\" ($mem), \"r\" ($newval), \"r\" ($oldval) : \"r0\", \"r1\", \"t\", \"memory\");  &__result; }));
    }
}
unless(defined(&__arch_compare_and_exchange_val_32_acq)) {
    sub __arch_compare_and_exchange_val_32_acq {
	my($mem, $newval, $oldval) = @_;
	eval q(({  &__typeof (*($mem))  &__result;  &__asm  &__volatile (\"	.align 2\\n	mova 1f,r0\\n	nop\\n	mov r15,r1\\n	mov #-8,r15\\n     0: mov.l @%1,%0\\n	cmp/eq %0,%3\\n	bf 1f\\n	mov.l %2,@%1\\n     1: mov r1,r15\" : \"=&r\" ( &__result) : \"r\" ($mem), \"r\" ($newval), \"r\" ($oldval) : \"r0\", \"r1\", \"t\", \"memory\");  &__result; }));
    }
}
unless(defined(&__arch_compare_and_exchange_val_64_acq)) {
    sub __arch_compare_and_exchange_val_64_acq {
	my($mem, $newval, $oldval) = @_;
	eval q(( &abort (), ( &__typeof (*$mem)) 0));
    }
}
unless(defined(&atomic_exchange_and_add)) {
    sub atomic_exchange_and_add {
	my($mem, $value) = @_;
	eval q(({  &__typeof (*($mem))  &__result,  &__tmp,  &__value = ($value);  &if ($sizeof{($mem)} == 1)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.b @%2,%0\\n	  add %0,%1\\n	  mov.b %1,@%2\\n       1: mov r1,r15\" : \"=&r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"memory\");  &else  &if ($sizeof{($mem)} == 2)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.w @%2,%0\\n	  add %0,%1\\n	  mov.w %1,@%2\\n       1: mov r1,r15\" : \"=&r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"memory\");  &else  &if ($sizeof{($mem)} == 4)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.l @%2,%0\\n	  add %0,%1\\n	  mov.l %1,@%2\\n       1: mov r1,r15\" : \"=&r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"memory\");  &else {  &__typeof ($mem)  &memp = ($mem);  &do  &__result = * &memp;  &while ( &__arch_compare_and_exchange_val_64_acq ( &memp,  &__result +  &__value,  &__result) ==  &__result); ( &void)  &__value; }  &__result; }));
    }
}
unless(defined(&atomic_add)) {
    sub atomic_add {
	my($mem, $value) = @_;
	eval q(( &void) ({  &__typeof (*($mem))  &__tmp,  &__value = ($value);  &if ($sizeof{($mem)} == 1)  &__asm  &__volatile (\"		.align 2\\n		mova 1f,r0\\n		mov r15,r1\\n		mov #-6,r15\\n	     0: mov.b @%1,r2\\n		add r2,%0\\n		mov.b %0,@%1\\n	     1: mov r1,r15\" : \"=&r\" ( &__tmp) : \"r\" ($mem), \"0\" ( &__value) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &if ($sizeof{($mem)} == 2)  &__asm  &__volatile (\"		.align 2\\n		mova 1f,r0\\n		mov r15,r1\\n		mov #-6,r15\\n	     0: mov.w @%1,r2\\n		add r2,%0\\n		mov.w %0,@%1\\n	     1: mov r1,r15\" : \"=&r\" ( &__tmp) : \"r\" ($mem), \"0\" ( &__value) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &if ($sizeof{($mem)} == 4)  &__asm  &__volatile (\"		.align 2\\n		mova 1f,r0\\n		mov r15,r1\\n		mov #-6,r15\\n	     0: mov.l @%1,r2\\n		add r2,%0\\n		mov.l %0,@%1\\n	     1: mov r1,r15\" : \"=&r\" ( &__tmp) : \"r\" ($mem), \"0\" ( &__value) : \"r0\", \"r1\", \"r2\", \"memory\");  &else {  &__typeof (*($mem))  &oldval;  &__typeof ($mem)  &memp = ($mem);  &do  &oldval = * &memp;  &while ( &__arch_compare_and_exchange_val_64_acq ( &memp,  &oldval +  &__value,  &oldval) ==  &oldval); ( &void)  &__value; } }));
    }
}
unless(defined(&atomic_add_negative)) {
    sub atomic_add_negative {
	my($mem, $value) = @_;
	eval q(({ 'unsigned char __result';  &__typeof (*($mem))  &__tmp,  &__value = ($value);  &if ($sizeof{($mem)} == 1)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.b @%2,r2\\n	  add r2,%1\\n	  mov.b %1,@%2\\n       1: mov r1,r15\\n	  shal %1\\n	  movt %0\" : \"=r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"r2\", \"t\", \"memory\");  &else  &if ($sizeof{($mem)} == 2)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.w @%2,r2\\n	  add r2,%1\\n	  mov.w %1,@%2\\n       1: mov r1,r15\\n	  shal %1\\n	  movt %0\" : \"=r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"r2\", \"t\", \"memory\");  &else  &if ($sizeof{($mem)} == 4)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.l @%2,r2\\n	  add r2,%1\\n	  mov.l %1,@%2\\n       1: mov r1,r15\\n	  shal %1\\n	  movt %0\" : \"=r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"r2\", \"t\", \"memory\");  &else  &abort ();  &__result; }));
    }
}
unless(defined(&atomic_add_zero)) {
    sub atomic_add_zero {
	my($mem, $value) = @_;
	eval q(({ 'unsigned char __result';  &__typeof (*($mem))  &__tmp,  &__value = ($value);  &if ($sizeof{($mem)} == 1)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.b @%2,r2\\n	  add r2,%1\\n	  mov.b %1,@%2\\n       1: mov r1,r15\\n	  tst %1,%1\\n	  movt %0\" : \"=r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"r2\", \"t\", \"memory\");  &else  &if ($sizeof{($mem)} == 2)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.w @%2,r2\\n	  add r2,%1\\n	  mov.w %1,@%2\\n       1: mov r1,r15\\n	  tst %1,%1\\n	  movt %0\" : \"=r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"r2\", \"t\", \"memory\");  &else  &if ($sizeof{($mem)} == 4)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  mov r15,r1\\n	  mov #-6,r15\\n       0: mov.l @%2,r2\\n	  add r2,%1\\n	  mov.l %1,@%2\\n       1: mov r1,r15\\n	  tst %1,%1\\n	  movt %0\" : \"=r\" ( &__result), \"=&r\" ( &__tmp) : \"r\" ($mem), \"1\" ( &__value) : \"r0\", \"r1\", \"r2\", \"t\", \"memory\");  &else  &abort ();  &__result; }));
    }
}
unless(defined(&atomic_increment_and_test)) {
    sub atomic_increment_and_test {
	my($mem) = @_;
	eval q( &atomic_add_zero(($mem), 1));
    }
}
unless(defined(&atomic_decrement_and_test)) {
    sub atomic_decrement_and_test {
	my($mem) = @_;
	eval q( &atomic_add_zero(($mem), -1));
    }
}
unless(defined(&atomic_bit_set)) {
    sub atomic_bit_set {
	my($mem, $bit) = @_;
	eval q(( &void) ({ 'unsigned int __mask' = 1<< ($bit);  &if ($sizeof{($mem)} == 1)  &__asm  &__volatile (\"		.align 2\\n		mova 1f,r0\\n		mov r15,r1\\n		mov #-6,r15\\n	     0: mov.b @%0,r2\\n		or %1,r2\\n		mov.b r2,@%0\\n	     1: mov r1,r15\" : : \"r\" ($mem), \"r\" ( &__mask) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &if ($sizeof{($mem)} == 2)  &__asm  &__volatile (\"		.align 2\\n		mova 1f,r0\\n		mov r15,r1\\n		mov #-6,r15\\n	     0: mov.w @%0,r2\\n		or %1,r2\\n		mov.w r2,@%0\\n	     1: mov r1,r15\" : : \"r\" ($mem), \"r\" ( &__mask) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &if ($sizeof{($mem)} == 4)  &__asm  &__volatile (\"		.align 2\\n		mova 1f,r0\\n		mov r15,r1\\n		mov #-6,r15\\n	     0: mov.l @%0,r2\\n		or %1,r2\\n		mov.l r2,@%0\\n	     1: mov r1,r15\" : : \"r\" ($mem), \"r\" ( &__mask) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &abort (); }));
    }
}
unless(defined(&atomic_bit_test_set)) {
    sub atomic_bit_test_set {
	my($mem, $bit) = @_;
	eval q(({ 'unsigned int __mask' = 1<< ($bit); 'unsigned int __result' =  &__mask;  &if ($sizeof{($mem)} == 1)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  nop\\n	  mov r15,r1\\n	  mov #-8,r15\\n       0: mov.b @%2,r2\\n	  or r2,%1\\n	  and r2,%0\\n	  mov.b %1,@%2\\n       1: mov r1,r15\" : \"=&r\" ( &__result), \"=&r\" ( &__mask) : \"r\" ($mem), \"0\" ( &__result), \"1\" ( &__mask) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &if ($sizeof{($mem)} == 2)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  nop\\n	  mov r15,r1\\n	  mov #-8,r15\\n       0: mov.w @%2,r2\\n	  or r2,%1\\n	  and r2,%0\\n	  mov.w %1,@%2\\n       1: mov r1,r15\" : \"=&r\" ( &__result), \"=&r\" ( &__mask) : \"r\" ($mem), \"0\" ( &__result), \"1\" ( &__mask) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &if ($sizeof{($mem)} == 4)  &__asm  &__volatile (\"	  .align 2\\n	  mova 1f,r0\\n	  nop\\n	  mov r15,r1\\n	  mov #-8,r15\\n       0: mov.l @%2,r2\\n	  or r2,%1\\n	  and r2,%0\\n	  mov.l %1,@%2\\n       1: mov r1,r15\" : \"=&r\" ( &__result), \"=&r\" ( &__mask) : \"r\" ($mem), \"0\" ( &__result), \"1\" ( &__mask) : \"r0\", \"r1\", \"r2\", \"memory\");  &else  &abort ();  &__result; }));
    }
}
1;
