require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BITS_SYSCALLS_H)) {
    eval 'sub _BITS_SYSCALLS_H () {1;}' unless defined(&_BITS_SYSCALLS_H);
    unless(defined(&_SYSCALL_H)) {
	die("Never use <bits/syscalls.h> directly; include <sys/syscall.h> instead.");
    }
    require 'bits/sysnum.ph';
    unless(defined(&__set_errno)) {
	eval 'sub __set_errno {
	    my($val) = @_;
    	    eval q((* &__errno_location ()) = ($val));
	}' unless defined(&__set_errno);
    }
    unless(defined(&SYS_ify)) {
	eval 'sub SYS_ify {
	    my($syscall_name) = @_;
    	    eval q(( &__NR_$syscall_name));
	}' unless defined(&SYS_ify);
    }
    unless(defined(&__ASSEMBLER__)) {
	eval 'sub __syscall_return {
	    my($type, $res) = @_;
    	    eval q( &do {  &if ( >= (-125)) { \'int\'  &__err = -($res);  &__set_errno( &__err); $res = -1; }  &return ($type) ($res); }  &while (0));
	}' unless defined(&__syscall_return);
	eval 'sub _syscall0 {
	    my($type,$name) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall0);
	eval 'sub _syscall1 {
	    my($type,$name,$type1,$arg1) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall1);
	eval 'sub _syscall2 {
	    my($type,$name,$type1,$arg1,$type2,$arg2) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall2);
	eval 'sub _syscall3 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall3);
	eval 'sub _syscall4 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall4);
	eval 'sub _syscall5 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4,$type5,$arg5) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall5);
	unless(defined(&__SH_SYSCALL6_TRAPA)) {
	    eval 'sub __SH_SYSCALL6_TRAPA () {"0x16";}' unless defined(&__SH_SYSCALL6_TRAPA);
	}
	eval 'sub _syscall6 {
	    my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4,$type5,$arg5,$type6,$arg6) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_syscall6);
    }
}
1;
